/*
================================ COPYRIGHT ================================
The contents of this file are subject to the VTech Informations Ltd. License
of VT-OS Ver. 1.1 operating system (the "License"); you may not use this 
file except in compliance with the License.  
 
Software distributed under the License is distributed on an "AS IS" basis, 
WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
for the specific language governing rights and limitations under the License.
 
The Original Code is VT-OS Ver. 1.1 Operating System, released 
on October 1st, 1999

The Initial Developer of the Original Code is VTech Informations Ltd.  All 
codes are Copyright (C) VTech Informations Ltd. 1999.  All Rights Reserved.
===========================================================================
*/

/*
===========================================================================
File        :   expmain.c
Author(s)   :   Jason Ngan
Company     :   VTech Informations Ltd.
Project     :   Helio 
Date:	    :   October 1st, 1999
Purpose:	:   application c file
Revision    :   1.1
Note        :   None
===========================================================================
*/         


#include "stdafx.h"
#include "platform.h"
#include "include\expdef.h"
#include "include\expense.h"
#include "include\sysetup.h"
#include "include\system.h"
#include "include\atod.h"

#ifdef PC_SIM
#include "resource.h"
#include "pdaemu.h"
#include "PdaEmuDlg.h"
extern CPDAEmuDlg* m_EmuDlg;
#endif

//#define DEBUG
/*****************************************************************
********************** Global Variables **************************
*****************************************************************/
BYTE			OldCatText[20], CatText[20], *CatNameInEdCat, LargeFontInEdcat;
SHORT			CatHighlightInList;
USHORT			prev_row_num, prev_col_num, NewItemNumInList, DelItemNum;
BOOLEAN			dialogX_selected, RenameCat;
ObjectID		ActiveTextboxID;
ObjectID		G_active_form_id;

extern BYTE		ListHighlightStatus;
extern SHORT	HighlightRecNumInList;
extern WORD		RecIDInList[11];
extern RecordID		NewExpense_rec_id, UnDelete_rec_id, Highlighted_rec_id;

/*****************************************************************
 * Function:	ExpenseInitMainGlobal
 * Purpose: 	This function is used to initialize the global variables
				and being called at start up
 * Scope:		application/internal
 * Input:		None
 * Output:		None
 * Return:		None
 * Comment: 	None
******************************************************************/
void ExpenseInitMainGlobal(BOOLEAN is_restart)
{
	BYTE	*buffer;
	SHORT	item_num;
	UWORD	byte_read;
	DatabaseID	Expense_dbid;


	DataFindDB((BYTE*)"ExpenseDatabase", &Expense_dbid);
	
	if (is_restart)
	{
		prev_row_num = 0;
		prev_col_num = 0;
		NewItemNumInList = EXPENSE_INVALID_REC_NUM;
		RenameCat = FALSE;
		CatText[0] = 0;
		CatHighlightInList = -1;
		DelItemNum = EXPENSE_INVALID_REC_NUM;
		dialogX_selected = FALSE;
		LargeFontInEdcat = 0;
		item_num = 0;
		DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_PopupItemNum, sizeof(SHORT), (BYTE*)&item_num);
		DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_LargeFontInEdcat, sizeof(BYTE), (BYTE*)&LargeFontInEdcat);

		ExpenseCatToList(CatText, TRUE);
	}
	else
	{

		DataGetField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_CatText, &buffer, &byte_read);
		strcpy(CatText, buffer);
		qfree(buffer);
		DataGetField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_prev_row_num, &buffer, &byte_read);
		prev_row_num = *(USHORT*)buffer;
		qfree(buffer);
		DataGetField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_prev_col_num, &buffer, &byte_read);
		prev_col_num = *(USHORT*)buffer;
		qfree(buffer);
		DataGetField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_NewItemNumInList, &buffer, &byte_read);
		NewItemNumInList = *(USHORT*)buffer;
		qfree(buffer);
		DataGetField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_DelItemNum, &buffer, &byte_read);
		DelItemNum = *(USHORT*)buffer;
		qfree(buffer);
		DataGetField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_dialogX_selected, &buffer, &byte_read);
		dialogX_selected = *(BOOLEAN*)buffer;
		qfree(buffer);
		DataGetField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_RenameCat, &buffer, &byte_read);
		RenameCat = *(BOOLEAN*)buffer;
		qfree(buffer);
		DataGetField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_ActiveTextboxID, &buffer, &byte_read);
		ActiveTextboxID = *(ObjectID*)buffer;
		qfree(buffer);
		DataGetField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_CatHighlightInList, &buffer, &byte_read);
		CatHighlightInList = *(SHORT*)buffer;
		qfree(buffer);
		//DataGetField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_ActiveFormID, &buffer, &byte_read);
		ExpenseCatToList(CatText, TRUE);
		//qfree(buffer);

		DataGetField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_PopupItemNum, &buffer, &byte_read);
		ControlPopupSetSelectedItem(POPUP_EXPENSE_LIST, *(SHORT*)buffer);
		qfree(buffer);

		DataGetField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_LargeFontInEdcat, &buffer, &byte_read);
		LargeFontInEdcat = *(BYTE*)buffer;
		qfree(buffer);

	}

	return;
}


/*****************************************************************
 * Function:	ExpenseMainAppSave
 * Purpose: 	This function is called to save the data in 
				the expense database when it is called to stopped
 * Scope:		application/internal
 * Input:		None
 * Output:		None
 * Return:		None
 * Comment: 	None
******************************************************************/
BOOLEAN ExpenseMainAppSave(void)
{
	BYTE		*textbox_string, *item_text;
	BYTE		bchar_pos, visible;
	SHORT		item_num;
	WORD		char_pos;
	ObjectID	active_form_id;
	BOOLEAN		drawn_attr, enable_attr, active_attr, visible_attr, set_scroll_attr;
	DatabaseID	Expense_dbid;

//	ExpenseCatToList(CatText, FALSE);
/*
	if (ExpenseGetNewExpenseType() == EXPENSE_TYPE)
	{
		if(DelItemNum < EXPENSE_INVALID_REC_NUM)
			ExpenseDeleteExpense(DelItemNum);

//		ExpenseLoadRecord(CatText);
//		ExpenseRecordToList(&NewItemNumInList);
		DelItemNum = NewItemNumInList;
		ActiveTextboxID = NewItemNumInList + TEXTBOX_EXPENSE_LIST_AMT1;
		ListHighlightStatus = EXPENSE_NO_HIGHLIGHT;
		HighlightRecNumInList = (SHORT)EXPENSE_INVALID_REC_NUM;
//		ExpenseListSetScrollbar();

	}	
	
*/	
	if (!DataFindDB((BYTE*)"ExpenseDatabase", &Expense_dbid))
		return FALSE;

	FormGetActiveFormID(&active_form_id);
	if (active_form_id == FORM_EXPENSE_EDCAT || active_form_id == FORM_EXPENSE_DIALOG_EDCAT 
		|| active_form_id == FORM_EXPENSE_DIALOG_REMOVE || active_form_id == FORM_EXPENSE_DIALOG_EXIST
		|| active_form_id == FORM_EXPENSE_DIALOG_SELCAT)
	{
	    item_num = CatHighlightInList + 1;
	}
	else
    {
	    ControlPopupGetSelectedItem(POPUP_EXPENSE_LIST, &item_num);
	}
    ControlPopupGetPopupItem(POPUP_EXPENSE_LIST, (USHORT)item_num, &item_text);
    if (item_text[0] == 0)
		CatText[0] = 0;
	else
		strcpy(CatText, item_text);
	if (DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_PopupItemNum, sizeof(SHORT), (BYTE*)&item_num) != TRUE)
		return FALSE;
	if (DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_CatText, 20*sizeof(BYTE), (BYTE*)CatText) != TRUE)
		return FALSE;
	if (DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_CatHighlightInList, sizeof(SHORT), (BYTE*)&CatHighlightInList) != TRUE)
		return FALSE;
	if (DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_prev_row_num, sizeof(USHORT), (BYTE*)&prev_row_num) != TRUE)
		return FALSE;
	if (DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_prev_col_num, sizeof(USHORT), (BYTE*)&prev_col_num) != TRUE)
		return FALSE;
	if (DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_NewItemNumInList, sizeof(USHORT), (BYTE*)&NewItemNumInList) != TRUE)
		return FALSE;
	if (DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_DelItemNum, sizeof(USHORT), (BYTE*)&DelItemNum) != TRUE)
		return FALSE;
	if (DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_dialogX_selected, sizeof(BOOLEAN), (BYTE*)&dialogX_selected) != TRUE)
		return FALSE;
	if (DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_RenameCat, sizeof(BOOLEAN), (BYTE*)&RenameCat) != TRUE)
		return FALSE;
	if (DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_ActiveTextboxID, sizeof(ObjectID), (BYTE*)&ActiveTextboxID) != TRUE)
		return FALSE;
	if (DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_ActiveFormID, sizeof(ObjectID), (BYTE*)&active_form_id) != TRUE)
		return FALSE;

	if (active_form_id == FORM_EXPENSE_LIST	|| active_form_id == FORM_EXPENSE_DIALOG_SAVE)
	{
		TextboxGetTextPointer(ActiveTextboxID, &textbox_string);
		TextboxGetInsertPointPosition(ActiveTextboxID, &char_pos);
		ListGetAttribute(LIST_EXPENSE_LIST_DATE, &enable_attr, &drawn_attr, &active_attr, &visible_attr, &set_scroll_attr);

		if (!enable_attr)
		{
			if (DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_ExpTextboxString, 15*sizeof(BYTE), (BYTE*)textbox_string) != TRUE)
				return FALSE;
			bchar_pos = (BYTE)char_pos;
			if (DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_ExpTextboxCharPos, sizeof(BYTE), (BYTE*)&bchar_pos) != TRUE)
				return FALSE;
		}
	}
	else
	{
		TextboxGetTextPointer(TEXTBOX_EXPENSE_DIALOG_EDCAT, &textbox_string);
		TextboxGetInsertPointPosition(TEXTBOX_EXPENSE_DIALOG_EDCAT, &char_pos);
		if (DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_ExpTextboxString, 15*sizeof(BYTE), (BYTE*)textbox_string) != TRUE)
			return FALSE;
		bchar_pos = (BYTE)char_pos;
		if (DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_ExpTextboxCharPos, sizeof(BYTE), (BYTE*)&bchar_pos) != TRUE)
			return FALSE;
	}
	
	visible = (BYTE)enable_attr;
	if (DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_ExpKeypadInvisible, sizeof(BYTE), (BYTE*)&visible) != TRUE)
		return FALSE;

	if (DataWriteField(Expense_dbid, EXPENSE_MAIN_APP_SAVE, F_LargeFontInEdcat, sizeof(BYTE), (BYTE*)&LargeFontInEdcat) != TRUE)
		return FALSE;

	return TRUE;
}



/*****************************************************************
***************** Application Event Handle Function **************
*****************************************************************/


/*****************************************************************
 * Function:	ExpenseList
 * Purpose: 	This function is the event handler for the list
 *				settings page of the expense application
 * Scope:		application/internal
 * Input:		Event			received event
 * Output:		None
 * Return:		TRUE if handled
 *				FALSE if not handled
 * Comment: 	None
******************************************************************/
BOOLEAN ExpenseList(EvtType *Event)
{
	BYTE		null_buf[1] = {0};
	BYTE		*amount_text_ptr, editcate[20], *item_text;
	SHORT		item_num;
	USHORT		num_items;
	WORD		insert_ptr_pos;
	double		amount;
    static double   static_amount=0.0;
    AppID		app_id;
    BYTE		object_type;
    Textbox		*textbox_ptr;
    ObjectID	active_id;
	SHORT		selected_item;
	BYTE		*text;
	
	switch(Event->eventType)
	{
		case EVT_FORM_OPEN:
			if (!dialogX_selected)
			{
				KeyboardSetKeyboardInvisible();
				ControlPopupGetSelectedItem(POPUP_EXPENSE_LIST, &item_num);
				strcpy(editcate, "Edit Folders");
				strcpy(OldCatText, CatText);
				ControlPopupGetPopupItem(POPUP_EXPENSE_LIST, (USHORT)item_num, &item_text);
				strcpy(CatText, item_text);
				if (!strcmp(CatText, editcate))
				{
					strcpy(CatText, OldCatText);
					ExpenseCatToList(CatText, TRUE);
					FormPopupForm(FORM_EXPENSE_EDCAT);
					return TRUE;
				}

				ExpenseLoadRecord(CatText);
				ExpenseRecordToList(&NewItemNumInList);
				ExpenseKeypadInvisible();
			}
			else
				dialogX_selected = FALSE;
			FormDrawForm(FORM_EXPENSE_LIST);
			return TRUE;

		case EVT_MENU_SELECT_ITEM:
			if (ExpenseIsKeypadVisible())
				return TRUE;

			switch((USHORT)(Event->para1))
			{
				case MENU_ITEM_DELETE:
					ListHighlightStatus = EXPENSE_NO_HIGHLIGHT;
					DelItemNum = HighlightRecNumInList;
					HighlightRecNumInList = (SHORT)EXPENSE_INVALID_REC_NUM;
					if (DelItemNum < EXPENSE_INVALID_REC_NUM)
					{
						if (ExpenseDeleteExpense(DelItemNum) != TRUE)
							return TRUE;
						NewItemNumInList = EXPENSE_INVALID_REC_NUM;
						
						ExpenseLoadRecord(CatText);
						ExpenseRecordToList(&NewItemNumInList);
						DelItemNum = NewItemNumInList;
						ActiveTextboxID = NewItemNumInList + TEXTBOX_EXPENSE_LIST_AMT1;
						FormDrawForm(FORM_EXPENSE_LIST);
					}
					else
						return TRUE;
					break;
				case MENU_ITEM_UNDELETE:
#ifdef DEBUG
printf("\n ***UNDEL");
printf("\n status %ld", ListHighlightStatus);
#endif
					if (UnDelete_rec_id != 0x80001200)
					{
 						Highlighted_rec_id = UnDelete_rec_id;
						UnDelete_rec_id = 0x80001200;
//						ListHighlightStatus = EXPENSE_DATE_HIGHLIGHT;
						ListHighlightStatus = EXPENSE_TYPE_HIGHLIGHT;
						HighlightRecNumInList = EXPENSE_INVALID_REC_NUM;
						FormPopupForm(FORM_EXPENSE_LIST);
					}
					break;
				case MENU_ITEM_DELALL:
					ListGetNumItemsDisplay(LIST_EXPENSE_LIST_DATE, &num_items);
					if (num_items > 0)
						FormPopupForm(FORM_EXPENSE_DIALOG_ERASE);
					return TRUE;
				default:
					break;

			}

			return TRUE;

		case EVT_CONTROL_POPUP_SELECT:
			switch(Event->eventID)
			{
				case POPUP_EXPENSE_LIST:
					if (ListHighlightStatus == EXPENSE_TYPE_HIGHLIGHT)
					{
						if (ExpenseGetNewExpenseType() == EXPENSE_TYPE)
						{
							if (CatHighlightInList > -1)
								ControlPopupSetSelectedItem(POPUP_EXPENSE_LIST, CatHighlightInList + 1);
							else
								ControlPopupSetSelectedItem(POPUP_EXPENSE_LIST, 1);
							FormPopupForm(FORM_EXPENSE_DIALOG_SELTYPE);
							return TRUE;
						}
					}
					NewItemNumInList = EXPENSE_INVALID_REC_NUM;
					DelItemNum = EXPENSE_INVALID_REC_NUM;
					HighlightRecNumInList = EXPENSE_INVALID_REC_NUM;
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				default:	return FALSE;	
			}

		case EVT_SCROLLBAR_REPEAT:
			if (Event->para1 == Event->para2)
				return TRUE;
			if (ListHighlightStatus == EXPENSE_TYPE_HIGHLIGHT)
				if (ExpenseGetNewExpenseType() == EXPENSE_TYPE)
				{
					FormPopupForm(FORM_EXPENSE_DIALOG_SELTYPE);
					return TRUE;
				}
			NewItemNumInList = EXPENSE_INVALID_REC_NUM;
			switch(ListHighlightStatus)
			{
				case EXPENSE_DATE_HIGHLIGHT:
					ListGetSelectedItem(LIST_EXPENSE_LIST_DATE, &HighlightRecNumInList);
					break;

				case EXPENSE_TYPE_HIGHLIGHT:
					ListGetSelectedItem(LIST_EXPENSE_LIST_TYPE, &HighlightRecNumInList);
					break;
					

				case EXPENSE_CURR_HIGHLIGHT:
					ListGetSelectedItem(LIST_EXPENSE_LIST_CURR, &HighlightRecNumInList);
					break;

				default:
					HighlightRecNumInList = -1;
			}
			ExpenseScrollbarSetList((USHORT)Event->para2);
			FormDrawForm(FORM_EXPENSE_LIST);
			return TRUE;

#ifdef PR31700
		case EVT_IO_KEY_CTRL:
			if (Event->eventID == EVT_IO_KEY_PRESS || Event->eventID == EVT_IO_KEY_REPEAT)
            {
                if (Event->para2 == IO_UP_ARROW)
					ScrollbarHardButtonSetScrollbar(SCROLLBAR_EXPENSE_LIST, SCROLLBAR_UP_ARROW);
                else if (Event->para2 == IO_DOWN_ARROW)
					ScrollbarHardButtonSetScrollbar(SCROLLBAR_EXPENSE_LIST, SCROLLBAR_DOWN_ARROW);
				 return TRUE;
			}
			return FALSE;
#endif

		case EVT_SCROLLBAR_SELECT:
			ScrollbarDrawScrollbar((USHORT)Event->eventID);
/*
			if (ListHighlightStatus == EXPENSE_TYPE_HIGHLIGHT)
				if (ExpenseGetNewExpenseType() == EXPENSE_TYPE)
				{
					FormPopupForm(FORM_EXPENSE_DIALOG_SELTYPE);
					return TRUE;
				}
			NewItemNumInList = EXPENSE_INVALID_REC_NUM;
			switch(ListHighlightStatus)
			{
				case EXPENSE_DATE_HIGHLIGHT:
					ListGetSelectedItem(LIST_EXPENSE_LIST_DATE, &HighlightRecNumInList);
					break;

				case EXPENSE_TYPE_HIGHLIGHT:
					ListGetSelectedItem(LIST_EXPENSE_LIST_TYPE, &HighlightRecNumInList);
					break;

				case EXPENSE_CURR_HIGHLIGHT:
					ListGetSelectedItem(LIST_EXPENSE_LIST_CURR, &HighlightRecNumInList);
					break;

				default:
					HighlightRecNumInList = -1;
			}
			ExpenseScrollbarSetList((USHORT)Event->para2);
			FormDrawForm(FORM_EXPENSE_LIST);
*/			return TRUE;
				
		case EVT_CONTROL_SELECT:
			switch(Event->eventID)
			{	
				case BUTTON_EXPENSE_LIST_NEW:
					if (ExpenseCheckMemoryEmpty())
					{
						FormPopupForm(FORM_EXPENSE_DIALOG_LOW_MEMORY);
						return TRUE;
					}
					if (ListHighlightStatus == EXPENSE_TYPE_HIGHLIGHT)
						if (ExpenseGetNewExpenseType() == EXPENSE_TYPE)
						{
							FormPopupForm(FORM_EXPENSE_DIALOG_SELTYPE);
							return TRUE;
						}
					static_amount = 0.0;
					ControlPopupGetSelectedItem(POPUP_EXPENSE_LIST, &item_num);
					if (item_num < 1)
						return TRUE;
					if (ExpenseNewExpense() != TRUE)
						return TRUE;
					ExpenseKeypadVisible();

					ExpenseLoadRecord(CatText);
					ExpenseRecordToList(&NewItemNumInList);
					DelItemNum = NewItemNumInList;
					ActiveTextboxID = NewItemNumInList + TEXTBOX_EXPENSE_LIST_AMT1;
					FormSetFormActiveObject(FORM_EXPENSE_LIST, ActiveTextboxID);
					for(item_num=TEXTBOX_EXPENSE_LIST_AMT1; item_num<=TEXTBOX_EXPENSE_LIST_AMT11; item_num++)
						TextboxDrawTextbox(item_num);
					StringDrawString(STRING_EXPENSE_LIST_TOTAL);
					StringDrawString(STRING_EXPENSE_LIST_TOTAL_AMT);
					StringDrawString(STRING_EXPENSE_LIST_HEADER);
					ControlDrawControl(BUTTON_EXPENSE_LIST_NEW);
					ListDrawList(LIST_EXPENSE_LIST_CURR);
					//FormDrawForm(FORM_EXPENSE_LIST);
					return TRUE;
/*
				case BUTTON_EXPENSE_LIST_DEL:
					ListHighlightStatus = EXPENSE_NO_HIGHLIGHT;
// ----------------------------------------------------------------------**
// --------------------------------------------------------- NewEdit 041799
					DelItemNum = HighlightRecNumInList;
// ----------------------------------------------------------------------**
					HighlightRecNumInList = (SHORT)EXPENSE_INVALID_REC_NUM;
					if (DelItemNum < EXPENSE_INVALID_REC_NUM)
					{
						if (ExpenseDeleteExpense(DelItemNum) != TRUE)
							return TRUE;
						//ExpenseSetCatPopupEnable();
// ----------------------------------------------------------------------**
// --------------------------------------------------------- NewEdit 041799
						NewItemNumInList = EXPENSE_INVALID_REC_NUM;
// ----------------------------------------------------------------------**
						break;
					}
					else
						return TRUE;

				case BUTTON_EXPENSE_LIST_DELALL:
					ListGetNumItemsDisplay(LIST_EXPENSE_LIST_DATE, &num_items);
					if (num_items > 0)
						FormPopupForm(FORM_EXPENSE_DIALOG_ERASE);
					return TRUE;
*/

				default:	return FALSE;
			}
			return TRUE;


		case EVT_LIST_SELECT:
//------------------------------------------------------New edit 040299
			
//			if (Event->para1 == NewItemNumInList)
			if (Event->para1 == HighlightRecNumInList)
			{
#ifdef DEBUG
printf("\n ***rec num IN list");
printf("\n status %ld", ListHighlightStatus);
#endif
				switch(Event->eventID)
				{
					case LIST_EXPENSE_LIST_DATE:
						if (ListHighlightStatus == EXPENSE_TYPE_HIGHLIGHT)
							if (ExpenseGetNewExpenseType() == EXPENSE_TYPE)
							{
								FormPopupForm(FORM_EXPENSE_DIALOG_SELTYPE);
								return TRUE;					
							}
						ListHighlightStatus = EXPENSE_DATE_HIGHLIGHT;
						ListGetSelectedItem(LIST_EXPENSE_LIST_DATE, &HighlightRecNumInList);
						FormPopupForm(FORM_EXPENSE_DATE);
						return TRUE;

					case LIST_EXPENSE_LIST_TYPE:
						ListHighlightStatus = EXPENSE_TYPE_HIGHLIGHT;
						ListGetSelectedItem(LIST_EXPENSE_LIST_TYPE, &HighlightRecNumInList);
						FormPopupForm(FORM_EXPENSE_TYPE);
						return TRUE;

					case LIST_EXPENSE_LIST_CURR:
						if (ListHighlightStatus == EXPENSE_TYPE_HIGHLIGHT)
							if (ExpenseGetNewExpenseType() == EXPENSE_TYPE)
							{
								FormPopupForm(FORM_EXPENSE_DIALOG_SELTYPE);
								return TRUE;					
							}
						ListHighlightStatus = EXPENSE_CURR_HIGHLIGHT;
						ListGetSelectedItem(LIST_EXPENSE_LIST_CURR, &HighlightRecNumInList);
						FormPopupForm(FORM_EXPENSE_CURR);
						return TRUE;

					default:	return FALSE;
				}
			}
			else
			{
#ifdef DEBUG
printf("\n ***rec num NOT IN list");
printf("\n status %ld", ListHighlightStatus);
#endif
//donna delete
//				if (ListHighlightStatus == EXPENSE_TYPE_HIGHLIGHT)
					if (ExpenseGetNewExpenseType() == EXPENSE_TYPE)
					{
//donna add(
#ifdef DEBUG
printf("\n **** A ****");
#endif
						if (Event->eventID == LIST_EXPENSE_LIST_TYPE)
						{
							ListGetSelectedItem(LIST_EXPENSE_LIST_TYPE, &selected_item);
							ListGetListItem(LIST_EXPENSE_LIST_TYPE, selected_item, &text);
#ifdef DEBUG
printf("\n **** B ****");
#endif

							if (strcmp(text,(BYTE*)("Expense Type"))==0)
							{
#ifdef DEBUG
printf("\n **** text is expense type ****");
#endif								
								ListHighlightStatus = EXPENSE_TYPE_HIGHLIGHT;
								ListGetSelectedItem(LIST_EXPENSE_LIST_TYPE, &HighlightRecNumInList);
								FormPopupForm(FORM_EXPENSE_TYPE);
								return TRUE;
							}
							else
//add)						
							{
#ifdef DEBUG
printf("\n **** C ****");
#endif								
								FormPopupForm(FORM_EXPENSE_DIALOG_SELTYPE);
								return TRUE;
							}
						}
						else
						{
#ifdef DEBUG
printf("\n **** D ****");
#endif								
							FormPopupForm(FORM_EXPENSE_DIALOG_SELTYPE);
							return TRUE;
						}
						
					}
				
/*					ListGetSelectedItem(LIST_EXPENSE_LIST_TYPE, &selected_item);
					ListGetListItem(LIST_EXPENSE_LIST_TYPE, selected_item, &text); 
#ifdef DEBUG
printf("\n selected item = %ld", selected_item);
printf("\n %s", text);
#endif
						if (strcmp(text,(BYTE*)("Expense Type"))==0)
						{	
							ListHighlightStatus = EXPENSE_TYPE_HIGHLIGHT;
							ListGetSelectedItem(LIST_EXPENSE_LIST_TYPE, &HighlightRecNumInList);
							FormPopupForm(FORM_EXPENSE_TYPE);
							return TRUE;
						}
*/				


				switch(Event->eventID)
				{
					case LIST_EXPENSE_LIST_DATE:
				HighlightRecNumInList = (USHORT)Event->para1;
				NewExpense_rec_id = RecIDInList[HighlightRecNumInList];
				DelItemNum = (USHORT)Event->para1;
				NewItemNumInList = EXPENSE_INVALID_REC_NUM;
//						ListGetSelectedItem(LIST_EXPENSE_LIST_DATE, &HighlightRecNumInList);
						ListHighlightStatus = EXPENSE_DATE_HIGHLIGHT;
						ListSetHighlightedItem(LIST_EXPENSE_LIST_DATE, HighlightRecNumInList);					
						ListDrawList((USHORT)Event->eventID);
						return TRUE;

					case LIST_EXPENSE_LIST_TYPE:
				HighlightRecNumInList = (USHORT)Event->para1;
				NewExpense_rec_id = RecIDInList[HighlightRecNumInList];
				DelItemNum = (USHORT)Event->para1;
				NewItemNumInList = EXPENSE_INVALID_REC_NUM;
//						ListGetSelectedItem(LIST_EXPENSE_LIST_TYPE, &HighlightRecNumInList);
						ListHighlightStatus = EXPENSE_TYPE_HIGHLIGHT;
						ListSetHighlightedItem(LIST_EXPENSE_LIST_TYPE, HighlightRecNumInList);
						ListDrawList((USHORT)Event->eventID);
						return TRUE;

					case LIST_EXPENSE_LIST_CURR:
						ListGetNumItemsDisplay(LIST_EXPENSE_LIST_DATE, &num_items);
//						ListGetSelectedItem(LIST_EXPENSE_LIST_CURR, &item_num);
						if ((USHORT)Event->para1 < 11 && (USHORT)Event->para1 < num_items)
						{


//				NewItemNumInList = (USHORT)Event->para1;		

//				NewExpense_rec_id = RecIDInList[NewItemNumInList];
							ListHighlightStatus = EXPENSE_CURR_HIGHLIGHT;
							ListGetListItem(LIST_EXPENSE_LIST_CURR, (USHORT)Event->para1, &amount_text_ptr);
							if (*amount_text_ptr != 0)
							{
				HighlightRecNumInList = (USHORT)Event->para1;
				NewExpense_rec_id = RecIDInList[HighlightRecNumInList];
				DelItemNum = (USHORT)Event->para1;
				NewItemNumInList = EXPENSE_INVALID_REC_NUM;

								ListSetHighlightedItem(LIST_EXPENSE_LIST_CURR, HighlightRecNumInList);
								ListDrawList((USHORT)Event->eventID);
							}
//							FormPopupForm(FORM_EXPENSE_CURR);
							return TRUE;
						}

						HighlightRecNumInList = EXPENSE_INVALID_REC_NUM;
						NewExpense_rec_id = HighlightRecNumInList;
						NewItemNumInList = EXPENSE_INVALID_REC_NUM;
						ListHighlightStatus = EXPENSE_NO_HIGHLIGHT;

						if(Event->para1 == 11)
							FormPopupForm(FORM_EXPENSE_CURR);

						return TRUE;

					default:	return FALSE;
				}
				return TRUE;
			}
//---------------------------------------------------------------------------------------

		case EVT_TEXTBOX_SELECT:
			FormGetObjectPointer((SHORT)Event->eventID, &object_type, (void**)&textbox_ptr);
			if (textbox_ptr->textbox_highlight_length < 0)
				insert_ptr_pos = -textbox_ptr->textbox_highlight_length;
			else
				insert_ptr_pos = textbox_ptr->textbox_highlight_length;
			if (insert_ptr_pos != textbox_ptr->textbox_num_chars_displayed)
			{
				textbox_ptr->textbox_highlight_start_char = 0;
				textbox_ptr->textbox_highlight_end_char = 0;
				textbox_ptr->textbox_highlight_length = 0;
				textbox_ptr->textbox_attr.textbox_highlight = FALSE;
				TextboxDrawTextbox((SHORT)Event->eventID);
// bug fixed - 140400
				TextboxSetInsertPointOn((SHORT)Event->eventID);
//				TextboxSetInsertPointOn(ActiveTextboxID);
			}

			if (ExpenseIsKeypadVisible())
			{		
				if (ActiveTextboxID == Event->eventID)
					return TRUE;
// ----------------------------------------------------------------------------------------**
// ----------------------------------------------------------------------------- New Edit 042699
				FormGetObjectPointer((SHORT)Event->eventID, &object_type, (void**)&textbox_ptr);
				textbox_ptr->textbox_highlight_start_char = 0;
				textbox_ptr->textbox_highlight_end_char = 0;
				textbox_ptr->textbox_highlight_length = 0;
				textbox_ptr->textbox_attr.textbox_highlight = FALSE;
				TextboxDrawTextbox((SHORT)Event->eventID);
// ----------------------------------------------------------------------------------------**

				FormSetFormActiveObject(FORM_EXPENSE_LIST, ActiveTextboxID);
				TextboxSetInsertPointOn(ActiveTextboxID);
			
				return TRUE;
			}
			if (ListHighlightStatus == EXPENSE_TYPE_HIGHLIGHT)
				if (ExpenseGetNewExpenseType() == EXPENSE_TYPE)
				{
					FormPopupForm(FORM_EXPENSE_DIALOG_SELTYPE);
					return TRUE;
				}
			ListGetNumOfItems(LIST_EXPENSE_LIST_DATE, &num_items);
			if (num_items < (USHORT)(Event->eventID - TEXTBOX_EXPENSE_LIST_AMT1 + 1))
			{
				TextboxSetInsertPointOff((ObjectID)Event->eventID);
				return TRUE;
			}
			ActiveTextboxID = (ObjectID)Event->eventID;		
			TextboxGetTextPointer(ActiveTextboxID, &amount_text_ptr);
			static_amount = atod((const char*)amount_text_ptr);
//			static_amount = atod((const char*)sbuf);

			ListHighlightStatus = EXPENSE_OLD_AMT_HIGHLIGHT;
//			NewItemNumInList = EXPENSE_INVALID_REC_NUM;
			HighlightRecNumInList =  ActiveTextboxID - TEXTBOX_EXPENSE_LIST_AMT1;
			NewItemNumInList = (USHORT)(Event->eventID - TEXTBOX_EXPENSE_LIST_AMT1);
			NewExpense_rec_id = RecIDInList[NewItemNumInList];
			ExpenseKeypadVisible();
			FormDrawForm(FORM_EXPENSE_LIST);
			return TRUE;


		case EVT_KEY:
		    if (Event->para2 & 0x00000300)
		    	return TRUE;

			FormGetActiveObject(FORM_EXPENSE_LIST, &active_id);
			if (active_id < TEXTBOX_EXPENSE_LIST_AMT1 || active_id > TEXTBOX_EXPENSE_LIST_AMT11)
				return TRUE;			
			if (Event->eventID == SOFT_KEY)
			{
				switch(Event->para1)
				{
					case '\r':
					case '\n':
			            EvtAppendEvt(EVT_BITMAP_SELECT, BITMAP_EXPENSE_LIST_KEYEN, 0, 0, NULL);
						break;					
					case '0':
			            EvtAppendEvt(EVT_BITMAP_SELECT, BITMAP_EXPENSE_LIST_KEY0, 0, 0, NULL);
						break;
					case '1':
			            EvtAppendEvt(EVT_BITMAP_SELECT, BITMAP_EXPENSE_LIST_KEY1, 0, 0, NULL);
						break;
					case '2':
			            EvtAppendEvt(EVT_BITMAP_SELECT, BITMAP_EXPENSE_LIST_KEY2, 0, 0, NULL);
						break;
					case '3':
			            EvtAppendEvt(EVT_BITMAP_SELECT, BITMAP_EXPENSE_LIST_KEY3, 0, 0, NULL);
						break;
					case '4':
			            EvtAppendEvt(EVT_BITMAP_SELECT, BITMAP_EXPENSE_LIST_KEY4, 0, 0, NULL);
						break;
					case '5':
			            EvtAppendEvt(EVT_BITMAP_SELECT, BITMAP_EXPENSE_LIST_KEY5, 0, 0, NULL);
						break;
					case '6':
			            EvtAppendEvt(EVT_BITMAP_SELECT, BITMAP_EXPENSE_LIST_KEY6, 0, 0, NULL);
						break;
					case '7':
			            EvtAppendEvt(EVT_BITMAP_SELECT, BITMAP_EXPENSE_LIST_KEY7, 0, 0, NULL);
						break;
					case '8':
			            EvtAppendEvt(EVT_BITMAP_SELECT, BITMAP_EXPENSE_LIST_KEY8, 0, 0, NULL);
						break;
					case '9':
			            EvtAppendEvt(EVT_BITMAP_SELECT, BITMAP_EXPENSE_LIST_KEY9, 0, 0, NULL);
						break;
					case '.':
			            EvtAppendEvt(EVT_BITMAP_SELECT, BITMAP_EXPENSE_LIST_KEYD, 0, 0, NULL);
						break;
					case KEY_LEFT:
			            EvtAppendEvt(EVT_BITMAP_SELECT, BITMAP_EXPENSE_LIST_KEYB, 0, 0, NULL);
						break;
					case KEY_BACKSPACE:
			            EvtAppendEvt(EVT_BITMAP_SELECT, BITMAP_EXPENSE_LIST_KEYC, 0, 0, NULL);
						break;
					case KEY_RIGHT:
			            EvtAppendEvt(EVT_BITMAP_SELECT, BITMAP_EXPENSE_LIST_KEYF, 0, 0, NULL);
						break;
					default:
						break;
				}		
				return TRUE;
			}


		case EVT_BITMAP_SELECT:	
			switch(Event->eventID)
			{	
				case BITMAP_EXPENSE_LIST_KEYB:
					FormSetFormActiveObject(FORM_EXPENSE_LIST, ActiveTextboxID);
					TextboxSetInsertPointOn(ActiveTextboxID);
					KeyboardSendEvent(KEY_LEFT, FALSE, FALSE, FALSE);
					return TRUE;

				case BITMAP_EXPENSE_LIST_KEYC:
					FormSetFormActiveObject(FORM_EXPENSE_LIST, ActiveTextboxID);
					TextboxSetInsertPointOn(ActiveTextboxID);
			TextboxGetTextPointer(ActiveTextboxID, &amount_text_ptr);
			TextboxGetInsertPointPosition(ActiveTextboxID, &insert_ptr_pos);
			if (insert_ptr_pos > 0)
				insert_ptr_pos--;
			if (amount_text_ptr[insert_ptr_pos] == '.')
			{
					if (amount_text_ptr[insert_ptr_pos+1] != 0)
					{
						if (amount_text_ptr[insert_ptr_pos+2] != 0)
						{
							KeyboardSendEvent(KEY_RIGHT, FALSE, FALSE, FALSE);
							KeyboardSendEvent(KEY_RIGHT, FALSE, FALSE, FALSE);
							KeyboardSendEvent(KEY_BACKSPACE, FALSE, FALSE, FALSE);
							KeyboardSendEvent(KEY_BACKSPACE, FALSE, FALSE, FALSE);
						}
						else
						{
							KeyboardSendEvent(KEY_RIGHT, FALSE, FALSE, FALSE);
							KeyboardSendEvent(KEY_BACKSPACE, FALSE, FALSE, FALSE);
						}
					}
			}
					KeyboardSendEvent(KEY_BACKSPACE, FALSE, FALSE, FALSE);
					return TRUE;

				case BITMAP_EXPENSE_LIST_KEYF:
					FormSetFormActiveObject(FORM_EXPENSE_LIST, ActiveTextboxID);
					TextboxSetInsertPointOn(ActiveTextboxID);
					KeyboardSendEvent(KEY_RIGHT, FALSE, FALSE, FALSE);
					return TRUE;

				case BITMAP_EXPENSE_LIST_KEY7:
					FormSetFormActiveObject(FORM_EXPENSE_LIST, ActiveTextboxID);
					TextboxSetInsertPointOn(ActiveTextboxID);
					TextboxGetTextPointer(ActiveTextboxID, &amount_text_ptr);
					TextboxGetInsertPointPosition(ActiveTextboxID, &insert_ptr_pos);
					if (ExpenseCheckTextboxDigitOver(ActiveTextboxID, amount_text_ptr, insert_ptr_pos, 2))
						return TRUE;
					TextboxAddKeyInChar(ActiveTextboxID, '7');
					return TRUE;

				case BITMAP_EXPENSE_LIST_KEY8:
					FormSetFormActiveObject(FORM_EXPENSE_LIST, ActiveTextboxID);
					TextboxSetInsertPointOn(ActiveTextboxID);
					TextboxGetTextPointer(ActiveTextboxID, &amount_text_ptr);
					TextboxGetInsertPointPosition(ActiveTextboxID, &insert_ptr_pos);
					if (ExpenseCheckTextboxDigitOver(ActiveTextboxID, amount_text_ptr, insert_ptr_pos, 2))
						return TRUE;
					TextboxAddKeyInChar(ActiveTextboxID, '8');
					return TRUE;

				case BITMAP_EXPENSE_LIST_KEY9:
					FormSetFormActiveObject(FORM_EXPENSE_LIST, ActiveTextboxID);
					TextboxSetInsertPointOn(ActiveTextboxID);
					TextboxGetTextPointer(ActiveTextboxID, &amount_text_ptr);
					TextboxGetInsertPointPosition(ActiveTextboxID, &insert_ptr_pos);
					if (ExpenseCheckTextboxDigitOver(ActiveTextboxID, amount_text_ptr, insert_ptr_pos, 2))
						return TRUE;
					TextboxAddKeyInChar(ActiveTextboxID, '9');
					return TRUE;

				case BITMAP_EXPENSE_LIST_KEY4:
					FormSetFormActiveObject(FORM_EXPENSE_LIST, ActiveTextboxID);
					TextboxSetInsertPointOn(ActiveTextboxID);
					TextboxGetTextPointer(ActiveTextboxID, &amount_text_ptr);
					TextboxGetInsertPointPosition(ActiveTextboxID, &insert_ptr_pos);
					if (ExpenseCheckTextboxDigitOver(ActiveTextboxID, amount_text_ptr, insert_ptr_pos, 2))
						return TRUE;
					TextboxAddKeyInChar(ActiveTextboxID, '4');
					return TRUE;

				case BITMAP_EXPENSE_LIST_KEY5:
					FormSetFormActiveObject(FORM_EXPENSE_LIST, ActiveTextboxID);
					TextboxSetInsertPointOn(ActiveTextboxID);
					TextboxGetTextPointer(ActiveTextboxID, &amount_text_ptr);
					TextboxGetInsertPointPosition(ActiveTextboxID, &insert_ptr_pos);
					if (ExpenseCheckTextboxDigitOver(ActiveTextboxID, amount_text_ptr, insert_ptr_pos, 2))
						return TRUE;
					TextboxAddKeyInChar(ActiveTextboxID, '5');
					return TRUE;

				case BITMAP_EXPENSE_LIST_KEY6:
					FormSetFormActiveObject(FORM_EXPENSE_LIST, ActiveTextboxID);
					TextboxSetInsertPointOn(ActiveTextboxID);
					TextboxGetTextPointer(ActiveTextboxID, &amount_text_ptr);
					TextboxGetInsertPointPosition(ActiveTextboxID, &insert_ptr_pos);
					if (ExpenseCheckTextboxDigitOver(ActiveTextboxID, amount_text_ptr, insert_ptr_pos, 2))
						return TRUE;
					TextboxAddKeyInChar(ActiveTextboxID, '6');
					return TRUE;

				case BITMAP_EXPENSE_LIST_KEY1:
					FormSetFormActiveObject(FORM_EXPENSE_LIST, ActiveTextboxID);
					TextboxSetInsertPointOn(ActiveTextboxID);
					TextboxGetTextPointer(ActiveTextboxID, &amount_text_ptr);
					TextboxGetInsertPointPosition(ActiveTextboxID, &insert_ptr_pos);
					if (ExpenseCheckTextboxDigitOver(ActiveTextboxID, amount_text_ptr, insert_ptr_pos, 2))
						return TRUE;
					TextboxAddKeyInChar(ActiveTextboxID, '1');
					return TRUE;

				case BITMAP_EXPENSE_LIST_KEY2:
					FormSetFormActiveObject(FORM_EXPENSE_LIST, ActiveTextboxID);
					TextboxSetInsertPointOn(ActiveTextboxID);
					TextboxGetTextPointer(ActiveTextboxID, &amount_text_ptr);
					TextboxGetInsertPointPosition(ActiveTextboxID, &insert_ptr_pos);
					if (ExpenseCheckTextboxDigitOver(ActiveTextboxID, amount_text_ptr, insert_ptr_pos, 2))
						return TRUE;
					TextboxAddKeyInChar(ActiveTextboxID, '2');
					return TRUE;

				case BITMAP_EXPENSE_LIST_KEY3:
					FormSetFormActiveObject(FORM_EXPENSE_LIST, ActiveTextboxID);
					TextboxSetInsertPointOn(ActiveTextboxID);
					TextboxGetTextPointer(ActiveTextboxID, &amount_text_ptr);
					TextboxGetInsertPointPosition(ActiveTextboxID, &insert_ptr_pos);
					if (ExpenseCheckTextboxDigitOver(ActiveTextboxID, amount_text_ptr, insert_ptr_pos, 2))
						return TRUE;
					TextboxAddKeyInChar(ActiveTextboxID, '3');
					return TRUE;

				case BITMAP_EXPENSE_LIST_KEYD:
					FormSetFormActiveObject(FORM_EXPENSE_LIST, ActiveTextboxID);
					TextboxSetInsertPointOn(ActiveTextboxID);
					TextboxGetTextPointer(ActiveTextboxID, &amount_text_ptr);
					TextboxGetInsertPointPosition(ActiveTextboxID, &insert_ptr_pos);
					if (ExpenseCheckTextboxDigitOver(ActiveTextboxID, amount_text_ptr, insert_ptr_pos, 0))
						return TRUE;
					TextboxAddKeyInChar(ActiveTextboxID, '.');
					return TRUE;

				case BITMAP_EXPENSE_LIST_KEY0:
					FormSetFormActiveObject(FORM_EXPENSE_LIST, ActiveTextboxID);
					TextboxSetInsertPointOn(ActiveTextboxID);
					TextboxGetTextPointer(ActiveTextboxID, &amount_text_ptr);
					TextboxGetInsertPointPosition(ActiveTextboxID, &insert_ptr_pos);
					if (ExpenseCheckTextboxDigitOver(ActiveTextboxID, amount_text_ptr, insert_ptr_pos, 2))
						return TRUE;
					TextboxAddKeyInChar(ActiveTextboxID, '0');
					return TRUE;

				case BITMAP_EXPENSE_LIST_KEYA:
					FormSetFormActiveObject(FORM_EXPENSE_LIST, ActiveTextboxID);
					TextboxSetInsertPointOn(ActiveTextboxID);
					TextboxGetTextPointer(ActiveTextboxID, &amount_text_ptr);
					TextboxGetInsertPointPosition(ActiveTextboxID, &insert_ptr_pos);
					if (ExpenseCheckTextboxDigitOver(ActiveTextboxID, amount_text_ptr, insert_ptr_pos, 1))
						return TRUE;
					TextboxAddKeyInChar(ActiveTextboxID, '0');
					TextboxAddKeyInChar(ActiveTextboxID, '0');
					return TRUE;

				case BITMAP_EXPENSE_LIST_KEYEN:
					TextboxGetTextPointer(ActiveTextboxID, &amount_text_ptr);
					item_num = strlen(amount_text_ptr);
					if (item_num < 1)
					{
						TextboxSetInsertPointOn(ActiveTextboxID);
						return TRUE;
					}

					item_num--;
					while(item_num > -1)
					{
						if ((amount_text_ptr[item_num] != '.') && !(amount_text_ptr[item_num] >= '0' && amount_text_ptr[item_num] <= '9'))
						{
							TextboxSetInsertPointOn(ActiveTextboxID);
							return TRUE;
						}
						item_num--;
					}
					amount = atod((const char*)amount_text_ptr);
					if (amount >= 0.01)
					{
						ExpenseSetAmount(ActiveTextboxID - (ObjectID)TEXTBOX_EXPENSE_LIST_AMT1, amount);
						TextboxSetInsertPointOff(ActiveTextboxID);
						ExpenseKeypadInvisible();
						if (ListHighlightStatus == EXPENSE_OLD_AMT_HIGHLIGHT)
						{
							ListHighlightStatus = EXPENSE_CURR_HIGHLIGHT;
//							ListHighlightStatus = EXPENSE_TYPE_HIGHLIGHT;
							ExpenseSetCatPopupEnable();

							HighlightRecNumInList =  ActiveTextboxID - TEXTBOX_EXPENSE_LIST_AMT1;
							ExpenseLoadRecord(CatText);
							ExpenseRecordToList(&NewItemNumInList);
							ExpenseKeypadInvisible();
// ----------------------------------------------------------------------------------------**
							FormGetObjectPointer(ActiveTextboxID, &object_type, (void**)&textbox_ptr);
							textbox_ptr->textbox_highlight_start_char = 0;
							textbox_ptr->textbox_highlight_end_char = 0;
							textbox_ptr->textbox_highlight_length = 0;
							textbox_ptr->textbox_attr.textbox_highlight = FALSE;
// ----------------------------------------------------------------------------------------**
							FormDrawForm(FORM_EXPENSE_LIST);
							return TRUE;
						}
						else
							ListHighlightStatus = EXPENSE_TYPE_HIGHLIGHT;
						HighlightRecNumInList =  ActiveTextboxID - TEXTBOX_EXPENSE_LIST_AMT1;
						ExpenseLoadRecord(CatText);
						ExpenseRecordToList(&NewItemNumInList);
						ExpenseKeypadInvisible();
// ----------------------------------------------------------------------------------------**
						FormGetObjectPointer(ActiveTextboxID, &object_type, (void**)&textbox_ptr);
						textbox_ptr->textbox_highlight_start_char = 0;
						textbox_ptr->textbox_highlight_end_char = 0;
						textbox_ptr->textbox_highlight_length = 0;
						textbox_ptr->textbox_attr.textbox_highlight = FALSE;
// ----------------------------------------------------------------------------------------**
						
						ListDrawList(LIST_EXPENSE_LIST_DATE);
						ControlDrawControl(BUTTON_EXPENSE_LIST_NEW);
						FormPopupForm(FORM_EXPENSE_TYPE);
					}
					else
						TextboxSetInsertPointOn(ActiveTextboxID);

					return TRUE;

				default:	return FALSE;
			}
	
		case EVT_INLAY_SELECT:
			switch(Event->para1)
			{	
				case INLAY_OK:
					if (!ExpenseIsKeypadVisible())
					{
//						ListHighlightStatus = EXPENSE_NO_HIGHLIGHT;
//						HighlightRecNumInList =  (SHORT)0x80001000;
						ExpenseAppSave();

#ifdef PR31700
          	SysGetAppID((BYTE*)("Mainmenu"), &app_id);
            EvtAppendEvt(EVT_APP_STOP, 0, 0, 0, NULL);
            EvtAppendEvt(EVT_APP_LAUNCH, app_id, 0, 0, NULL);
#endif

						return TRUE;
					}

		            EvtAppendEvt(EVT_BITMAP_SELECT, BITMAP_EXPENSE_LIST_KEYEN, 0, 0, NULL);
					return TRUE;

				case INLAY_EXIT:
					if (ExpenseIsKeypadVisible())
					{
						TextboxGetTextPointer(ActiveTextboxID, &amount_text_ptr);
						amount = atod((const char*)amount_text_ptr);
//						amount = atod((const char*)sbuf);
//			static_amount = atod((const char*)amount_text_ptr);		
						if (static_amount == amount)
						{
							//if (*amount_text_ptr == 0)
							if (amount < 1.0)
							{
								if (DelItemNum < EXPENSE_INVALID_REC_NUM)
								{
									if (ExpenseDeleteExpense(DelItemNum) != TRUE)
										return TRUE;
								}
								ListHighlightStatus = EXPENSE_NO_HIGHLIGHT;
								HighlightRecNumInList = (SHORT)EXPENSE_INVALID_REC_NUM;
								DelItemNum = EXPENSE_INVALID_REC_NUM;
								ExpenseListSetScrollbar();
							}
							else
							{
								ListHighlightStatus = EXPENSE_TYPE_HIGHLIGHT;
								DelItemNum = NewItemNumInList;
							}
								
							ExpenseLoadRecord(CatText);
							ExpenseRecordToList(&NewItemNumInList);
							ActiveTextboxID = NewItemNumInList + TEXTBOX_EXPENSE_LIST_AMT1;
//							ListHighlightStatus = EXPENSE_NO_HIGHLIGHT;
//							HighlightRecNumInList = (SHORT)EXPENSE_INVALID_REC_NUM;
//							ExpenseListSetScrollbar();
							ExpenseSetCatPopupEnable();
// ----------------------------------------------------------------------------------------**
// ----------------------------------------------------------------------------- New Edit 042699
							FormGetObjectPointer(ActiveTextboxID, &object_type, (void**)&textbox_ptr);
							textbox_ptr->textbox_highlight_start_char = 0;
							textbox_ptr->textbox_highlight_end_char = 0;
							textbox_ptr->textbox_highlight_length = 0;
							textbox_ptr->textbox_attr.textbox_highlight = FALSE;
// ----------------------------------------------------------------------------------------**
							FormPopupForm(FORM_EXPENSE_LIST);
						}
						else
							FormPopupForm(FORM_EXPENSE_DIALOG_SAVE);
					}
					else
					{
						ExpenseAppSave();
#ifdef PR31700
          	SysGetAppID((BYTE*)("Mainmenu"), &app_id);
            EvtAppendEvt(EVT_APP_STOP, 0, 0, 0, NULL);
            EvtAppendEvt(EVT_APP_LAUNCH, app_id, 0, 0, NULL);
#endif
			return TRUE;
					}					
					return TRUE;
			}

		default:	return FALSE;	
	}

	return FALSE;
}


/*****************************************************************
 * Function:	ExpenseDate
 * Purpose: 	This function is the event handler for the date
 *				settings page of the expense application
 * Scope:		application/internal
 * Input:		Event			received event
 * Output:		None
 * Return:		TRUE if handled
 *				FALSE if not handled
 * Comment: 	None
******************************************************************/
BOOLEAN ExpenseDate(EvtType *Event)
{

	BYTE	*list_string, day_text[3] = {0}, text[60];
	SHORT	year, month, day;
	RTM				time_source;
	EXPENSE_DATE	date;
	CountrySettings country;

	switch(Event->eventType)
	{
		case EVT_FORM_OPEN:
			SySetupGetCountrySettings(&country);
			switch(country.start_of_week)
			{
				case SYSETUP_SUN:
					strcpy(text, "    S       M        T       W       T         F        S");
					break;
				case SYSETUP_MON:
					strcpy(text, "   M        T       W       T         F        S        S");
					break;
				default:	return FALSE;	
			}
			StringSetText(STRING_EXPENSE_DATE_WDAY, text);
			SySetupRestoreDateSettings(FORM_EXPENSE_DATE, TABLE_EXPENSE_DATE, PUSH_EXPENSE_DATE_Y1, 
				PUSH_EXPENSE_DATE_JAN, &prev_row_num, &prev_col_num);
			FormDrawForm(FORM_EXPENSE_DATE);
			return TRUE;

		case EVT_BITMAP_SELECT:
			SySetupGetCountrySettings(&country);
			switch (Event->eventID)
			{
				case BITMAP_EXPENSE_DATE_LEFT:
					SySetupDateUpdateYearBar(PUSH_EXPENSE_DATE_Y1, BUTTON_EXPENSE_DATE_DISABLE_BKGRD, SYSETUP_YEAR_LEFT);
					SySetupGetDateSettings(FORM_EXPENSE_DATE, TABLE_EXPENSE_DATE, PUSH_EXPENSE_DATE_JAN, GROUP_ID_EXPENSE_DATE_YEAR,
						GROUP_ID_EXPENSE_DATE_MONTH, prev_row_num, prev_col_num, &year, &month, &day);
					SySetupDateUpdateTable(TABLE_EXPENSE_DATE, year, month, day, (SHORT)country.start_of_week, &prev_row_num, &prev_col_num);
					TableEraseTable(TABLE_EXPENSE_DATE);
					TableDrawTable(TABLE_EXPENSE_DATE);
					return TRUE;

				case BITMAP_EXPENSE_DATE_RIGHT:
					SySetupDateUpdateYearBar(PUSH_EXPENSE_DATE_Y1, BUTTON_EXPENSE_DATE_DISABLE_BKGRD, SYSETUP_YEAR_RIGHT);
					SySetupGetDateSettings(FORM_EXPENSE_DATE, TABLE_EXPENSE_DATE, PUSH_EXPENSE_DATE_JAN, GROUP_ID_EXPENSE_DATE_YEAR,
						GROUP_ID_EXPENSE_DATE_MONTH, prev_row_num, prev_col_num, &year, &month, &day);
					SySetupDateUpdateTable(TABLE_EXPENSE_DATE, year, month, day, (SHORT)country.start_of_week, &prev_row_num, &prev_col_num);
					TableEraseTable(TABLE_EXPENSE_DATE);
					TableDrawTable(TABLE_EXPENSE_DATE);
					return TRUE;


				default:	return FALSE;
			}

		case EVT_CONTROL_SELECT:
			switch(Event->eventID)
			{	
				case BUTTON_EXPENSE_DATE_TODAY:
					FormPopupForm(FORM_EXPENSE_DATE);
					return TRUE;
					
				default:
					SySetupGetCountrySettings(&country);
					SySetupGetDateSettings(FORM_EXPENSE_DATE, TABLE_EXPENSE_DATE, PUSH_EXPENSE_DATE_JAN, GROUP_ID_EXPENSE_DATE_YEAR,
						GROUP_ID_EXPENSE_DATE_MONTH, prev_row_num, prev_col_num, &year, &month, &day);
					SySetupDateUpdateTable(TABLE_EXPENSE_DATE, year, month, day, (SHORT)country.start_of_week, &prev_row_num, &prev_col_num);
					TableEraseTable(TABLE_EXPENSE_DATE);
					TableDrawTable(TABLE_EXPENSE_DATE);
					return TRUE;
			}


		case EVT_TABLE_SELECT:			
			TableGetItemText(TABLE_EXPENSE_DATE, (USHORT)Event->para1, (USHORT)Event->para2, &list_string);
			if (list_string[0] != 0)
			{
				if ((prev_row_num == (USHORT)Event->para1) && (prev_col_num == (USHORT)Event->para2))
					TableSetHighlightCell(TABLE_EXPENSE_DATE, prev_row_num, prev_col_num, TRUE);
				else
				{
					TableSetHighlightCell(TABLE_EXPENSE_DATE, prev_row_num, prev_col_num, FALSE);
					prev_row_num = (USHORT)Event->para1;
					prev_col_num = (USHORT)Event->para2;		
				}
				TableDrawTable(TABLE_EXPENSE_DATE);
			}
			return TRUE;

		case EVT_INLAY_SELECT:
			switch(Event->para1)
			{	
				case INLAY_OK:
					SySetupGetDateSettings(FORM_EXPENSE_DATE, TABLE_EXPENSE_DATE, PUSH_EXPENSE_DATE_JAN, GROUP_ID_EXPENSE_DATE_YEAR,
						GROUP_ID_EXPENSE_DATE_MONTH, prev_row_num, prev_col_num, &year, &month, &day);
					date.year= (BYTE)(year - SYSETUP_YEAR_OFFSET);
					date.mon = (BYTE)(month+1);
					date.day = (BYTE)day;
					RtcGetTime(&time_source);
					date.hr  = (BYTE)time_source.hour;
					date.min = (BYTE)time_source.min;
					date.sec = (BYTE)time_source.sec;
//					date.hr  = 0;
//					date.min = 0;
//					date.sec = 0;
					ExpenseSetDate(date);
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				case INLAY_EXIT:
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				default:	return FALSE;
			}

	}

	return FALSE;
}

/*****************************************************************
 * Function:	ExpenseType
 * Purpose: 	This function is the event handler for the expense
 *				type settings page of the expense application
 * Scope:		application/internal
 * Input:		Event			received event
 * Output:		None
 * Return:		TRUE if handled
 *				FALSE if not handled
 * Comment: 	None
******************************************************************/
BOOLEAN ExpenseType(EvtType *Event)
{
    BYTE		object_type;
    Control		*control_ptr;
	
	switch(Event->eventType)
	{
		case EVT_FORM_OPEN:
			FormGetObjectPointer(POPUP_EXPENSE_LIST, &object_type, (void**)&control_ptr);
			control_ptr->control_attr.control_enable = FALSE;
			control_ptr->control_attr.control_drawn = FALSE;
			control_ptr->control_attr.control_active = FALSE;
			control_ptr->control_attr.control_visible = FALSE;
			FormDrawForm(FORM_EXPENSE_LIST);
			FormDrawForm(FORM_EXPENSE_TYPE);
			return TRUE;

		case EVT_LIST_SELECT:
			switch(Event->eventID)
			{
				case LIST_EXPENSE_TYPE_LIST1:
					ExpenseSetType((BYTE)Event->para1);
//					ListHighlightStatus = EXPENSE_DATE_HIGHLIGHT;
					ListHighlightStatus = EXPENSE_TYPE_HIGHLIGHT;
					ExpenseSetCatPopupEnable();
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				case LIST_EXPENSE_TYPE_LIST2:
					ExpenseSetType((BYTE)(Event->para1+14));
//					ListHighlightStatus = EXPENSE_DATE_HIGHLIGHT;
					ListHighlightStatus = EXPENSE_TYPE_HIGHLIGHT;
					ExpenseSetCatPopupEnable();
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				default:	return FALSE;
			}

		
		case PEN_EVENT:
			if (Event->eventID == PEN_DOWN)
			{
				if (Event->para1 < 160 && Event->para2 < 160)
				{
					ListHighlightStatus = EXPENSE_TYPE_HIGHLIGHT;

					FormGetObjectPointer(POPUP_EXPENSE_LIST, &object_type, (void**)&control_ptr);
					control_ptr->control_attr.control_enable = TRUE;
					control_ptr->control_attr.control_drawn = TRUE;
					control_ptr->control_attr.control_active = TRUE;
					control_ptr->control_attr.control_visible = TRUE;

					FormPopupForm(FORM_EXPENSE_LIST);
				}
			}
			return TRUE;


		case EVT_INLAY_SELECT:
			switch(Event->para1)
			{	
				case INLAY_OK:
/*
					ListGetSelectedItem(LIST_EXPENSE_TYPE_LIST1, &item_num1);
					ListGetSelectedItem(LIST_EXPENSE_TYPE_LIST2, &item_num2);
					if (item_num1 < 0 && item_num2 > -1)
					{
						ExpenseSetType((BYTE)(item_num2));
						ListHighlightStatus = EXPENSE_DATE_HIGHLIGHT;
					}
					else if(item_num1 > -1 && item_num2 < 0)
					{
						ExpenseSetType((BYTE)(item_num1));
						ListHighlightStatus = EXPENSE_DATE_HIGHLIGHT;
					}
					else
						ListHighlightStatus = EXPENSE_TYPE_HIGHLIGHT;
					
					ExpenseSetCatPopupEnable();
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;
*/
				case INLAY_EXIT:
					ListHighlightStatus = EXPENSE_TYPE_HIGHLIGHT;

					FormGetObjectPointer(POPUP_EXPENSE_LIST, &object_type, (void**)&control_ptr);
					control_ptr->control_attr.control_enable = TRUE;
					control_ptr->control_attr.control_drawn = TRUE;
					control_ptr->control_attr.control_active = TRUE;
					control_ptr->control_attr.control_visible = TRUE;

					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				default:	return FALSE;
			}

	}

	return FALSE;
}


/*****************************************************************
 * Function:	ExpenseCurr
 * Purpose: 	This function is the event handler for the expense
 *				currenices settings page of the expense application
 * Scope:		application/internal
 * Input:		Event			received event
 * Output:		None
 * Return:		TRUE if handled
 *				FALSE if not handled
 * Comment: 	None
******************************************************************/
BOOLEAN ExpenseCurr(EvtType *Event)
{
    BYTE		object_type;
    Control		*control_ptr;
	
	switch(Event->eventType)
	{
		case EVT_FORM_OPEN:
			FormGetObjectPointer(POPUP_EXPENSE_LIST, &object_type, (void**)&control_ptr);
			control_ptr->control_attr.control_enable = FALSE;
			control_ptr->control_attr.control_drawn = FALSE;
			control_ptr->control_attr.control_active = FALSE;
			control_ptr->control_attr.control_visible = FALSE;
			FormDrawForm(FORM_EXPENSE_LIST);
			FormDrawForm(FORM_EXPENSE_CURR);
			return TRUE;

		case EVT_LIST_SELECT:
			switch(Event->eventID)
			{
				case LIST_EXPENSE_CURR_LIST1:
					ExpenseSetCurr((BYTE)Event->para1);
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				case LIST_EXPENSE_CURR_LIST2:
					ExpenseSetCurr((BYTE)(Event->para1+13));
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				default:	return FALSE;
			}

		

		case PEN_EVENT:
			if (Event->eventID == PEN_DOWN)
			{
				if (Event->para1 < 160 && Event->para2 < 160)
				{
					FormGetObjectPointer(POPUP_EXPENSE_LIST, &object_type, (void**)&control_ptr);
					control_ptr->control_attr.control_enable = TRUE;
					control_ptr->control_attr.control_drawn = TRUE;
					control_ptr->control_attr.control_active = TRUE;
					control_ptr->control_attr.control_visible = TRUE;
					FormPopupForm(FORM_EXPENSE_LIST);
				}
			}
			return TRUE;




		case EVT_INLAY_SELECT:
			switch(Event->para1)
			{	
				case INLAY_OK:
/*
					ListGetSelectedItem(LIST_EXPENSE_CURR_LIST1, &item_num1);
					ListGetSelectedItem(LIST_EXPENSE_CURR_LIST2, &item_num2);
					if (item_num1 < 0 && item_num2 > -1)
					{
						ExpenseSetCurr((BYTE)(item_num2));
//						ListHighlightStatus = EXPENSE_DATE_HIGHLIGHT;
					}
					else if(item_num1 > -1 && item_num2 < 0)
					{
						ExpenseSetCurr((BYTE)(item_num1));
//						ListHighlightStatus = EXPENSE_DATE_HIGHLIGHT;
					}
//					else
					ListHighlightStatus = EXPENSE_NO_HIGHLIGHT;
					
					ExpenseSetCatPopupEnable();
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;
*/
				case INLAY_EXIT:
					
					FormGetObjectPointer(POPUP_EXPENSE_LIST, &object_type, (void**)&control_ptr);
					control_ptr->control_attr.control_enable = TRUE;
					control_ptr->control_attr.control_drawn = TRUE;
					control_ptr->control_attr.control_active = TRUE;
					control_ptr->control_attr.control_visible = TRUE;
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				default:	return FALSE;
			}

	}

	return FALSE;
}

/*****************************************************************
 * Function:	ExpenseDialogSave
 * Purpose: 	This function is the event handler for the saving
 *				dialog box of the expense application
 * Scope:		application/internal
 * Input:		Event			received event
 * Output:		None
 * Return:		TRUE if handled
 *				FALSE if not handled
 * Comment: 	None
******************************************************************/
BOOLEAN ExpenseDialogSave(EvtType *Event)
{
	BYTE	*amount_text_ptr;
	double	amount;

	switch(Event->eventType)
	{
		case EVT_FORM_OPEN:
			FormDrawForm(FORM_EXPENSE_DIALOG_SAVE);
			return TRUE;

		case EVT_BITMAP_SELECT:
			switch(Event->eventID)
			{	
				case BITMAP_EXPENSE_DIALOG_SAVE_X:
					dialogX_selected = TRUE;
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				default:	return FALSE;
			}


		case EVT_CONTROL_SELECT:
			switch(Event->eventID)
			{	
				case BUTTON_EXPENSE_DIALOG_SAVE_YES:
					TextboxGetTextPointer(ActiveTextboxID, &amount_text_ptr);
					amount = atod((const char*)amount_text_ptr);
//					dtoa(amount, (char*)sbuf, 2);
//					amount = atod((const char*)sbuf);
					if (amount >= 0.01)
					{
						ExpenseSetAmount(ActiveTextboxID - TEXTBOX_EXPENSE_LIST_AMT1, amount);
						TextboxSetInsertPointOff(ActiveTextboxID);
						ExpenseKeypadInvisible();
						ListHighlightStatus = EXPENSE_TYPE_HIGHLIGHT;
						HighlightRecNumInList =  ActiveTextboxID - TEXTBOX_EXPENSE_LIST_AMT1;
						//FormPopupForm(FORM_EXPENSE_LIST);
						FormDrawForm(FORM_EXPENSE_LIST);
						FormPopupForm(FORM_EXPENSE_TYPE);
					}
					else if(*amount_text_ptr == 0)
					{
						if (DelItemNum < EXPENSE_INVALID_REC_NUM)
						{
							if (ExpenseDeleteExpense(DelItemNum) != TRUE)
								return TRUE;
						}
						ListHighlightStatus = EXPENSE_NO_HIGHLIGHT;
						HighlightRecNumInList = (SHORT)EXPENSE_INVALID_REC_NUM;
						DelItemNum = EXPENSE_INVALID_REC_NUM;
						TextboxSetInsertPointOff(ActiveTextboxID);
						ExpenseKeypadInvisible();
						FormPopupForm(FORM_EXPENSE_LIST);
					}
					else
						TextboxSetInsertPointOn(ActiveTextboxID);

					return TRUE;

				case BUTTON_EXPENSE_DIALOG_SAVE_NO:
					if (ExpenseGetNewExpenseType() == EXPENSE_TYPE)
						if (DelItemNum < EXPENSE_INVALID_REC_NUM)
						{
							if (ExpenseDeleteExpense(DelItemNum) != TRUE)
								return TRUE;
						}
					ExpenseLoadRecord(CatText);
					ExpenseRecordToList(&NewItemNumInList);
					DelItemNum = NewItemNumInList;
					ActiveTextboxID = NewItemNumInList + TEXTBOX_EXPENSE_LIST_AMT1;
					ListHighlightStatus = EXPENSE_NO_HIGHLIGHT;
					HighlightRecNumInList = (SHORT)EXPENSE_INVALID_REC_NUM;
//					ExpenseListSetScrollbar();
					ExpenseSetCatPopupEnable();
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				default:	return FALSE;
			}

		case EVT_INLAY_SELECT:
			switch(Event->para1)
			{	
				case INLAY_OK:
					EvtAppendEvt(EVT_CONTROL_SELECT, BUTTON_EXPENSE_DIALOG_SAVE_YES, 0, 0, NULL);
					FormPopupForm(FORM_EXPENSE_EDCAT);
					return TRUE;

				case INLAY_EXIT:
					dialogX_selected = TRUE;
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				default:	return FALSE;
			}

	}

	return FALSE;
}

/*****************************************************************
 * Function:	ExpenseDialogSelectCat
 * Purpose: 	This function is the event handler for the selecting
 *				category name dialog box of the expense application
 * Scope:		application/internal
 * Input:		Event			received event
 * Output:		None
 * Return:		TRUE if handled
 *				FALSE if not handled
 * Comment: 	None
******************************************************************/
BOOLEAN ExpenseDialogSelectCat(EvtType *Event)
{

	switch(Event->eventType)
	{
		case EVT_FORM_OPEN:
			FormDrawForm(FORM_EXPENSE_DIALOG_SELCAT);
			return TRUE;

		case EVT_BITMAP_SELECT:
			switch(Event->eventID)
			{	
				case BITMAP_EXPENSE_DIALOG_SELCAT_X:
					FormPopupForm(FORM_EXPENSE_EDCAT);
					return TRUE;

				default:	return FALSE;
			}

		case EVT_INLAY_SELECT:
			switch(Event->para1)
			{	
				case INLAY_OK:
				case INLAY_EXIT:
					FormPopupForm(FORM_EXPENSE_EDCAT);
					return TRUE;

				default:	return FALSE;
			}
	}

	return FALSE;
}


/*****************************************************************
 * Function:	ExpenseDialogSelectType
 * Purpose: 	This function is the event handler for the selecting
 *				Expense type dialog box of the expense application
 * Scope:		application/internal
 * Input:		Event			received event
 * Output:		None
 * Return:		TRUE if handled
 *				FALSE if not handled
 * Comment: 	None
******************************************************************/
BOOLEAN ExpenseDialogSelectType(EvtType *Event)
{

	switch(Event->eventType)
	{
		case EVT_FORM_OPEN:
			FormDrawForm(FORM_EXPENSE_DIALOG_SELTYPE);
			return TRUE;

		case EVT_BITMAP_SELECT:
			switch(Event->eventID)
			{	
				case BITMAP_EXPENSE_DIALOG_SELTYPE_X:
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				default:	return FALSE;
			}

		case EVT_INLAY_SELECT:
			switch(Event->para1)
			{	
				case INLAY_OK:
				case INLAY_EXIT:
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				default:	return FALSE;
			}
	}

	return FALSE;
}

/*****************************************************************
 * Function:	ExpenseDialogErase
 * Purpose: 	This function is the event handler for the erase
 *				confirmation dialog box of the expense application
 * Scope:		application/internal
 * Input:		Event			received event
 * Output:		None
 * Return:		TRUE if handled
 *				FALSE if not handled
 * Comment: 	None
******************************************************************/
BOOLEAN ExpenseDialogErase(EvtType *Event)
{

	switch(Event->eventType)
	{
		case EVT_FORM_OPEN:
			FormDrawForm(FORM_EXPENSE_DIALOG_ERASE);
			return TRUE;

		case EVT_CONTROL_SELECT:
			switch(Event->eventID)
			{	
				case BUTTON_EXPENSE_DIALOG_ERASE_YES:
					if (ExpenseDeleteAllExpense())
						FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				case BUTTON_EXPENSE_DIALOG_ERASE_NO:
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				default:	return FALSE;
			}

		case EVT_INLAY_SELECT:
			switch(Event->para1)
			{	
				case INLAY_OK:
					if (ExpenseDeleteAllExpense())
						FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;
				case INLAY_EXIT:
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				default:	return FALSE;
			}
	}

	return FALSE;
}

/*****************************************************************
 * Function:	ExpenseDialogExist
 * Purpose: 	This function is the event handler for the exist
 *				confirmation dialog box of the expense application
 * Scope:		application/internal
 * Input:		Event			received event
 * Output:		None
 * Return:		TRUE if handled
 *				FALSE if not handled
 * Comment: 	None
******************************************************************/
BOOLEAN ExpenseDialogExist(EvtType *Event)
{

	switch(Event->eventType)
	{
		case EVT_FORM_OPEN:
			FormDrawForm(FORM_EXPENSE_DIALOG_EXIST);
			return TRUE;

		case EVT_INLAY_SELECT:
			switch(Event->para1)
			{	
				case INLAY_OK:
					FormPopupForm(FORM_EXPENSE_EDCAT);
					return TRUE;

				case INLAY_EXIT:
					FormPopupForm(FORM_EXPENSE_EDCAT);
					return TRUE;

				default:	return FALSE;
			}

	}

	return FALSE;
}

/*****************************************************************
 * Function:	ExpenseDialogEditCat
 * Purpose: 	This function is the event handler for the edit categories
 *				dialog box of the expense application
 * Scope:		application/internal
 * Input:		Event			received event
 * Output:		None
 * Return:		TRUE if handled
 *				FALSE if not handled
 * Comment: 	None
******************************************************************/
BOOLEAN ExpenseDialogEditCat(EvtType *Event)
{

	BYTE	*textbox_string, *list_string;
	SHORT	num_valid_cat, item_num;
	UBYTE	cat[NUM_FLODERS];
	WORD	char_pos;
	BYTE	unfiled[10];
	DatabaseID	Expense_dbid;


	switch(Event->eventType)
	{
		case EVT_FORM_OPEN:
/*
			KeyboardSetKeyboardVisible();
			FormSetFormActiveObject(FORM_EXPENSE_DIALOG_EDCAT, TEXTBOX_EXPENSE_DIALOG_EDCAT);
			TextboxSetText(TEXTBOX_EXPENSE_DIALOG_EDCAT, null_buf);
			TextboxSetInsertPointOn(TEXTBOX_EXPENSE_DIALOG_EDCAT);
*/
			if (RenameCat == TRUE)
			{
				ListGetSelectedItem(LIST_EXPENSE_EDCAT, &item_num);
				ListGetListItem(LIST_EXPENSE_EDCAT, (USHORT)item_num, &textbox_string);
				FormSetFormActiveObject(FORM_EXPENSE_DIALOG_EDCAT, TEXTBOX_EXPENSE_DIALOG_EDCAT);
				TextboxSetText(TEXTBOX_EXPENSE_DIALOG_EDCAT, textbox_string);
//				TextboxSetInsertPointOn(TEXTBOX_EXPENSE_DIALOG_EDCAT);
				char_pos = strlen(textbox_string);
				TextboxSetInsertPointPositionByCharPos(TEXTBOX_EXPENSE_DIALOG_EDCAT, char_pos);
				TextboxSetHighlightSelection(TEXTBOX_EXPENSE_DIALOG_EDCAT, 0, char_pos);
			}
			else
			{
				FormSetFormActiveObject(FORM_EXPENSE_DIALOG_EDCAT, TEXTBOX_EXPENSE_DIALOG_EDCAT);
				strcpy(unfiled, "Unfiled");
				TextboxSetText(TEXTBOX_EXPENSE_DIALOG_EDCAT, unfiled);
				TextboxSetHighlightSelection(TEXTBOX_EXPENSE_DIALOG_EDCAT, 0, 7);
				TextboxSetInsertPointOff(TEXTBOX_EXPENSE_DIALOG_EDCAT);
			}
			FormDrawForm(FORM_EXPENSE_DIALOG_EDCAT);
			return TRUE;

		
		case EVT_BITMAP_SELECT:
			switch(Event->eventID)
			{	
				case BITMAP_EXPENSE_DIALOG_EDCAT_X:
					FormPopupForm(FORM_EXPENSE_EDCAT);
					RenameCat = FALSE;
					return TRUE;

				default:	return FALSE;
			}

		case EVT_KEY:
		    if (Event->para2 & 0x00000300)
		    	return TRUE;
			if (Event->eventID == SOFT_KEY)
			{
				if (Event->para1 == '\r' || Event->para1 == '\n')
				{
					EvtAppendEvt(EVT_INLAY_SELECT, 0, INLAY_OK, 0, NULL);
					return TRUE;
				}

				TextboxAddKeyInChar(TEXTBOX_EXPENSE_DIALOG_EDCAT, (BYTE)(Event->para1));
				return TRUE;
			}
			break;

		case EVT_INLAY_SELECT:
			switch(Event->para1)
			{	
				case INLAY_OK:
					TextboxGetTextPointer(TEXTBOX_EXPENSE_DIALOG_EDCAT, &textbox_string);
					if (textbox_string[0] == 0)
						return TRUE;
					if (RenameCat == TRUE)
					{
						ListGetSelectedItem(LIST_EXPENSE_EDCAT, &item_num);
						ListGetListItem(LIST_EXPENSE_EDCAT, (USHORT)item_num, &list_string);
						if (!strcmp(list_string, textbox_string))
						{
							FormPopupForm(FORM_EXPENSE_EDCAT);
							RenameCat = FALSE;
							return TRUE;
						}
					}
					if (!ExpenseNewCat(RenameCat))
					{
						FormPopupForm(FORM_EXPENSE_EDCAT);
						FormPopupForm(FORM_EXPENSE_DIALOG_EXIST);
					}
					else if (RenameCat == TRUE)
						FormPopupForm(FORM_EXPENSE_EDCAT);
					else
					{

						if (!DataFindDB((BYTE*)"ExpenseDatabase", &Expense_dbid))
							return TRUE;
						num_valid_cat = DataCategorySort(Expense_dbid, cat);
						if (num_valid_cat == 0)
							return TRUE;
						if (CatHighlightInList > -1)
							ControlPopupSetSelectedItem(POPUP_EXPENSE_LIST, CatHighlightInList + 1);
						else
							ControlPopupSetSelectedItem(POPUP_EXPENSE_LIST, 1);
                        FormPopupForm(FORM_EXPENSE_LIST);
                        EvtAppendEvt(EVT_CONTROL_SELECT, BUTTON_EXPENSE_LIST_NEW, 0, 0, NULL);

					}
					RenameCat = FALSE;
					return TRUE;

				case INLAY_EXIT:
					FormPopupForm(FORM_EXPENSE_EDCAT);
					RenameCat = FALSE;
					return TRUE;

				default:	return FALSE;
			}

	}

	return FALSE;
}

/*****************************************************************
 * Function:	ExpenseDialogRemove
 * Purpose: 	This function is the event handler for the remvoe category
 *				dialog box of the expense application
 * Scope:		application/internal
 * Input:		Event			received event
 * Output:		None
 * Return:		TRUE if handled
 *				FALSE if not handled
 * Comment: 	None
******************************************************************/
BOOLEAN ExpenseDialogRemove(EvtType *Event)
{

	switch(Event->eventType)
	{
		case EVT_FORM_OPEN:
			FormDrawForm(FORM_EXPENSE_DIALOG_REMOVE);
			return TRUE;

		case EVT_CONTROL_SELECT:
			switch(Event->eventID)
			{	
				case BUTTON_EXPENSE_DIALOG_REMOVE_YES:
					if (ExpenseDeleteCat())
						FormPopupForm(FORM_EXPENSE_EDCAT);
					return TRUE;

				case BUTTON_EXPENSE_DIALOG_REMOVE_NO:
					FormPopupForm(FORM_EXPENSE_EDCAT);
					return TRUE;

				default:	return FALSE;
			}

		case EVT_INLAY_SELECT:
			switch(Event->para1)
			{	
				case INLAY_OK:
					if (ExpenseDeleteCat())
						FormPopupForm(FORM_EXPENSE_EDCAT);
					return TRUE;
				case INLAY_EXIT:
					FormPopupForm(FORM_EXPENSE_EDCAT);
					return TRUE;

				default:	return FALSE;
			}
	}


	return FALSE;
}


/*****************************************************************
 * Function:	ExpenseDialogLowMemory
 * Purpose: 	This function is the event handler for the low memory
 *				dialog box of the expense application
 * Scope:		application/internal
 * Input:		Event			received event
 * Output:		None
 * Return:		TRUE if handled
 *				FALSE if not handled
 * Comment: 	None
******************************************************************/
BOOLEAN ExpenseDialogLowMemory(EvtType *Event)
{

	switch(Event->eventType)
	{
		case EVT_FORM_OPEN:
			FormDrawForm(FORM_EXPENSE_DIALOG_LOW_MEMORY);
			return TRUE;

		case EVT_BITMAP_SELECT:
			switch(Event->eventID)
			{		
				case BITMAP_EXPENSE_DIALOG_LOW_MEMORY_X:
					FormPopupForm(G_active_form_id);
					return TRUE;

				default:	return FALSE;
			}


		case EVT_INLAY_SELECT:
			switch(Event->para1)
			{	
				case INLAY_OK:
				case INLAY_EXIT:
					FormPopupForm(G_active_form_id);
					return TRUE;

				default:	return FALSE;
			}

	}


	return FALSE;
}


/*****************************************************************
 * Function:	ExpenseEditCate
 * Purpose: 	This function is the event handler for the edit 
 *				categories page of the expense application
 * Scope:		application/internal
 * Input:		Event			received event
 * Output:		None
 * Return:		TRUE if handled
 *				FALSE if not handled
 * Comment: 	None
******************************************************************/
BOOLEAN ExpenseEditCate(EvtType *Event)
{
	SHORT	item_num, num_valid_cat;
	USHORT	num_items;
	UBYTE	cat[NUM_FLODERS+1];
	BYTE	null_buf[1] = {0}, *item_text;
	AppID	app_id;
	DatabaseID	Expense_dbid;

	switch(Event->eventType)
	{
		case EVT_FORM_OPEN:
			if (LargeFontInEdcat)
				ExpenseSetEdcatListFont(LIST_EXPENSE_EDCAT, MEDIUM_FONT);
			else
				ExpenseSetEdcatListFont(LIST_EXPENSE_EDCAT, SMALL_FONT);
			FormDrawForm(FORM_EXPENSE_EDCAT);
			return TRUE;

		case EVT_MENU_SELECT_ITEM:
			if (Event->para1 == MENU_ITEM_DELETE)
			{
				MenuGetMenuItem(MENU_EXPENSE_EDCAT, MENU_ITEM_FONT, &item_text);
				if (item_text[0] == 'L')
				{
					LargeFontInEdcat = 1;
					ExpenseSetEdcatListFont(LIST_EXPENSE_EDCAT, MEDIUM_FONT);
				}
				else
				{
					LargeFontInEdcat = 0;
					ExpenseSetEdcatListFont(LIST_EXPENSE_EDCAT, SMALL_FONT);
				}
				ListGetNumItemsDisplay(LIST_EXPENSE_EDCAT, &num_items);

				if (num_items > 8)
				{
					/*
					ListGetHighlightedItem(LIST_EXPENSE_EDCAT, &item_num);
					if (item_num > -1)
						ListGetListItem(LIST_EXPENSE_EDCAT, (USHORT)item_num, &item_text);
					else
						ListGetListItem(LIST_EXPENSE_EDCAT, 0, &item_text);
					*/
					ExpenseCatToList((BYTE*)"", FALSE);
					ScrollbarDrawScrollbar(SCROLLBAR_EXPENSE_EDCAT);
				}
				ListDrawList(LIST_EXPENSE_EDCAT);


			}
			return TRUE;


		case EVT_CONTROL_SELECT:
			switch(Event->eventID)
			{	
				case BUTTON_EXPENSE_EDCAT_NEW:
					if (ExpenseCheckMemoryEmpty())
					{
						FormPopupForm(FORM_EXPENSE_DIALOG_LOW_MEMORY);
						return TRUE;
					}
						
					if (!DataFindDB((BYTE*)"ExpenseDatabase", &Expense_dbid))
						return TRUE;
					num_valid_cat = DataCategorySort(Expense_dbid, cat);
					if (num_valid_cat > NUM_FLODERS)
						return TRUE;
					KeyboardSetKeyboardVisible();
					FormSetFormActiveObject(FORM_EXPENSE_DIALOG_EDCAT, TEXTBOX_EXPENSE_DIALOG_EDCAT);
					TextboxSetText(TEXTBOX_EXPENSE_DIALOG_EDCAT, null_buf);
					TextboxSetInsertPointOn(TEXTBOX_EXPENSE_DIALOG_EDCAT);
					FormPopupForm(FORM_EXPENSE_DIALOG_EDCAT);
					return TRUE;

				case BUTTON_EXPENSE_EDCAT_DEL:
					ListGetNumOfItems(LIST_EXPENSE_EDCAT, &num_items);
					if (num_items < 1)
						return TRUE;
					ListGetSelectedItem(LIST_EXPENSE_EDCAT, &item_num);
					if (item_num < 0)	FormPopupForm(FORM_EXPENSE_DIALOG_SELCAT);
					else				FormPopupForm(FORM_EXPENSE_DIALOG_REMOVE);
					return TRUE;

				case BUTTON_EXPENSE_EDCAT_RENAME:
					ListGetNumOfItems(LIST_EXPENSE_EDCAT, &num_items);
					if (num_items < 1)
						return TRUE;
					KeyboardSetKeyboardVisible();
					ListGetSelectedItem(LIST_EXPENSE_EDCAT, &item_num);
					if (item_num < 0)
					{	
						RenameCat = FALSE;
						FormPopupForm(FORM_EXPENSE_DIALOG_SELCAT);
					}
					else
					{
						RenameCat = TRUE;
						FormPopupForm(FORM_EXPENSE_DIALOG_EDCAT);
					}
					return TRUE;
/*
				case BUTTON_EXPENSE_EDCAT_LARGE_FONT:
					LargeFontInEdcat = 1;
					ExpenseSetEdcatListFont(LIST_EXPENSE_EDCAT, MEDIUM_FONT);
					ControlDrawControl(BUTTON_EXPENSE_EDCAT_LARGE_FONT);
					ControlDrawControl(BUTTON_EXPENSE_EDCAT_SMALL_FONT);
					ListDrawList(LIST_EXPENSE_EDCAT);
					return TRUE;

				case BUTTON_EXPENSE_EDCAT_SMALL_FONT:
					LargeFontInEdcat = 0;
					ExpenseSetEdcatListFont(LIST_EXPENSE_EDCAT, SMALL_FONT);
					ControlDrawControl(BUTTON_EXPENSE_EDCAT_LARGE_FONT);
					ControlDrawControl(BUTTON_EXPENSE_EDCAT_SMALL_FONT);
					ListDrawList(LIST_EXPENSE_EDCAT);
					return TRUE;
*/
				default:	return FALSE;
			}

		case EVT_LIST_SELECT:
			if (Event->para1 < 0)
				CatHighlightInList = -1;
			else
			{
				ListGetListItem(LIST_EXPENSE_EDCAT, (USHORT)Event->para1, &CatNameInEdCat);
				CatHighlightInList = ExpenseCatSelectedNameToNum(CatNameInEdCat);
// ----------------------------------------------------------New edit 040299
				ListGetSelectedItem(LIST_EXPENSE_EDCAT, &item_num);
				ListSetHighlightedItem(LIST_EXPENSE_EDCAT, item_num);
				ListDrawList((USHORT)Event->eventID);
// -------------------------------------------------------------------------
			}
			return TRUE;

		case EVT_SCROLLBAR_REPEAT:
			if (Event->para1 == Event->para2)
				return TRUE;
			ExpenseScrollbarSetCat((USHORT)Event->para2);
			FormDrawForm(FORM_EXPENSE_EDCAT);
			return TRUE;

#ifdef PR31700
		case EVT_IO_KEY_CTRL:
			if (Event->eventID == EVT_IO_KEY_PRESS || Event->eventID == EVT_IO_KEY_REPEAT)
            {
                if (Event->para2 == IO_UP_ARROW)
					ScrollbarHardButtonSetScrollbar(SCROLLBAR_EXPENSE_EDCAT, SCROLLBAR_UP_ARROW);
                else if (Event->para2 == IO_DOWN_ARROW)
					ScrollbarHardButtonSetScrollbar(SCROLLBAR_EXPENSE_EDCAT, SCROLLBAR_DOWN_ARROW);
				 return TRUE;
			}
			return FALSE;
#endif


		case EVT_SCROLLBAR_SELECT:
			ExpenseScrollbarSetCat((USHORT)Event->para2);
			FormDrawForm(FORM_EXPENSE_EDCAT);
			return TRUE;

		case EVT_INLAY_SELECT:
			switch(Event->para1)
			{	
				case INLAY_OK:
					ListGetNumOfItems(LIST_EXPENSE_EDCAT, &num_items);
					if (num_items < 1)
					{
#ifdef PR31700
          	SysGetAppID((BYTE*)("Mainmenu"), &app_id);
            EvtAppendEvt(EVT_APP_STOP, 0, 0, 0, NULL);
            EvtAppendEvt(EVT_APP_LAUNCH, app_id, 0, 0, NULL);
#endif
			return TRUE;
					}

					if (!DataFindDB((BYTE*)"ExpenseDatabase", &Expense_dbid))
						return TRUE;
					num_valid_cat = DataCategorySort(Expense_dbid, cat);
					if (num_valid_cat == 0)
						return TRUE;
					if (CatHighlightInList > -1)
						ControlPopupSetSelectedItem(POPUP_EXPENSE_LIST, CatHighlightInList + 1);
					else
						ControlPopupSetSelectedItem(POPUP_EXPENSE_LIST, 1);
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				case INLAY_EXIT:
					ListGetNumOfItems(LIST_EXPENSE_EDCAT, &num_items);
					if (num_items < 1)
					{
#ifdef PR31700
          	SysGetAppID((BYTE*)("Mainmenu"), &app_id);
            EvtAppendEvt(EVT_APP_STOP, 0, 0, 0, NULL);
            EvtAppendEvt(EVT_APP_LAUNCH, app_id, 0, 0, NULL);
#endif

						return TRUE;
					}
					if (!DataFindDB((BYTE*)"ExpenseDatabase", &Expense_dbid))
						return TRUE;
					num_valid_cat = DataCategorySort(Expense_dbid, cat);
					if (num_valid_cat == 0)
						return TRUE;
					if (CatHighlightInList > -1)
						ControlPopupSetSelectedItem(POPUP_EXPENSE_LIST, CatHighlightInList + 1);
					else
						ControlPopupSetSelectedItem(POPUP_EXPENSE_LIST, 1);
					FormPopupForm(FORM_EXPENSE_LIST);
					return TRUE;

				default:	return FALSE;
			}


	}

	return FALSE;
}


/*****************************************************************
 * Function:	ExpenseHandleKeyInStatus
 * Purpose: 	This function is used to handle the status of the data input
 * Scope:		application/internal
 * Input:		Event			received event
 * Output:		None
 * Return:		TRUE if handled
 *				FALSE if not handled
 * Comment: 	None
*****************************************************************/
BOOLEAN ExpenseHandleKeyInStatus(EvtType *Event)
{
	ObjectID	active_form_id;

	if (FormGetActiveFormID(&active_form_id) != TRUE)
		return FALSE;
	if (active_form_id != FORM_EXPENSE_LIST)
		return FALSE;

	if (Event->eventType == EVT_KEY && Event->eventID == SOFT_KEY)	
	{
	    if ((Event->para2 & 0x00000200))
	    	return FALSE;
		Event->para2 &= 0x000000ff;
		if (Event->para2 != 0)
			switch(Event->para2)
			{
				case KEY_UNDO:
					return TRUE;
				case KEY_COPY:
					return TRUE;
				case KEY_PASTE:
					return TRUE;
				case KEY_CUT:
					return TRUE;
				default:
		 			return FALSE;
			}
	}
	else if(Event->eventType == EVT_FIELD_JOT_PASTE_STRING || Event->eventType == EVT_TEXTBOX_JOT_PASTE_STRING)
    {
        pfree(Event->evtPBP);
		return TRUE;
    }

	return FALSE;
}
