/*
================================ COPYRIGHT ================================
The contents of this file are subject to the VTech Informations Ltd. License
of VT-OS Ver. 1.1 operating system (the "License"); you may not use this 
file except in compliance with the License.  
 
Software distributed under the License is distributed on an "AS IS" basis, 
WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
for the specific language governing rights and limitations under the License.
 
The Original Code is VT-OS Ver. 1.1 Operating System, released 
on October 1st, 1999

The Initial Developer of the Original Code is VTech Informations Ltd.  All 
codes are Copyright (C) VTech Informations Ltd. 1999.  All Rights Reserved.
===========================================================================
*/

/*
===========================================================================
File        :   app.c
Author(s)   :   Henry Fok
Company     :   VTech Informations Ltd.
Project     :   Helio 
Date:	    :   October 1st, 1999
Purpose:	:   application c file
Revision    :   1.1
Note        :   None
===========================================================================
*/              



#include "include\app.h"
//#include <emudbg.h>

#define DBG_MESSAGE


#ifdef DEBUG
	char debug_msg[80];
#endif
//#define DEBUG
//#define DEBUG_FIND
//#define DEBUG_GF
//#define DEBUG_SAVE
//#define DEBUG_TYPE

/*****************************************************************
********************** Global Variables **************************
*****************************************************************/
ObjectID        pressed_object = 0;
BYTE            *current_cate = NULL;
BYTE            char_start = 'A';
BYTE            *temp_cate = NULL;
ListDisplay     list_tel_list = {LIST_NAME,0,0,0,0,0};
ListDisplay     list_find = {LIST_FIND_RESULT_NAME,0,0,0,0,0};
AppStatus       app_status = {TEL_LIST,FALSE,FALSE,FALSE,0,FALSE};
BYTE            **field_buffers;
BYTE            *save_cate = NULL;
BYTE            save_first_letter = 'A';
Scroll          virtual_scrollbar;
BYTE            table_font_size = SMALL_FONT, font_size = SMALL_FONT;
BYTE            edit_dirty = 0;
BYTE            find_string[120];
BOOLEAN         draw_scrollbar = TRUE;
BOOLEAN         draw_view_edit_scrollbar = TRUE;
BOOLEAN         gf_entry = FALSE;
ObjectID        gf_in_form_id;
ObjectID        low_memory_form_id;
BOOLEAN	        entry_low_memory;
BOOLEAN	        entry_old_edit;
BOOLEAN			textbox_clear = FALSE;
BOOLEAN			letter_bar = TRUE;
BOOLEAN			bln1,bln2,bln3,bln4,bln5;
BYTE			company[120];


WORD			gTopNum = 0;
WORD			gSelNum = -1;
/********************************************************
 * Function:	TextboxClear
 * Purpose: 	This function is called in order to clear the find
                textbox
 * Scope:		application
 * Input:		none
 * Output:		none
 * Return:		void
 * Comment: 	None
 *********************************************************/
void TextboxClear()
{
	if(textbox_clear)
		return;
	TextboxSetInsertPointPositionByCharPos(TEXTBOX_LOOKUP,0);
	TextboxSetText(TEXTBOX_LOOKUP,"");
	TextboxDrawTextbox(TEXTBOX_LOOKUP);
	textbox_clear = TRUE;
}

/********************************************************
 * Function:	ListCompareNChar
 * Purpose: 	This function is called in order to compare the string bText
				to the listview
 * Scope:		application
 * Input:		none
 * Output:		none
 * Return:		void
 * Comment: 	None
 *********************************************************/
BOOLEAN ListCompareNChar(BYTE *bText, USHORT nPos)
{
	USHORT curr_item = list_tel_list.top_item_num;
	BYTE	*item_text;
	BYTE	start_char,curr_char;
	BOOLEAN blnRetVal = TRUE;
	int i;

	while(1)
	{
		//start at current item and check against first char
		ListDisplayGetText(&list_tel_list, curr_item, &item_text);
		start_char = chartoupper(item_text[0]);
		if(start_char!=char_start)
		{
			qfree(item_text);
			return FALSE;
		}
		//now compare remaining chars
		start_char = chartoupper(bText[nPos]);
		curr_char = chartoupper(item_text[nPos]);
		if(curr_char==start_char)
		{
			for(i=1;i<nPos;i++)
				blnRetVal &= (chartoupper(bText[i])==chartoupper(item_text[i]));
			if(blnRetVal)
				list_tel_list.top_item_num =  curr_item;
			qfree(item_text);
			return blnRetVal;
		}
		curr_item++;
	}
}

/********************************************************
 * Function:	SetScreenLayout
 * Purpose: 	This function is called in order to adjust screen 
				position of UI objects for keyboard
 * Scope:		application
 * Input:		None
 * Output:		None
 * Return:		None
 * Comment: 	None
 *********************************************************/
void SetScreenLayout()
{
	Textbox     *textbox_ptr;
    BYTE        object_type;
    USHORT      item_num;
	ObjectBounds ob;
	
	UISearchForAddress(TEXTBOX_LOOKUP,&object_type,(void**)&textbox_ptr);
	if(KeyboardCheckKeyboardStatus()) //keyboard started
	{
		for(item_num=2;item_num<11;item_num++)
		{
			FormGetObjectBounds(item_num,&ob);
			ob.ycoord -= 60;
			FormSetObjectBounds(item_num,ob);
		}
		FormGetObjectBounds(BUTTON_NEW_RECORD,&ob);
		ob.ycoord -= 60;
		FormSetObjectBounds(BUTTON_NEW_RECORD,ob);
		FormGetObjectBounds(STRING_LOOKUP,&ob);
		ob.ycoord -= 60;
		FormSetObjectBounds(STRING_LOOKUP,ob);
		TextboxGetTextboxBounds(TEXTBOX_LOOKUP,&ob);
		ob.ycoord -= 60;
		textbox_ptr->textbox_insert_pt_y -= 60;	
		TextboxSetBounds(TEXTBOX_LOOKUP,ob);
		FormGetObjectBounds(LIST_NAME,&ob);
		ob.height -= 60;
		FormSetObjectBounds(LIST_NAME,ob);
		FormGetObjectBounds(LIST_PHONENUM,&ob);
		ob.height -= 60;
		FormSetObjectBounds(LIST_PHONENUM,ob);
		FormGetObjectBounds(SCROLLBAR_TEL_LIST,&ob);
		ob.height -= 60;
		FormSetObjectBounds(SCROLLBAR_TEL_LIST,ob);
		ListSetNumItemsDisplay(LIST_NAME,4);
		ListSetNumItemsDisplay(LIST_PHONENUM,4);
		FormGetObjectBounds(BITMAP_PAGE_UP,&ob);
		ob.ycoord -= 60;
		FormSetObjectBounds(BITMAP_PAGE_UP,ob);
		FormGetObjectBounds(BITMAP_PAGE_DN,&ob);
		ob.ycoord -= 60;
		FormSetObjectBounds(BITMAP_PAGE_DN,ob);
		FormGetObjectBounds(BUTTON_LETTER_BAR,&ob);
		ob.ycoord -= 60;
		FormSetObjectBounds(BUTTON_LETTER_BAR,ob);
	}
	else			//keyboard closed
	{
		for(item_num=2;item_num<11;item_num++)
		{
			FormGetObjectBounds(item_num,&ob);
			ob.ycoord += 60;
			FormSetObjectBounds(item_num,ob);
		}
		FormGetObjectBounds(BUTTON_NEW_RECORD,&ob);
		ob.ycoord += 60;
		FormSetObjectBounds(BUTTON_NEW_RECORD,ob);
		FormGetObjectBounds(STRING_LOOKUP,&ob);
		ob.ycoord += 60;
		FormSetObjectBounds(STRING_LOOKUP,ob);
		TextboxGetTextboxBounds(TEXTBOX_LOOKUP,&ob);
		ob.ycoord += 60;
		textbox_ptr->textbox_insert_pt_y += 60;	
		TextboxSetBounds(TEXTBOX_LOOKUP,ob);
		FormGetObjectBounds(LIST_NAME,&ob);
		ob.height += 60;
		FormSetObjectBounds(LIST_NAME,ob);
		FormGetObjectBounds(LIST_PHONENUM,&ob);
		ob.height += 60;
		FormSetObjectBounds(LIST_PHONENUM,ob);
		FormGetObjectBounds(SCROLLBAR_TEL_LIST,&ob);
		ob.height += 60;
		FormSetObjectBounds(SCROLLBAR_TEL_LIST,ob);
		ListSetNumItemsDisplay(LIST_NAME,10);
		ListSetNumItemsDisplay(LIST_PHONENUM,10);
		list_tel_list.max_num_items_display = 10;
		FormGetObjectBounds(BITMAP_PAGE_UP,&ob);
		ob.ycoord += 60;
		FormSetObjectBounds(BITMAP_PAGE_UP,ob);
		FormGetObjectBounds(BITMAP_PAGE_DN,&ob);
		ob.ycoord += 60;
		FormSetObjectBounds(BITMAP_PAGE_DN,ob);
		FormGetObjectBounds(BUTTON_LETTER_BAR,&ob);
		ob.ycoord += 60;
		FormSetObjectBounds(BUTTON_LETTER_BAR,ob);
	}
}

/********************************************************
 * Function:	SetLetterBar
 * Purpose: 	This function is called in order to adjust screen 
				position of UI objects for letterbar
 * Scope:		application
 * Input:		None
 * Output:		None
 * Return:		None
 * Comment: 	None
 *********************************************************/
void SetLetterBar()
{
	ObjectBounds ob;
	USHORT		i;
	Textbox     *textbox_ptr;

	ob.xcoord = 3;
	if(KeyboardCheckKeyboardStatus())
		ob.ycoord = 68;
	else
		ob.ycoord = 128;
	ob.height = 12;
	ob.width = 155;
	LcdEraseRegion(&ob);
	for(i=2;i<11;i++)
	{
		ControlGetAttributes(i,&bln1,&bln2,&bln3,&bln4,&bln5);
		ControlSetAttributes(i,bln1,bln2,bln3,bln4,letter_bar);
		if(letter_bar)
			ControlDrawControl(i);
		else
			ControlEraseControl(i);
		PhonebookStartCharSetTab(-1);
	}
	//now move controls
	if(letter_bar)
	{
		FormGetObjectBounds(LIST_NAME,&ob);
		ob.height -= 12;
		FormSetObjectBounds(LIST_NAME,ob);
		FormGetObjectBounds(LIST_PHONENUM,&ob);
		ob.height -= 12;
		FormSetObjectBounds(LIST_PHONENUM,ob);
		FormGetObjectBounds(SCROLLBAR_TEL_LIST,&ob);
		ob.height -= 12;
		FormSetObjectBounds(SCROLLBAR_TEL_LIST,ob);
		if(KeyboardCheckKeyboardStatus())
		{
			ListSetNumItemsDisplay(LIST_NAME,4);
			ListSetNumItemsDisplay(LIST_PHONENUM,4);
		}
		else
		{
			ListSetNumItemsDisplay(LIST_NAME,10);
			ListSetNumItemsDisplay(LIST_PHONENUM,10);
		}
	}
	else
	{
		FormGetObjectBounds(LIST_NAME,&ob);
		ob.height += 12;
		FormSetObjectBounds(LIST_NAME,ob);
		FormGetObjectBounds(LIST_PHONENUM,&ob);
		ob.height += 12;
		FormSetObjectBounds(LIST_PHONENUM,ob);
		FormGetObjectBounds(SCROLLBAR_TEL_LIST,&ob);
		ob.height += 12;
		FormSetObjectBounds(SCROLLBAR_TEL_LIST,ob);
		if(KeyboardCheckKeyboardStatus())
		{
			ListSetNumItemsDisplay(LIST_NAME,6); //if large font, 5
			ListSetNumItemsDisplay(LIST_PHONENUM,6);
		}
		else
		{
			ListSetNumItemsDisplay(LIST_NAME,12);  //if large font, 11
			ListSetNumItemsDisplay(LIST_PHONENUM,12);
		}
	}
	DisplayScrollbarIfNeeded();
}

void HandleLetterBarLetter(void)
{
    SHORT		item_num;
	BOOLEAN		blnFound = FALSE;

	gSelNum = -1;
	gTopNum = 0;
	TextboxClear();
	if(!PhonebookSetTelListTopItemNum(char_start, 0, FALSE))
	{
		if(!PhonebookSetTelListTopItemNum(char_start + 1, 0, FALSE))
		{
			if(char_start!='Y')
			{
				if(!PhonebookSetTelListTopItemNum(char_start + 2, 0, FALSE))
					PhonebookStartCharSetTab(-1);
				else
					blnFound = TRUE;
			}
			else
				PhonebookStartCharSetTab(-1);
		}
		else
			blnFound = TRUE;
	}
	else
		blnFound = TRUE;

	gTopNum = (blnFound) ? list_tel_list.top_item_num : 0;
	gSelNum = (blnFound) ? 0 : -1;
	ListDrawList(LIST_NAME);
	ListDrawList(LIST_PHONENUM);
}

void PhonebookSelectItem(void)
{
	USHORT item_num;
	UBYTE cate_num;
	BYTE *cate_name;
	
	FormInitAllFormObjects(FORM_VIEW_EDIT);
	PhonebookCateNameToPopupTrigger(pb_dbid);
	ControlPopupDeleteItem(POPUP_TRIGGER_CATE, 0);
	SetStatus(VIEW,FALSE,TRUE,FALSE,app_status.rec_id,FALSE);
	DataRecordInfo(pb_dbid, app_status.rec_id, NULL, &cate_num, NULL, NULL, NULL);
	cate_name = (BYTE*)qmalloc(30*sizeof(BYTE));
	DataCategoryName(pb_dbid, cate_num, cate_name);
	if (ControlPopupFindItemNum(POPUP_TRIGGER_CATE, cate_name, &item_num) == TRUE) 
		ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, (SHORT)item_num);
	else
		ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, 0);
	if (temp_cate != NULL)
		qfree(temp_cate);
	temp_cate = (BYTE*)qmalloc(30*sizeof(BYTE));
	strcpy(temp_cate, cate_name);
	qfree(cate_name);
	PhonebookRecordToFieldBuffers(app_status.rec_id);
	PhonebookFieldBuffersToField();
	if (save_cate != NULL)
		qfree(save_cate);
	save_cate = (BYTE*)qmalloc(30*sizeof(BYTE));
	strcpy (save_cate, current_cate);
	edit_dirty = 0;
	KeyboardSetKeyboardInvisible();
	PhonebookSetViewEditTable(FORM_VIEW_EDIT, TABLE_VIEW_EDIT);
	PhonebookChangeFontSize(FORM_VIEW_EDIT, font_size);
	PhonebookPrepareChangeInfo();
	PhonebookViewEditTableSetScrollbar(TABLE_VIEW_EDIT, SCROLLBAR_VIEW_EDIT);
	PhonebookViewEditSetupScreen();

	FormPopupForm(FORM_VIEW_EDIT);
}

/*****************************************************************
***************** Application Event Handle Function **************
*****************************************************************/
/********************************************************
 * Function:	PhonebookTelList
 * Purpose: 	This function is the event handler for the TEL LIST
				page of the Phonebook application
 * Scope:		application/internal
 * Input:		Event		received event
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookTelList(EvtType* Event)
{
    USHORT      item_num;
    BYTE        *cate_name;
	BYTE		*text_buffer;
    UBYTE       cate_num;
    AppID       appid;
    BYTE        object_type;
    List        *list_ptr;
    ObjectID    pushed_button;
    Scrollbar   *scroll_ptr;
	ObjectBounds	ob;
	WORD		char_pos;
		
	FormObjectSetFocus(TEXTBOX_LOOKUP);
	TextboxSetInsertPointOn(TEXTBOX_LOOKUP);	
	switch (Event->eventType)
	{
		case EVT_MENU_SELECT_ITEM:
			MenuItemSelectedAction1((USHORT)(Event->para1));
			return TRUE;
        case EVT_INLAY_SELECT:
            if (Event->para1 == INLAY_OK || Event->para1 == INLAY_EXIT)
            {
                SysGetAppID((BYTE*)("Mainmenu"), &appid);
                EvtAppendEvt(EVT_APP_STOP, 0, 0, 0, NULL);
                EvtAppendEvt(EVT_APP_LAUNCH, appid, 0, 0, NULL);
            }
            return TRUE;        
		case EVT_LIST_SELECT:
			if (Event->para1 == -1) return TRUE;
			table_font_size = SMALL_FONT;
			TextboxClear();

			gTopNum = Event->para1 + list_tel_list.top_item_num;
			gSelNum = 0;

			ListDisplayGetRecordID(&list_tel_list, (USHORT)(Event->para1 + list_tel_list.top_item_num), &(app_status.rec_id));

			PhonebookSelectItem();

			ListDisplayGetText(&list_tel_list, Event->para1 + list_tel_list.top_item_num, &text_buffer);
			char_start = text_buffer[0];
			return TRUE;
#ifdef PR31700
		case EVT_IO_KEY_CTRL:
			TextboxClear();
             if (Event->eventID == EVT_IO_KEY_PRESS || Event->eventID == EVT_IO_KEY_REPEAT)
             {                
                 if (Event->para2 == IO_UP_ARROW)
                 {
                    if (FormGetObjectPointer(SCROLLBAR_TEL_LIST, &object_type, (void**)&scroll_ptr) != TRUE)
                        return TRUE;
                    if (scroll_ptr->scrollbar_attr.scrollbar_visible &&
                        list_tel_list.total_num_items == 1)
                    {
                        EvtAppendEvt(EVT_SCROLLBAR_REPEAT, SCROLLBAR_TEL_LIST, 0, 0, (void*)scroll_ptr);
                        return TRUE;
                    }                    
                    ScrollbarHardButtonSetScrollbar(SCROLLBAR_TEL_LIST, SCROLLBAR_UP_ARROW);
                 }
                 else if (Event->para2 == IO_DOWN_ARROW)
                     ScrollbarHardButtonSetScrollbar(SCROLLBAR_TEL_LIST, SCROLLBAR_DOWN_ARROW);
				 return TRUE;
			 }
			 return FALSE;
#endif
		case EVT_SCROLLBAR_REPEAT:
            PhonebookScrollbarSetTelList(Event);
			return TRUE;
		case EVT_SCROLLBAR_SELECT:            
			TextboxClear();
            ScrollbarDrawScrollbar(SCROLLBAR_TEL_LIST);
            return TRUE;
		case EVT_CONTROL_POPUP_SELECT:
			TextboxClear();
			gTopNum = 0;
			gSelNum = -1;
			if (PhonebookPopupCateActions((SHORT)(Event->para1)) == TRUE) 
				return TRUE;
			break;
		case EVT_CONTROL_SELECT:
			TextboxClear();
			switch (Event->eventID)
			{	
				case BUTTON_NEW_RECORD:				
					if (MemoryLow || (entry_low_memory && entry_old_edit))
					{
#ifdef DEBUG
						printf("\n NEW_RECORD pressed - Low Memory");
#endif												
						low_memory_form_id = FORM_TEL_LIST;
						FormPopupForm(FORM_PB_LOW_MEMORY);	
						return TRUE;
					}											
					else if (gf_entry && entry_old_edit)
					{
						gf_in_form_id = FORM_TEL_LIST;
						FormPopupForm(FORM_PB_DISCARD_CHANGES);	
						return TRUE;
                    }											    

					table_font_size = SMALL_FONT;
					PhonebookInitFieldBuffers();
					SetStatus(EDIT, FALSE, TRUE, TRUE,0,TRUE);
					FormInitAllFormObjects(FORM_VIEW_EDIT);
				
					if(KeyboardCheckKeyboardStatus())
					{
						KeyboardSetKeyboardStatus(FALSE);
						SetScreenLayout();
					}

					PhonebookCateNameToPopupTrigger(pb_dbid);
					ControlPopupDeleteItem(POPUP_TRIGGER_CATE,0);

					if (ControlPopupFindItemNum(POPUP_TRIGGER_CATE, current_cate, &item_num) == TRUE) 
						ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, (SHORT)item_num);
					else
						ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, 0);

					PhonebookChangeFontSize(FORM_VIEW_EDIT, font_size);
					PhonebookViewEditSetupScreen();
					if (app_status.key_in != TRUE)
						StringSetText(STRING_NAME, (BYTE *)("ABC"));
					else
					{
						FormSetFormActiveObject(FORM_VIEW_EDIT, TEXTBOX_LAST_NAME);
						TextboxSetInsertPointPositionByCharPos(TEXTBOX_LAST_NAME, 0);
						TextboxSetInsertPointOn(TEXTBOX_LAST_NAME);
					}
					if (save_cate != NULL)
						qfree(save_cate);
					save_cate = (BYTE*)qmalloc(30*sizeof(BYTE));
					strcpy (save_cate, (BYTE*)("All"));
					if (temp_cate != NULL)
						qfree(temp_cate);
					temp_cate = (BYTE*)qmalloc(30*sizeof(BYTE));
					strcpy (temp_cate, current_cate);					
                    FormPopupForm(FORM_VIEW_EDIT);
					return TRUE;
				case BUTTON_TEL_LIST_ZOOMIN:
                    PhonebookChangeListFont();
					return TRUE;
				case PUSHBUTTON_ABC:
//					char_start = 32;
					char_start = 'A';
					HandleLetterBarLetter();
					return TRUE;
				case PUSHBUTTON_DEF:
					char_start = 'D';
					HandleLetterBarLetter();
					return TRUE;
				case PUSHBUTTON_GHI:
					char_start = 'G';
					HandleLetterBarLetter();
					return TRUE;
				case PUSHBUTTON_JKL:
					char_start = 'J';
					HandleLetterBarLetter();
					return TRUE;
				case PUSHBUTTON_MNO:
					char_start = 'M';
					HandleLetterBarLetter();
					return TRUE;
				case PUSHBUTTON_PQR:
					char_start = 'P';
					HandleLetterBarLetter();
					return TRUE;
				case PUSHBUTTON_STU:
					char_start = 'S';
					HandleLetterBarLetter();
					return TRUE;
				case PUSHBUTTON_VWX:
					char_start = 'V';
					HandleLetterBarLetter();
					return TRUE;
				case PUSHBUTTON_YZ:
					char_start = 'Y';
					HandleLetterBarLetter();
					return TRUE;
				case BUTTON_LETTER_BAR:
					letter_bar = !letter_bar;
					SetLetterBar();
					ListDisplayDraw(&list_tel_list);
					ListDrawList(LIST_NAME);
					ListDrawList(LIST_PHONENUM);
					break;
				default: 
					return FALSE;
			}
			break;
		case EVT_BITMAP_SELECT:
			switch(Event->eventID)
			{
				case BITMAP_PAGE_UP:
					if(list_tel_list.top_item_num!=0)
					{
						if(list_tel_list.top_item_num < list_tel_list.max_num_items_display)
							list_tel_list.top_item_num = 0;
						else
							list_tel_list.top_item_num -= list_tel_list.max_num_items_display;

 						ListDisplayDraw(&list_tel_list);
						ListDrawList(LIST_NAME);
						ListDrawList(LIST_PHONENUM);
						PhonebookTelListSetScrollbar();
						FormObjectSetFocus(TEXTBOX_LOOKUP);
					}
					break;
				case BITMAP_PAGE_DN:
					if(list_tel_list.top_item_num<(list_tel_list.total_num_items-list_tel_list.max_num_items_display))
					{
						list_tel_list.top_item_num += list_tel_list.max_num_items_display;
 						ListDisplayDraw(&list_tel_list);
						ListDrawList(LIST_NAME);
						ListDrawList(LIST_PHONENUM);
						PhonebookTelListSetScrollbar();
					}
					break;
				default:
					return FALSE;
			}
			FormObjectSetFocus(TEXTBOX_LOOKUP);
			TextboxSetInsertPointOn(TEXTBOX_LOOKUP);	
			return TRUE;
		case EVT_KEY:
			if (Event->eventID == SOFT_KEY && (Event->para2 & 0x300) == 0)
			{
				TextboxAddKeyInChar(TEXTBOX_LOOKUP, (BYTE)(Event->para1));
				textbox_clear = FALSE;
				return TRUE;
			}
			break;
		case EVT_KEYBOARD_STATUS:
			SetScreenLayout();
			ob.xcoord = 3;
			ob.ycoord = 19;
			ob.height = (KeyboardCheckKeyboardStatus()) ? 80 : 137;
			ob.width = 155;
			LcdEraseRegion(&ob);
			for(item_num=2;item_num<11;item_num++)
				ControlDrawControl(item_num);
			ControlDrawControl(BUTTON_NEW_RECORD);
			ControlDrawControl(BUTTON_LETTER_BAR);
			BitmapDrawBitmap(BITMAP_PAGE_UP);
			BitmapDrawBitmap(BITMAP_PAGE_DN);
			StringDrawString(STRING_LOOKUP);
			TextboxDrawTextbox(TEXTBOX_LOOKUP);
			DisplayScrollbarIfNeeded();
			ListDisplayDraw(&list_tel_list);
			ListDrawList(LIST_NAME);
			ListDrawList(LIST_PHONENUM);
			break;
		case EVT_TEXTBOX_CHANGED:
			DBG_MESSAGE("+EVT_TEXTBOX_CHANGED\r\n");
			TextboxGetTextPointer(TEXTBOX_LOOKUP,&text_buffer);
			if(text_buffer)
			{
				if(strlen(text_buffer))
				{
					DBG_MESSAGE(text_buffer);
					char_start = chartoupper(text_buffer[0]);
					if(PhonebookSetTelListTopItemNum(char_start, 0, FALSE))
					{
						if(text_buffer[1]!='\0')
						{
							if(ListCompareNChar(text_buffer,1))
							{
								if(text_buffer[2]!='\0')
								{
									if(ListCompareNChar(text_buffer,2))
									{
										if(text_buffer[3]!='\0')
										{
											if(!ListCompareNChar(text_buffer,3))
												EvtAppendEvt(EVT_KEY,SOFT_KEY,KEY_BACKSPACE,0,NULL);
										}
									}
									else
										EvtAppendEvt(EVT_KEY,SOFT_KEY,KEY_BACKSPACE,0,NULL);
								}
							}
							else
								EvtAppendEvt(EVT_KEY,SOFT_KEY,KEY_BACKSPACE,0,NULL);
						}

    					ListDisplayDraw(&list_tel_list);
						PhonebookTelListSetScrollbar();
						ListSetHighlightedItem(LIST_NAME,0);
						ListSetHighlightedItem(LIST_PHONENUM,0);
						PhonebookStartCharSetTab(char_start);
						gTopNum = list_tel_list.top_item_num;
						gSelNum = 0;

					}
					else
						EvtAppendEvt(EVT_KEY,SOFT_KEY,KEY_BACKSPACE,0,NULL);
				}
				else
				{
					DBG_MESSAGE("ListSetHighlightedItem\r\n");
					ListSetHighlightedItem(LIST_NAME,-1);
					DBG_MESSAGE("ListSetHighlightedItem\r\n");
					ListSetHighlightedItem(LIST_PHONENUM,-1);
					DBG_MESSAGE("PhonebookStartCharSetTab\r\n");
					PhonebookStartCharSetTab(-1);
					list_tel_list.top_item_num = 0;
					gTopNum = 0;
					gSelNum = -1;
				}
				TextboxDrawTextbox(TEXTBOX_LOOKUP);
				ListDrawList(LIST_NAME);
				ListDrawList(LIST_PHONENUM);
			}
			DBG_MESSAGE("-EVT_TEXTBOX_CHANGED\r\n");
			break;
		case EVT_FORM_OPEN:
			KeyboardSetKeyboardVisible();
            FormGetObjectPointer(LIST_NAME, &object_type, (void**)&list_ptr);
            if (list_ptr->list_text_font == SMALL_FONT)
			{
				MenuDeleteItem(MENU_TEL_LIST, 0);
                MenuInsertItem(MENU_TEL_LIST, 0, (BYTE*)("Large Font"));
                ControlSetLabel(BUTTON_TEL_LIST_ZOOMIN, (BYTE*)("Large Font"));
			}
            else
			{			
				MenuDeleteItem(MENU_TEL_LIST, 0);
				MenuInsertItem(MENU_TEL_LIST, 0, (BYTE*)("Small Font"));
 				ControlSetLabel(BUTTON_TEL_LIST_ZOOMIN, (BYTE*)("Small Font"));
			}
			SetStatus(TEL_LIST,FALSE,FALSE,FALSE,app_status.rec_id,FALSE);
			edit_dirty = 0;
			
			if(gSelNum==-1)
			{
				list_tel_list.top_item_num = 0;
				PhonebookStartCharSetTab(-1);
			}
			else
			{
				list_tel_list.top_item_num = gTopNum;
				PhonebookStartCharSetTab(char_start);
			}

			ListSetTopItemNum(LIST_NAME,gTopNum);
			ListSetTopItemNum(LIST_PHONENUM,gTopNum);
			DisplayScrollbarIfNeeded();
			ListSetHighlightedItem(LIST_NAME,gSelNum);
			ListSetHighlightedItem(LIST_PHONENUM,gSelNum);			
			ListDisplayDraw(&list_tel_list);
			PhonebookTelListSetScrollbar();

			FormDrawForm(FORM_TEL_LIST);
			FormObjectSetFocus(TEXTBOX_LOOKUP);
			TextboxSetInsertPointOn(TEXTBOX_LOOKUP);

			return TRUE;
		default:
			return FALSE;
	}
	return FALSE;
}
/********************************************************
 * Function:	PhonebookEditCate
 * Purpose: 	This function is the event handler for the EDIT CATEGORIES
				page of the Phonebook application
 * Scope:		application/internal
 * Input:		Event		received event
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookEditCate(EvtType* Event)
{
	SHORT selected_cate;
	USHORT num_items;
	BYTE *list_string;
	USHORT item_num;
    BYTE        object_type;
    List        *list_ptr;


	if (Event->eventType == EVT_KEY && Event->eventID == SOFT_KEY)
	{
        if ((Event->para2 & 0x00000200))
	    {
	        if (Event->para1 == 'N' || Event->para1 == 'n')
	        {
	            Event->eventType    = EVT_CONTROL_SELECT;
                Event->eventID      = BUTTON_CATE_NEW;
                Event->evtPBP       = NULL;
            }
            else if (Event->para1 == 'D' || Event->para1 == 'd')
            {
	            Event->eventType    = EVT_CONTROL_SELECT;
                Event->eventID      = BUTTON_CATE_DEL;
                Event->evtPBP       = NULL;
            }            	            
            else if (Event->para1 == 'R' || Event->para1 == 'r')
            {
	            Event->eventType    = EVT_CONTROL_SELECT;
                Event->eventID      = BUTTON_CATE_RENAME;
                Event->evtPBP       = NULL;
            }            	                        
            else if (Event->para2 == 0x215 || Event->para2 == 0x21c)
            {           
                ScrollbarHardButtonSetScrollbar(SCROLLBAR_CATE, SCROLLBAR_UP_ARROW);            
                return TRUE;            
            }
            else if (Event->para2 == 0x216 || Event->para2 == 0x21d)
            {           
                ScrollbarHardButtonSetScrollbar(SCROLLBAR_CATE, SCROLLBAR_DOWN_ARROW);            
                return TRUE;            
            }                                
        }       
    }                    

	switch (Event->eventType)
	{
		case EVT_MENU_SELECT_ITEM:
			MenuItemSelectedAction1((USHORT)(Event->para1));
			return TRUE;
#ifdef PR31700
		case EVT_IO_KEY_CTRL:
             if (Event->eventID == EVT_IO_KEY_PRESS || Event->eventID == EVT_IO_KEY_REPEAT)
             {
                 if (Event->para2 == IO_UP_ARROW)
                     ScrollbarHardButtonSetScrollbar(SCROLLBAR_CATE, SCROLLBAR_UP_ARROW);
                 else if (Event->para2 == IO_DOWN_ARROW)
                     ScrollbarHardButtonSetScrollbar(SCROLLBAR_CATE, SCROLLBAR_DOWN_ARROW);
				 return TRUE;
			 }
			 return FALSE;
#endif
		case EVT_SCROLLBAR_SELECT:
            ScrollbarDrawScrollbar(SCROLLBAR_CATE);
			return TRUE;
		case EVT_SCROLLBAR_REPEAT:
            PhonebookScrollbarSetEditCate(Event);
			return TRUE;
		case EVT_INLAY_SELECT:
			//set current_cate to selected cate
			if (Event->para1 == INLAY_OK || Event->para1 == INLAY_EXIT)
			{
				ListGetSelectedItem(LIST_CATE,&item_num);
				if(item_num!=-1)
				{
					ListGetListItem(LIST_CATE, item_num, &list_string);
					strcpy(current_cate,list_string);
				}
				else
					strcpy(current_cate,"All");

				ControlInitControl(POPUP_TRIGGER_CATE);
				PhonebookCateNameToPopupTrigger(pb_dbid);
				if (ControlPopupFindItemNum(POPUP_TRIGGER_CATE, current_cate,&item_num) == TRUE) 
				{
					ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, (SHORT)item_num);
					PhonebookRecordToList(pb_dbid, current_cate, char_start,NULL);
				}
				else
                {
					ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, 0);
					PhonebookRecordToList(pb_dbid, (BYTE*)("All"), 'A',NULL);
				}
  //              PhonebookChangeFontSize(FORM_TEL_LIST, font_size);
  //  			ListDisplayDraw(&list_tel_list);
//				ListGetAttribute(LIST_NAME, &enable, &drawn, &active, &visible, &set_scroll);
//				ListSetAttribute(LIST_NAME, enable, drawn, active, TRUE, set_scroll);
//				ListGetAttribute(LIST_PHONENUM, &enable, &drawn, &active, &visible, &set_scroll);
//				ListSetAttribute(LIST_PHONENUM, enable, drawn, active, TRUE, set_scroll);
//				PhonebookTelListSetScrollbar();
//				ListDrawList(LIST_NAME);
//				ListDrawList(LIST_PHONENUM);
				if (app_status.status == TEL_LIST)
				{	
					FormPopupForm(FORM_TEL_LIST);
					return TRUE;
				}
				else if (app_status.status == EDIT || app_status.status == VIEW)
				{
					FormPopupForm(FORM_VIEW_EDIT);
					return TRUE;
				}
			}
			return FALSE;		
		case EVT_CONTROL_SELECT:
			switch (Event->eventID)
			{	
				case BUTTON_CATE_NEW:				
					if (MemoryLow || (entry_low_memory && entry_old_edit))
					{
#ifdef DEBUG
						printf("\n NEW_RECORD pressed - Low Memory");
#endif												
						low_memory_form_id = FORM_EDIT_CATE;
						FormPopupForm(FORM_PB_LOW_MEMORY);	
						return TRUE;
					}											
				
					ListGetNumOfItems(LIST_CATE,&num_items);
					if (num_items == 255)
						FormPopupForm(FORM_CATE_FULL);
					else
					{				
						TextboxSetText(TEXTBOX_INPUT_CATE,(BYTE*)(""));
						TextboxSetLeftCharPos(TEXTBOX_INPUT_CATE, 0);
						TextboxSetRightCharPos(TEXTBOX_INPUT_CATE, -1);
						TextboxSetInsertPointPositionByCharPos(TEXTBOX_INPUT_CATE,0);
						FormSetFormActiveObject(FORM_INPUT_CATE,TEXTBOX_INPUT_CATE);
						pressed_object = BUTTON_CATE_NEW;
                        FormPopupForm(FORM_INPUT_CATE);
					}
					break;
				case BUTTON_CATE_DEL:			
					ListGetNumOfItems(LIST_CATE,&num_items);
					if (num_items == 0) return TRUE;
					ListGetSelectedItem(LIST_CATE, &selected_cate);
					if (selected_cate != -1)
					{
						if (DeleteCateCheck(selected_cate) == TRUE) return TRUE;
					}
					else
					{
						FormPopupForm(FORM_NO_CATE);
						return TRUE;
					}
					break;
				case BUTTON_CATE_RENAME:
					if (MemoryLow || (entry_low_memory && entry_old_edit))
					{
#ifdef DEBUG
						printf("\n NEW_RECORD pressed - Low Memory");
#endif												
						low_memory_form_id = FORM_EDIT_CATE;
						FormPopupForm(FORM_PB_LOW_MEMORY);	
						return TRUE;
					}											
				
					ListGetSelectedItem(LIST_CATE, &selected_cate);
					if (selected_cate != -1)
					{
						TextboxInitTextbox(TEXTBOX_INPUT_CATE);
						ListGetListItem(LIST_CATE,(USHORT)selected_cate, &list_string);
						TextboxSetText(TEXTBOX_INPUT_CATE, list_string);
						TextboxSetInsertPointPositionByCharPos(TEXTBOX_INPUT_CATE,strlen(list_string));
						TextboxSetInsertPointOn(TEXTBOX_INPUT_CATE);
						FormSetFormActiveObject(FORM_INPUT_CATE,TEXTBOX_INPUT_CATE);
						pressed_object = BUTTON_CATE_RENAME;
                        FormPopupForm(FORM_INPUT_CATE);
						return TRUE;
					}
					else
					{
						FormPopupForm(FORM_NO_CATE);
						return TRUE;
					}
					break;
                case BUTTON_CATE_ZOOMIN:
                    PhonebookChangeListFont();
                    break;
				default: return FALSE;
			}
			break;
        case EVT_LIST_SELECT:
            ListSetHighlightedItem(LIST_CATE, (SHORT)(Event->para1));
            ListDrawList(LIST_CATE);
            return TRUE;
		case EVT_FORM_OPEN:
			if (FormCheckObjectExists(SCROLLBAR_CATE) == FALSE)
				ScrollbarInitScrollbar(SCROLLBAR_CATE);
			PhonebookEditCateSetScrollbar();
            FormGetObjectPointer(LIST_CATE, &object_type, (void**)&list_ptr);
            if (list_ptr->list_text_font == SMALL_FONT)
			{
				MenuDeleteItem(MENU_EDIT_CATE, 0);
                MenuInsertItem(MENU_EDIT_CATE, 0, (BYTE*)("Large Font"));
                ControlSetLabel(BUTTON_CATE_ZOOMIN, (BYTE*)("Large Font"));
			}
            else
			{			
				MenuDeleteItem(MENU_EDIT_CATE, 0);
				MenuInsertItem(MENU_EDIT_CATE, 0, (BYTE*)("Small Font"));			
				ControlSetLabel(BUTTON_CATE_ZOOMIN, (BYTE*)("Small Font"));
			}
			FormDrawForm(FORM_EDIT_CATE);
			return TRUE;
		default:
			return FALSE;
	}
	return FALSE;
}
/********************************************************
 * Function:	PhonebookInputCate
 * Purpose: 	This function is the event handler for the INPUT CATEGORIES
				page of the Phonebook application
 * Scope:		application/internal
 * Input:		Event		received event
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookInputCate(EvtType *Event)
{
	ObjectID tempID;

	if (Event->eventType == EVT_KEY && Event->eventID == SOFT_KEY)
	{
        if ((Event->para2 & 0x00000200))
	    {
	        if (Event->para1 == 'X' || Event->para1 == 'x')
	        {
	            Event->eventType    = EVT_BITMAP_SELECT;
                Event->eventID      = 0;
                Event->evtPBP       = NULL;
            }
        }       
    }                    
	
	switch (Event->eventType)
	{
		case EVT_MENU_SELECT_ITEM:
			MenuItemSelectedAction((USHORT)(Event->para1));
			return TRUE;
		case EVT_INLAY_SELECT:
			switch (Event->para1)
			{
				case INLAY_OK:
					if (InputCatCheckCharIn() == TRUE) return TRUE;
					break;
				case INLAY_EXIT:
					FormPopupForm(FORM_EDIT_CATE);
					return TRUE;
				default: return FALSE;
			}
			break;
		case EVT_KEY:
			if (Event->eventID == SOFT_KEY && (Event->para2 & 0x300) == 0)
			{
				FormGetActiveObject(FORM_INPUT_CATE,&tempID);
				if (tempID == TEXTBOX_INPUT_CATE) 
				{
					if ((BYTE)(Event->para1) == 13 && (InputCatCheckCharIn() == TRUE)) return TRUE;
					else TextboxAddKeyInChar(TEXTBOX_INPUT_CATE, (BYTE)(Event->para1));
					return TRUE;
				}
			}
			break;
		case EVT_BITMAP_SELECT:
			PhonebookEditCateSetScrollbar();
			FormPopupForm(FORM_EDIT_CATE);
			return TRUE;
		case EVT_FORM_OPEN:
			FormDrawForm(FORM_INPUT_CATE);
			return TRUE;
		default:
			return FALSE;
	}
	return FALSE;
}

/********************************************************
 * Function:	PhonebookNoCate
 * Purpose: 	This function is the event handler for the NO CATEGORY SELECTED
				page of the Phonebook application
 * Scope:		application/internal
 * Input:		Event		received event
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookNoCate(EvtType* Event)
{
	if (Event->eventType == EVT_KEY && Event->eventID == SOFT_KEY)
	{
        if ((Event->para2 & 0x00000200))
	    {
	        if (Event->para1 == 'X' || Event->para1 == 'x')
	        {
	            Event->eventType    = EVT_BITMAP_SELECT;
                Event->eventID      = 0;
                Event->evtPBP       = NULL;
            }
        }       
    }                    	
	
	switch (Event->eventType)
	{
		case EVT_INLAY_SELECT:
			if (Event->para1 == INLAY_EXIT || Event->para1 == INLAY_OK)
			{
				FormPopupForm(FORM_EDIT_CATE);
				return TRUE;
			}
			break;
		case EVT_BITMAP_SELECT:
			FormPopupForm(FORM_EDIT_CATE);
			return TRUE;
		case EVT_FORM_OPEN:
			FormDrawForm(FORM_NO_CATE);
			return TRUE;
		default:
			return FALSE;
	}
	return FALSE;
}

/********************************************************
 * Function:	PhonebookNameExists
 * Purpose: 	This function is the event handler for the CATEGORY ALREADY EXISTS
				page of the Phonebook application
 * Scope:		application/internal
 * Input:		Event		received event
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookNameExists(EvtType *Event)
{
	if (Event->eventType == EVT_KEY && Event->eventID == SOFT_KEY)
	{
        if ((Event->para2 & 0x00000200))
	    {
	        if (Event->para1 == 'X' || Event->para1 == 'x')
	        {
	            Event->eventType    = EVT_BITMAP_SELECT;
                Event->eventID      = 0;
                Event->evtPBP       = NULL;
            }
        }       
    }                    

	switch (Event->eventType)
	{
		case EVT_INLAY_SELECT:
			if (Event->para1 == INLAY_EXIT || Event->para1 == INLAY_OK)
			{
				TextboxSetInsertPointOn(TEXTBOX_INPUT_CATE);
				TextboxDrawTextbox(TEXTBOX_INPUT_CATE);
				FormSetFormActiveObject(FORM_INPUT_CATE,TEXTBOX_INPUT_CATE);
				FormPopupForm(FORM_EDIT_CATE);
				FormPopupForm(FORM_INPUT_CATE);
				return TRUE;
			}
			break;
		case EVT_BITMAP_SELECT:
			TextboxSetInsertPointOn(TEXTBOX_INPUT_CATE);
			TextboxDrawTextbox(TEXTBOX_INPUT_CATE);
			FormSetFormActiveObject(FORM_INPUT_CATE,TEXTBOX_INPUT_CATE);
			FormPopupForm(FORM_EDIT_CATE);
			FormPopupForm(FORM_INPUT_CATE);
			return TRUE;
		case EVT_FORM_OPEN:
			FormDrawForm(FORM_CATE_NAME_EXISTS);
			return TRUE;
		default:
			return FALSE;
	}
	return FALSE;
}

/********************************************************
 * Function:	PhonebookEraseCate
 * Purpose: 	This function is the event handler for the ERASE CATEGORY
				page of the Phonebook application
 * Scope:		application/internal
 * Input:		Event		received event
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookEraseCate(EvtType *Event)
{
	SHORT selected_item;

	if (Event->eventType == EVT_KEY && Event->eventID == SOFT_KEY)
	{
        if ((Event->para2 & 0x00000200))
	    {
	        if (Event->para1 == 'Y' || Event->para1 == 'y')
	        {
	            Event->eventType    = EVT_CONTROL_SELECT;
                Event->eventID      = BUTTON_ERASE_CATE_YES;
                Event->evtPBP       = NULL;
            }
            else if (Event->para1 == 'N' || Event->para1 == 'n')
            {
	            Event->eventType    = EVT_CONTROL_SELECT;
                Event->eventID      = BUTTON_ERASE_CATE_NO;
                Event->evtPBP       = NULL;
            }            	            
        }       
    }                    

	
	switch (Event->eventType)
	{
		case EVT_CONTROL_SELECT:
			if (Event->eventID == BUTTON_ERASE_CATE_YES)
			{	
				ListGetSelectedItem(LIST_CATE,&selected_item);
				if (DeleteCate(selected_item) == TRUE)
				{
					FormPopupForm(FORM_EDIT_CATE);
					return TRUE;
				}
				else break;
			}
			else if (Event->eventID == BUTTON_ERASE_CATE_NO)
				FormPopupForm(FORM_EDIT_CATE);
			return TRUE;
		case EVT_FORM_OPEN:
			FormDrawForm(FORM_ERASE_CATE);
			return TRUE;
		default:
			return FALSE;
	}
	return FALSE;
}

/********************************************************
 * Function:	PhonebookRemoveCate
 * Purpose: 	This function is the event handler for the REMOVE CATEGORY
				page of the Phonebook application
 * Scope:		application/internal
 * Input:		Event		received event
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookRemoveCate(EvtType *Event)
{
	SHORT selected_item;
	
	if (Event->eventType == EVT_KEY && Event->eventID == SOFT_KEY)
	{
        if ((Event->para2 & 0x00000200))
	    {
	        if (Event->para1 == 'Y' || Event->para1 == 'y')
	        {
	            Event->eventType    = EVT_CONTROL_SELECT;
                Event->eventID      = BUTTON_REMOVE_CATE_YES;
                Event->evtPBP       = NULL;
            }
            else if (Event->para1 == 'N' || Event->para1 == 'n')
            {
	            Event->eventType    = EVT_CONTROL_SELECT;
                Event->eventID      = BUTTON_REMOVE_CATE_NO;
                Event->evtPBP       = NULL;
            }            	            
        }       
    }                    
	
	
	switch (Event->eventType)
	{
		case EVT_CONTROL_SELECT:
			if (Event->eventID == BUTTON_REMOVE_CATE_YES)
			{	
				ListGetSelectedItem(LIST_CATE,&selected_item);
				if (DeleteCate(selected_item) == TRUE)
				{
					FormPopupForm(FORM_EDIT_CATE);
					return TRUE;
				}
				else break;
			}
			else if (Event->eventID == BUTTON_REMOVE_CATE_NO)
				FormPopupForm(FORM_EDIT_CATE);
			return TRUE;
		case EVT_FORM_OPEN:
			FormDrawForm(FORM_REMOVE_CATE);
			return TRUE;
		default:
			return FALSE;
	}
	return FALSE;
}

/********************************************************
 * Function:	PhonebookCateFull
 * Purpose: 	This function is the event handler for the CATEGORY FULL
				page of the Phonebook application
 * Scope:		application/internal
 * Input:		Event		received event
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookCateFull(EvtType *Event)
{
	if (Event->eventType == EVT_KEY && Event->eventID == SOFT_KEY)
	{
        if ((Event->para2 & 0x00000200))
	    {
	        if (Event->para1 == 'X' || Event->para1 == 'x')
	        {
	            Event->eventType    = EVT_BITMAP_SELECT;
                Event->eventID      = 0;
                Event->evtPBP       = NULL;
            }
        }       
    }                    


	switch (Event->eventType)
	{
		case EVT_INLAY_SELECT:
			if (Event->para1 == INLAY_EXIT || Event->para1 == INLAY_OK)
			{
				FormPopupForm(FORM_EDIT_CATE);
				return TRUE;
			}
			break;
		case EVT_BITMAP_SELECT:
			FormPopupForm(FORM_EDIT_CATE);
			return TRUE;
		case EVT_FORM_OPEN:
			FormDrawForm(FORM_CATE_FULL);
			return TRUE;
		default:
			return FALSE;
	}
	return FALSE;
}

/********************************************************
 * Function:	PhonebookFindBackground
 * Purpose: 	This function is called to handle the event occured in the 
				FIND BACKGROUND screen of phonebook application
 * Scope:		application/internal
 * Input:		Event		received event
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookFindBackground(EvtType *Event)
{
	switch (Event->eventType)
	{
		case EVT_INLAY_SELECT:
			if (Event->para1 == INLAY_EXIT || Event->para1 == INLAY_OK)
			{
				FormPopupForm(FORM_TEL_LIST);
				return TRUE;
			}
			break;
		case EVT_FORM_OPEN:
			FormDrawForm(FORM_FIND_BACKGROUND);
			return TRUE;
		default:
			return FALSE;
	}
	return FALSE;
}

/********************************************************
 * Function:	PhonebookFindInput
 * Purpose: 	This function is called to handle the event occured in the 
				FIND INPUT screen of phonebook application
 * Scope:		application/internal
 * Input:		Event		received event
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookFindInput(EvtType *Event)
{
	ObjectID tempID;
    BYTE *textbox_string;
    BYTE    object_type;
    Textbox *textbox_ptr;



	if (Event->eventType == EVT_KEY && Event->eventID == SOFT_KEY)
	{
        if ((Event->para2 & 0x00000200))
	    {
	        if (Event->para1 == 'X' || Event->para1 == 'x')
	        {
	            Event->eventType    = EVT_BITMAP_SELECT;
                Event->eventID      = 0;
                Event->evtPBP       = NULL;
            }
        }            
    }                    


	switch (Event->eventType)
	{
		case EVT_MENU_SELECT_ITEM:
			MenuItemSelectedAction((USHORT)(Event->para1));
			return TRUE;
		case EVT_INLAY_SELECT:
			if (Event->para1 == INLAY_EXIT)
			{
                PhonebookChangeFontSize(FORM_TEL_LIST, font_size);
                FormPopupForm(FORM_TEL_LIST);
				return TRUE;
			}
			else if (Event->para1 == INLAY_OK)
			{
				if (InputFindCharInCheck() == TRUE) 
					return TRUE;
				break;
			}
			break;
		case EVT_KEY:
			if (Event->eventID == SOFT_KEY && (Event->para2 & 0x300) == 0)
			{
				FormGetActiveObject(FORM_FIND_INPUT,&tempID);
				if (tempID == TEXTBOX_FIND_INPUT) 
				{
					if ((BYTE)(Event->para1) == 13 && (InputFindCharInCheck() == TRUE)) return TRUE;
					else TextboxAddKeyInChar(TEXTBOX_FIND_INPUT, (BYTE)(Event->para1));
					return TRUE;
				}
			}
			break;
		case EVT_BITMAP_SELECT:
            PhonebookChangeFontSize(FORM_TEL_LIST, font_size);
			FormPopupForm(FORM_TEL_LIST);
			return TRUE;
		case EVT_FORM_OPEN:
			FormSetFormActiveObject(FORM_FIND_INPUT, TEXTBOX_FIND_INPUT);
            TextboxGetTextPointer(TEXTBOX_FIND_INPUT, &textbox_string);
            FormGetObjectPointer(TEXTBOX_FIND_INPUT, &object_type, (void**)&textbox_ptr);
            if (strlen(textbox_string) == 0)
            {
                TextboxSetInsertPointOn(TEXTBOX_FIND_INPUT);
                TextboxSetInsertPointPositionByCharPos(TEXTBOX_FIND_INPUT, 0);
                textbox_ptr->textbox_attr.textbox_highlight = FALSE;
            }
            else
            {
                TextboxSetInsertPointOff(TEXTBOX_FIND_INPUT);
                TextboxSetInsertPointPositionByCharPos(TEXTBOX_FIND_INPUT, 0);
                TextboxSetLeftCharPos(TEXTBOX_FIND_INPUT, 0);
                TextboxSetRightCharPos(TEXTBOX_FIND_INPUT, -1);
                textbox_ptr->textbox_attr.textbox_highlight = TRUE;
                TextboxSetHighlightSelection(TEXTBOX_FIND_INPUT, 0, strlen(textbox_string));
            }
			FormDrawForm(FORM_FIND_INPUT);
			return TRUE;
		default:
			return FALSE;
	}
	return FALSE;
}

/********************************************************
 * Function:	PhonebookNotFound
 * Purpose: 	This function is called to handle the event occured in the 
				NOT FOUND screen of phonebook application
 * Scope:		application/internal
 * Input:		Event		received event
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookNotFound(EvtType *Event)
{
	if (Event->eventType == EVT_KEY && Event->eventID == SOFT_KEY)
	{
        if ((Event->para2 & 0x00000200))
	    {
	        if (Event->para1 == 'N' || Event->para1 == 'n')
	        {
	            Event->eventType    = EVT_BITMAP_SELECT;
                Event->eventID      = 0;
                Event->evtPBP       = NULL;
            }
        }
    }                    
	
	
	switch (Event->eventType)
	{
		case EVT_INLAY_SELECT:
			if (Event->para1 == INLAY_EXIT || Event->para1 == INLAY_OK)
			{
				FormPopupForm(FORM_FIND_BACKGROUND);
				FormPopupForm(FORM_FIND_INPUT);
				return TRUE;
			}
			break;
		case EVT_BITMAP_SELECT:
			FormPopupForm(FORM_FIND_BACKGROUND);
			FormPopupForm(FORM_FIND_INPUT);
			return TRUE;
		case EVT_FORM_OPEN:
			FormDrawForm(FORM_NOT_FOUND);
			return TRUE;
		default:
			return FALSE;
	}
	return FALSE;
}

/********************************************************
 * Function:	PhonebookFindResult
 * Purpose: 	This function is called to handle the event occured in the 
				FIND RESULT screen of phonebook application
 * Scope:		application/internal
 * Input:		Event		received event
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookFindResult(EvtType *Event)
{
	USHORT item_num;
	UBYTE cate_num;
	BYTE *cate_name;
    BYTE    object_type;
    Textbox *textbox_ptr;
	List	*list_ptr;
	
	if (Event->eventType == EVT_KEY && Event->eventID == SOFT_KEY)
	{
        if ((Event->para2 & 0x00000200))
	    {
	        if (Event->para1 == 'N' || Event->para1 == 'n')
	        {
	            Event->eventType    = EVT_CONTROL_SELECT;
                Event->eventID      = BUTTON_FIND_RESULT_NEW;
                Event->evtPBP       = NULL;
            }
            else if (Event->para1 == 'X' || Event->para1 == 'x')
            {
	            Event->eventType    = EVT_BITMAP_SELECT;
                Event->eventID      = 0;
                Event->evtPBP       = NULL;
            }            	            
            else if (Event->para2 == 0x215 || Event->para2 == 0x21c)
            {           
                ScrollbarHardButtonSetScrollbar(SCROLLBAR_FIND_RESULT, SCROLLBAR_UP_ARROW);            
                return TRUE;            
            }
            else if (Event->para2 == 0x216 || Event->para2 == 0x21d)
            {           
                ScrollbarHardButtonSetScrollbar(SCROLLBAR_FIND_RESULT, SCROLLBAR_DOWN_ARROW);            
                return TRUE;            
            }                                
        }       
    }                    
	
	switch(Event->eventType)
	{
		case EVT_MENU_SELECT_ITEM:
			MenuItemSelectedAction1((USHORT)(Event->para1));
			return TRUE;
		case EVT_LIST_SELECT:
			if (Event->para1 == -1) return TRUE;
			table_font_size = SMALL_FONT;

			ListDisplayGetRecordID(&list_find, (USHORT)(Event->para1 + list_find.top_item_num), &(app_status.rec_id));

			PhonebookSelectItem();

			return TRUE;
#ifdef PR31700
		case EVT_IO_KEY_CTRL:
             if (Event->eventID == EVT_IO_KEY_PRESS || Event->eventID == EVT_IO_KEY_REPEAT)
             {
                 if (Event->para2 == IO_UP_ARROW)
             	    ScrollbarHardButtonSetScrollbar(SCROLLBAR_FIND_RESULT, SCROLLBAR_UP_ARROW);
                 else if (Event->para2 == IO_DOWN_ARROW)
                	ScrollbarHardButtonSetScrollbar(SCROLLBAR_FIND_RESULT, SCROLLBAR_DOWN_ARROW);
				 return TRUE;
			 }
			 return FALSE;
#endif
		case EVT_SCROLLBAR_SELECT:
            ScrollbarDrawScrollbar(SCROLLBAR_FIND_RESULT);
			return TRUE;
		case EVT_SCROLLBAR_REPEAT:
            PhonebookScrollbarSetFindResult(Event);
            return TRUE;
		case EVT_INLAY_SELECT:
			if (Event->para1 == INLAY_OK || Event->para1 == INLAY_EXIT)
			{
                PhonebookChangeFontSize(FORM_TEL_LIST, font_size);
				FormPopupForm(FORM_TEL_LIST);
				return TRUE;
			}
			break;
		case EVT_CONTROL_SELECT:
			if (Event->eventID == BUTTON_FIND_RESULT_NEW)
			{
				FormEraseForm(FORM_FIND_RESULT);
				TextboxSetText(TEXTBOX_FIND_INPUT, (BYTE *)(""));
				TextboxSetInsertPointPositionByCharPos(TEXTBOX_FIND_INPUT, 0);
				TextboxSetInsertPointOn(TEXTBOX_FIND_INPUT);
				FormPopupForm(FORM_FIND_INPUT);
			}
			else if (Event->eventID == BUTTON_FIND_RESULT_ZOOMIN)
                PhonebookChangeListFont();                
			return TRUE;
		case EVT_BITMAP_SELECT:
			FormEraseForm(FORM_FIND_RESULT);
            FormGetObjectPointer(TEXTBOX_FIND_INPUT, &object_type, (void**)&textbox_ptr);
            TextboxSetInsertPointOff(TEXTBOX_FIND_INPUT);
            TextboxSetInsertPointPositionByCharPos(TEXTBOX_FIND_INPUT, 0);
            TextboxSetLeftCharPos(TEXTBOX_FIND_INPUT, 0);
            TextboxSetRightCharPos(TEXTBOX_FIND_INPUT, -1);
            textbox_ptr->textbox_attr.textbox_highlight = TRUE;
            TextboxSetHighlightSelection(TEXTBOX_FIND_INPUT, 0, strlen(textbox_ptr->textbox_string));
			FormPopupForm(FORM_FIND_INPUT);
			return TRUE;
		case EVT_FORM_OPEN:
            FormGetObjectPointer(LIST_FIND_RESULT_NAME, &object_type, (void**)&list_ptr);
            if (list_ptr->list_text_font == SMALL_FONT)
			{
				MenuDeleteItem(MENU_FIND_RESULT, 0);
                MenuInsertItem(MENU_FIND_RESULT, 0, (BYTE*)("Large Font"));
                ControlSetLabel(BUTTON_FIND_RESULT_ZOOMIN, (BYTE*)("Large Font"));
			}
            else
			{			
				MenuDeleteItem(MENU_FIND_RESULT, 0);
				MenuInsertItem(MENU_FIND_RESULT, 0, (BYTE*)("Small Font"));
 				ControlSetLabel(BUTTON_FIND_RESULT_ZOOMIN, (BYTE*)("Small Font"));
			}		
			FormDrawForm(FORM_FIND_RESULT);
			return TRUE;
		default: return FALSE;
	}
	return FALSE;
}

/********************************************************
 * Function:	PhonebookReturnToTelList
 * Purpose: 	This function is helper to save, then 
				return to list view
 * Scope:		application/internal
 * Input:		None
 * Output:		None
 * Return:		BOOLEAN True if ok to save
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookReturnSaveToTelList()
{
	BYTE object_type;
    BOOLEAN         control_value;
	void *addr;
    USHORT          item_num;

	if (PhonebookViewEditCheckEmptyFields() == TRUE)
	{
		if (app_status.new_record == FALSE)
		{
			FormGetControlValue(CHECKBOX_ADD_ERASE, &control_value);
			DataDeleteRecord(pb_dbid,app_status.rec_id, control_value);
		}							
		ListSetSelectedItem(LIST_NAME, -1);
		ListSetSelectedItem(LIST_PHONENUM, -1);
		FormGetObjectPointer(POPUP_TRIGGER_CATE, &object_type, (void **)&addr);
		((Control*)addr)->control_attr.control_visible = TRUE;
		((Control*)addr)->control_attr.control_enable = TRUE;
		PhonebookCateNameToPopupTrigger(pb_dbid);
		if (ControlPopupFindItemNum(POPUP_TRIGGER_CATE, current_cate, &item_num) == FALSE) 
			item_num = 0;
		ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, (SHORT)item_num);
		PhonebookPopupCateActions(item_num);
		PhonebookRecordToList(pb_dbid, current_cate, char_start, (BYTE*)(""));
		PhonebookChangeFontSize(FORM_TEL_LIST, font_size);
		FormPopupForm(FORM_TEL_LIST);
		return TRUE;
	}
	else if (strlen(field_buffers[2]) != 0) 
	{
		PhonebookSaveRecord(pb_dbid, app_status.rec_id, app_status.new_record);
		strcpy(current_cate, save_cate);
		ListSetSelectedItem(LIST_NAME, -1);
		ListSetSelectedItem(LIST_PHONENUM, -1);
		char_start = save_first_letter;
		FormGetObjectPointer(POPUP_TRIGGER_CATE, &object_type, (void **)&addr);

		((Control*)addr)->control_attr.control_enable = TRUE;
		PhonebookCateNameToPopupTrigger(pb_dbid);
		if (ControlPopupFindItemNum(POPUP_TRIGGER_CATE, current_cate, &item_num) == FALSE) 
			item_num = 0;
		ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, (SHORT)item_num);

		if (ControlPopupFindItemNum(POPUP_TRIGGER_CATE, current_cate,&item_num) == TRUE) 
		{
			ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, (SHORT)item_num);
			PhonebookRecordToList(pb_dbid, current_cate, char_start, field_buffers[2]);
		}
		else
		{
			ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, 0);
			PhonebookRecordToList(pb_dbid, (BYTE*)("All"), 'A',NULL);
		}

		PhonebookClearFieldBuffers();
		PhonebookChangeFontSize(FORM_TEL_LIST, font_size);
		FormPopupForm(FORM_TEL_LIST);
		return TRUE;
	}
	else
	{
		//need first/last name
		return FALSE;
	}
}

/********************************************************
 * Function:	PhonebookReturnToTelList
 * Purpose: 	This function is helper to return to list view
 * Scope:		application/internal
 * Input:		None
 * Output:		None
 * Return:		None
 * Comment: 	None
 *********************************************************/
void PhonebookReturnToTelList()
{
	BYTE object_type;
	void *addr;
    USHORT          item_num;

	PhonebookClearFieldBuffers();
	ListSetSelectedItem(LIST_NAME, -1);
	ListSetSelectedItem(LIST_PHONENUM, -1);
	FormGetObjectPointer(POPUP_TRIGGER_CATE, &object_type, (void **)&addr);
	((Control*)addr)->control_attr.control_enable = TRUE;
	((Control*)addr)->control_attr.control_visible = TRUE;
	PhonebookCateNameToPopupTrigger(pb_dbid);
	if (ControlPopupFindItemNum(POPUP_TRIGGER_CATE, current_cate, &item_num) == TRUE) 
		ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, (SHORT)item_num);
	else
		ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, 0);
	KeyboardSetKeyboardVisible();
	PhonebookRecordToList(pb_dbid, current_cate, char_start, (BYTE*)(""));
	PhonebookChangeFontSize(FORM_TEL_LIST, font_size);
	FormPopupForm(FORM_TEL_LIST);
}

/********************************************************
 * Function:	PhonebookViewEdit
 * Purpose: 	This function is the event handler for the VIEW EDIT
				page of the Phonebook application
 * Scope:		application/internal
 * Input:		Event		received event
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookViewEdit(EvtType *Event)
{
    ObjectID        tempID;
    BYTE            object_type;
    void            *addr;
    SHORT           xcoord,ycoord;
    USHORT          item_num;
    BYTE            *textbox_string, *textbox_string1, *string;
    void            *addr1, *addr2;
    USHORT          selected_item, popup_total_num_items;
    BYTE            *item_text, *whole_name;
    List            *list_ptr;
    Control         *control_ptr;
	ObjectBounds	ob;
	WORD			f_char_pos;
	WORD			l_char_pos;

	if (Event->eventType == EVT_KEY && Event->eventID == SOFT_KEY)
	{
        if (app_status.status == VIEW)
        {
            if ((Event->para2 & 0x00000200))
	        {
	            if (Event->para1 == 'D' || Event->para1 == 'd')
	            {
	                if (FormGetObjectPointer(BUTTON_VIEW_DEL, &object_type, (void**)&control_ptr) == TRUE)
	                {
	                    if (control_ptr->control_attr.control_visible)
	                    {
	                        Event->eventType    = EVT_CONTROL_SELECT;
                            Event->eventID      = BUTTON_VIEW_DEL;
                            Event->evtPBP       = NULL;
                        }                        
                    }                        
                }
                else if (Event->para1 == 'S' || Event->para1 == 's')
                {
  	                if (FormGetObjectPointer(BUTTON_VIEW_HOME, &object_type, (void**)&control_ptr) == TRUE)
  	                {
	                    if (control_ptr->control_attr.control_visible)
                        {
	                        Event->eventType    = EVT_CONTROL_SELECT;
                            Event->eventID      = BUTTON_VIEW_HOME;
                            Event->evtPBP       = NULL;
                        }                        
                    }                        
                }
                else if (Event->para1 == '0')
                {
                    ControlPopupPopupTrigger(POPUP_TRIGGER_CATE);
                    return TRUE;
                }            	                                           	            
                else if (Event->para2 == 0x215 || Event->para2 == 0x21c)
                {           
                    ScrollbarHardButtonSetScrollbar(SCROLLBAR_VIEW_EDIT, SCROLLBAR_UP_ARROW);            
                    return TRUE;            
                }
                else if (Event->para2 == 0x216 || Event->para2 == 0x21d)
                {           
                    ScrollbarHardButtonSetScrollbar(SCROLLBAR_VIEW_EDIT, SCROLLBAR_DOWN_ARROW);            
                    return TRUE;            
                }                                    
                
            }       
        }
        else
        {
            if ((Event->para2 & 0x00000200))
	        {           
	            if (Event->para1 == 'D' || Event->para1 == 'd')
	            {
	                if (FormGetObjectPointer(BUTTON_VIEW_DEL, &object_type, (void**)&control_ptr) == TRUE)
	                {
	                    if (control_ptr->control_attr.control_visible)
	                    {
	                        Event->eventType    = EVT_CONTROL_SELECT;
                            Event->eventID      = BUTTON_VIEW_DEL;
                            Event->evtPBP       = NULL;
                        }                        
                    }                        
                }
//                else if (Event->para1 == 'S' || Event->para1 == 's')
//                {
//					//switch views
//					if(app_status.status==VIEW)
//					{
//						ControlGetPushedPushButton(FORM_VIEW_EDIT,4,&tempID);
//					}
//                }
                else if (Event->para2 == 0x215 || Event->para2 == 0x21c)
                {           
                    ScrollbarHardButtonSetScrollbar(SCROLLBAR_VIEW_EDIT, SCROLLBAR_UP_ARROW);            
                    return TRUE;            
                }
                else if (Event->para2 == 0x216 || Event->para2 == 0x21d)
                {           
                    ScrollbarHardButtonSetScrollbar(SCROLLBAR_VIEW_EDIT, SCROLLBAR_DOWN_ARROW);            
                    return TRUE;            
                }                                                   
            }                
        }               
    }                    


	switch(Event->eventType)
	{
		case EVT_TEXTBOX_MODIFIED:	
		case EVT_FIELD_MODIFIED:
			edit_dirty = 1;
			return TRUE;
		case EVT_MENU_SELECT_ITEM:
			if(Event->para1==MENU_ITEM_ZOOM)
			{
				if((app_status.status == EDIT)&&(app_status.home==TRUE))
				{
					TextboxGetInsertPointPosition(TEXTBOX_LAST_NAME,&l_char_pos);
					TextboxGetInsertPointPosition(TEXTBOX_FIRST_NAME,&f_char_pos);
				}
				TableEraseTable(TABLE_VIEW_EDIT);
				ScrollbarEraseScrollbar(SCROLLBAR_VIEW_EDIT);
			}

			MenuItemSelectedAction((USHORT)(Event->para1));

			if(Event->para1==MENU_ITEM_ZOOM)
			{
				PhonebookFieldToFieldBuffer();
				TableSetTopRowNum(TABLE_VIEW_EDIT, 0);
				for (tempID = FIELD_ROW0; tempID <= FIELD_ROW11; tempID ++)
					FieldSetTopLineNum(tempID, 0);
				TableSetTopRowNum(TABLE_VIEW_EDIT, 0);
				PhonebookFieldBuffersToField();
				PhonebookViewEditSetupScreen();
				PhonebookSetViewEditTable(FORM_VIEW_EDIT, TABLE_VIEW_EDIT);
				PhonebookViewEditTableSetScrollbar(TABLE_VIEW_EDIT, SCROLLBAR_VIEW_EDIT);
				TableDrawTable(TABLE_VIEW_EDIT);
				ScrollbarDrawScrollbar(SCROLLBAR_VIEW_EDIT);

				//special case, if focus on TEXTBOX_LAST_NAME or TEXTBOX_FIRST_NAME, set back
				if((app_status.status == EDIT)&&(app_status.home==TRUE))
				{
					if(l_char_pos!=-1)
					{
						TextboxSetInsertPointPositionByCharPos(TEXTBOX_LAST_NAME,l_char_pos);
						TextboxDrawTextbox(TEXTBOX_LAST_NAME);
					}
					else if(f_char_pos!=-1)
					{
						TextboxSetInsertPointPositionByCharPos(TEXTBOX_FIRST_NAME,f_char_pos);
						TextboxDrawTextbox(TEXTBOX_FIRST_NAME);
					}

				}

			}
			return TRUE;
#ifdef PR31700
		case EVT_IO_KEY_CTRL:
             if (Event->eventID == EVT_IO_KEY_PRESS || Event->eventID == EVT_IO_KEY_REPEAT)
             {
                 if (Event->para2 == IO_UP_ARROW)
                    ScrollbarHardButtonSetScrollbar(SCROLLBAR_VIEW_EDIT, SCROLLBAR_UP_ARROW);
                 else if (Event->para2 == IO_DOWN_ARROW)
                    ScrollbarHardButtonSetScrollbar(SCROLLBAR_VIEW_EDIT, SCROLLBAR_DOWN_ARROW);
				 return TRUE;
			 }
			 return FALSE;
#endif
		case EVT_SCROLLBAR_SELECT:
            ScrollbarDrawScrollbar(SCROLLBAR_VIEW_EDIT);
			break;
		case EVT_SCROLLBAR_REPEAT:
            PhonebookScrollbarSetViewEditTable(TABLE_VIEW_EDIT, SCROLLBAR_VIEW_EDIT, Event);
			break;
		case EVT_FIELD_CHANGED:
			PhonebookViewEditSetupScreen();
			if (PhonebookKeyInChangeViewEditTable(FORM_VIEW_EDIT, TABLE_VIEW_EDIT, SCROLLBAR_VIEW_EDIT))
				TableDrawTable(TABLE_VIEW_EDIT);
			break;
		case EVT_CONTROL_POPUP_SELECT:
			gSelNum = -1;
			gTopNum = 0;
			ControlPopupGetTotalItems(POPUP_TRIGGER_CATE, &popup_total_num_items);
			ControlPopupGetPopupItem(POPUP_TRIGGER_CATE, (USHORT)(Event->para1), &item_text);
			selected_item = (USHORT)(Event->para1);
			if (popup_total_num_items == ((USHORT)selected_item + 1))
				PhonebookPopupCateActions((USHORT)(selected_item));
			else
			{
				if (temp_cate != NULL)
					qfree(temp_cate);
				temp_cate = (BYTE*)qmalloc(30*sizeof(BYTE));
				strcpy(temp_cate, item_text);
			}
            edit_dirty = 1;
			return TRUE;
		case PEN_EVENT:
			DBG_MESSAGE("PEN_EVENT\r\n");
			if ((Event->eventID == PEN_DOWN) && (app_status.status==VIEW) && ((SHORT)Event->para1 > 4 ) && ((SHORT)Event->para1 <155) && ((SHORT)Event->para2 > 15) && ((SHORT)Event->para2 < 141))
			{
				if (MemoryLow || (entry_low_memory && entry_old_edit))
				{
					low_memory_form_id = FORM_VIEW_EDIT;
					FormPopupForm(FORM_PB_LOW_MEMORY);
					return TRUE;
				}			  		
				else if (gf_entry && entry_old_edit)
				{
					gf_in_form_id = FORM_VIEW_EDIT;
					FormPopupForm(FORM_PB_DISCARD_CHANGES);
					return TRUE;
				}			  					    
				EvtAppendEvt(EVT_CONTROL_SELECT,BUTTON_EDIT_HOME_COMPANY,0,0,NULL);
			}
			return TRUE;
		case EVT_KEYBOARD_STATUS:
			DBG_MESSAGE("EVT_KEYBOARD_STATUS\r\n");
			TableSetTopRowNum(TABLE_VIEW_EDIT, 0);
			PhonebookViewEditSetupScreen();
			PhonebookSetViewEditTable(FORM_VIEW_EDIT, TABLE_VIEW_EDIT);
			PhonebookViewEditTableSetScrollbar(TABLE_VIEW_EDIT, SCROLLBAR_VIEW_EDIT);
			FormGetObjectPointer(TABLE_VIEW_EDIT, &object_type, (void **)&addr);
			//before repaint, clean up
			ob.xcoord = 0;
			ob.width = 160;
			ob.ycoord = (KeyboardCheckKeyboardStatus()) ? ((Table*)addr)->bounds.ycoord : 151;
			ob.height = (KeyboardCheckKeyboardStatus()) ? (99 - ((Table*)addr)->bounds.ycoord) : 6;
			LcdEraseRegion(&ob);
			TableDrawTable(TABLE_VIEW_EDIT);
			ScrollbarDrawScrollbar(SCROLLBAR_VIEW_EDIT);
			return TRUE;
		case EVT_KEY:
			if (Event->eventID == SOFT_KEY && app_status.status == EDIT && (Event->para2 & 0x300) == 0)
			{             
				FormGetActiveObject(FORM_VIEW_EDIT,&tempID);
				switch(tempID)
				{
					case TEXTBOX_LAST_NAME:
					case TEXTBOX_FIRST_NAME:
						if ((BYTE)(Event->para1) != 13)
							TextboxAddKeyInChar(tempID, (BYTE)(Event->para1));
						break;
					case FIELD_ROW0:
					case FIELD_ROW1:
					case FIELD_ROW2:
					case FIELD_ROW3:
					case FIELD_ROW4:
					case FIELD_ROW5:
					case FIELD_ROW6:
					case FIELD_ROW7:
					case FIELD_ROW8:
					case FIELD_ROW9:
					case FIELD_ROW10:
					case FIELD_ROW11:
						FieldAddKeyInChar(tempID, (BYTE)(Event->para1));
						break;
				}
				return TRUE;
			}
			break;
		case EVT_CONTROL_SELECT:
			if (Event->eventID == BUTTON_EDIT_HOME_COMPANY)
			{
				if (MemoryLow || (entry_low_memory && entry_old_edit))
				{
					low_memory_form_id = FORM_VIEW_EDIT;
					FormPopupForm(FORM_PB_LOW_MEMORY);
					return TRUE;
				}			  		
				else if (gf_entry && entry_old_edit)
				{
					DBG_MESSAGE("popup discard changes dialog\r\n");
					gf_in_form_id = FORM_VIEW_EDIT;
					FormPopupForm(FORM_PB_DISCARD_CHANGES);
					return TRUE;
				}			  					    
			  
				KeyboardSetKeyboardVisible();
				PhonebookFieldBuffersToField();
				TableSetTopRowNum(TABLE_VIEW_EDIT, 0);
				for (tempID = FIELD_ROW0; tempID <= FIELD_ROW11; tempID ++)
					FieldSetTopLineNum(tempID, 0);
				SetStatus(EDIT, TRUE, FALSE, FALSE ,app_status.rec_id,FALSE);
				TableSetTopRowNum(TABLE_VIEW_EDIT, 0);
				PhonebookFieldBuffersToField();
				PhonebookViewEditSetupScreen();
				PhonebookPrepareChangeInfo();
				PhonebookSetViewEditTable(FORM_VIEW_EDIT, TABLE_VIEW_EDIT);
				PhonebookViewEditTableSetScrollbar(TABLE_VIEW_EDIT, SCROLLBAR_VIEW_EDIT);
				//this is hack to get personal edit set from personal view
				ControlGetCheckedCheckbox(FORM_VIEW_EDIT,4,&tempID);
				TableSetTopRowNum(TABLE_VIEW_EDIT, 0);
				PhonebookFieldToFieldBuffer();
				SetStatus(EDIT, (tempID==BUTTON_VIEW_COMPANY), (tempID==BUTTON_VIEW_HOME), app_status.key_in ,app_status.rec_id,app_status.new_record);
				PhonebookFieldBuffersToField();
				PhonebookViewEditSetupScreen();
				PhonebookSetViewEditTable(FORM_VIEW_EDIT, TABLE_VIEW_EDIT);
				PhonebookViewEditTableSetScrollbar(TABLE_VIEW_EDIT, SCROLLBAR_VIEW_EDIT);
				if(tempID==BUTTON_VIEW_HOME)
					FormSetControlGroupSelection(FORM_VIEW_EDIT, PUSHBUTTON_HINFO);

				FormDrawForm(FORM_VIEW_EDIT);
				return TRUE;
			}
			else if (Event->eventID == BUTTON_DEL_HOME_COMPANY)
			{
				FormPopupForm(FORM_ADD_ERASE);
				return TRUE;
			}
			else if ((Event->eventID == PUSHBUTTON_HINFO)||(Event->eventID == PUSHBUTTON_CINFO))
			{
				if(((app_status.home==TRUE)&&(Event->eventID == PUSHBUTTON_HINFO))||
				   ((app_status.company==TRUE)&&(Event->eventID == PUSHBUTTON_CINFO)))
				   return TRUE;
				TableGetTopRowNum(TABLE_VIEW_EDIT,&item_num);
				if(item_num!=0)
					TableSetTopRowNum(TABLE_VIEW_EDIT,0);
				PhonebookFieldToFieldBuffer();
				SetStatus(EDIT, (Event->eventID == PUSHBUTTON_CINFO), (Event->eventID == PUSHBUTTON_HINFO), app_status.key_in ,app_status.rec_id,app_status.new_record);
			    PhonebookFieldBuffersToField();
				PhonebookViewEditSetupScreen();
				PhonebookViewEditTableSetScrollbar(TABLE_VIEW_EDIT, SCROLLBAR_VIEW_EDIT);
				PhonebookPrepareChangeInfo();
				KeyboardSetKeyboardVisible();
				PhonebookSetViewEditTable(FORM_VIEW_EDIT, TABLE_VIEW_EDIT);
				FormDrawForm(FORM_VIEW_EDIT);
				if (KeyboardCheckKeyboardStatus())
					KeyboardDrawKeyboard();

				FormSetFormActiveObject(FORM_VIEW_EDIT, FIELD_ROW0);
				FieldSetInsertPointOn(FIELD_ROW0);
				FieldSetInsertPointPositionByCharPos(FIELD_ROW0, 0);

				return TRUE;
			}
			else if (Event->eventID == BUTTON_VIEW_COMPANY)
			{
				if((app_status.company==TRUE)&&(app_status.status==VIEW))
				   return TRUE;
				TableSetTopRowNum(TABLE_VIEW_EDIT, 0);
				SetStatus(VIEW, TRUE, FALSE, FALSE ,app_status.rec_id,FALSE);
				PhonebookFieldBuffersToField();
				PhonebookViewEditSetupScreen();
				PhonebookPrepareChangeInfo();
				PhonebookSetViewEditTable(FORM_VIEW_EDIT, TABLE_VIEW_EDIT);
				PhonebookViewEditTableSetScrollbar(TABLE_VIEW_EDIT, SCROLLBAR_VIEW_EDIT);
				FormDrawForm(FORM_VIEW_EDIT);
				return TRUE;
			}
			else if (Event->eventID == BUTTON_VIEW_HOME)
			{
				if((app_status.home==TRUE)&&(app_status.status==VIEW))
				   return TRUE;
				TableSetTopRowNum(TABLE_VIEW_EDIT, 0);
				SetStatus(VIEW, FALSE, TRUE, FALSE ,app_status.rec_id,FALSE);
				PhonebookFieldBuffersToField();
				PhonebookViewEditSetupScreen();
				PhonebookPrepareChangeInfo();
				PhonebookSetViewEditTable(FORM_VIEW_EDIT, TABLE_VIEW_EDIT);
				PhonebookViewEditTableSetScrollbar(TABLE_VIEW_EDIT, SCROLLBAR_VIEW_EDIT);
				FormDrawForm(FORM_VIEW_EDIT);
				return TRUE;
			}
			break;
		case EVT_INLAY_SELECT:
			if (app_status.status == VIEW)
			{
				if ((Event->para1 == INLAY_OK) || (Event->para1 == INLAY_EXIT))
				{
					PhonebookReturnToTelList();
					return TRUE;
				}
			}
			else if (app_status.status == EDIT)
			{
                PhonebookFieldToFieldBuffer();
				if (Event->para1 == INLAY_OK)
				{
					if(PhonebookReturnSaveToTelList()==FALSE)
						FormPopupForm(FORM_ALERT);
					return TRUE;
				}
				else if (Event->para1 == INLAY_EXIT)
				{
					if (PhonebookViewEditCheckEmptyFields() == TRUE || edit_dirty == 0)
					{
						if (app_status.new_record == TRUE || edit_dirty == 0)
						{
							whole_name = (BYTE*)qmalloc(200 * sizeof(BYTE));
                            FormGetObjectPointer(LIST_NAME, &object_type, (void**)&list_ptr);
                            if (ListGetListItem(LIST_NAME, 0, &item_text) &&
                                list_ptr->list_attr.list_drawn)
								strcpy(whole_name, item_text);
							else 
								strcpy(whole_name, (BYTE*)(""));
							ListSetSelectedItem(LIST_NAME, -1);
							ListSetSelectedItem(LIST_PHONENUM, -1);
							FormGetObjectPointer(POPUP_TRIGGER_CATE, &object_type, (void **)&addr);
							((Control*)addr)->control_attr.control_enable = TRUE;
							PhonebookCateNameToPopupTrigger(pb_dbid);
							if (ControlPopupFindItemNum(POPUP_TRIGGER_CATE, current_cate, &item_num) == TRUE) 
								ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, (SHORT)item_num);
							else
								ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, 0);
							if (ControlPopupFindItemNum(POPUP_TRIGGER_CATE, current_cate,
								&item_num) == TRUE) 
							{
								ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, (SHORT)item_num);
								PhonebookRecordToList(pb_dbid, current_cate, char_start, whole_name);
							}
							else
							{
								ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, 0);
								PhonebookRecordToList(pb_dbid, (BYTE*)("All"), 'A', NULL);
							}
							qfree(whole_name);
							PhonebookClearFieldBuffers();
                            PhonebookChangeFontSize(FORM_TEL_LIST, font_size);
							FormPopupForm(FORM_TEL_LIST);
						}
						else
						{
							FormPopupForm(FORM_ADD_ERASE);
							return TRUE;
						}
					}
					else
					{
						PhonebookFieldToFieldBuffer();
						FormPopupForm(FORM_SAVE_CHANGES);
					}
					return TRUE;
				}
			}
			break;
		case EVT_FORM_OPEN:
			PhonebookSetViewEditTable(FORM_VIEW_EDIT, TABLE_VIEW_EDIT);
			PhonebookViewEditTableSetScrollbar(TABLE_VIEW_EDIT, SCROLLBAR_VIEW_EDIT);
			FormDrawForm(FORM_VIEW_EDIT);
			return TRUE;
		default: 
			return FALSE;
	}
	return FALSE;
}

/********************************************************
 * Function:	PhonebookAddErase
 * Purpose: 	This function is the event handler for the ADDRESS ERASE
				page of the Phonebook application
 * Scope:		application/internal
 * Input:		Event		received event
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookAddErase(EvtType *Event)
{
	BOOLEAN control_value;
	USHORT item_num;
	BYTE object_type;
	void *addr;

	if (Event->eventType == EVT_KEY && Event->eventID == SOFT_KEY)
	{
        if ((Event->para2 & 0x00000200))
	    {
	        if (Event->para1 == 'Y' || Event->para1 == 'y')
	        {
	            Event->eventType    = EVT_CONTROL_SELECT;
                Event->eventID      = BUTTON_ADD_ERASE_YES;
                Event->evtPBP       = NULL;
            }
            else if (Event->para1 == 'N' || Event->para1 == 'n')
            {
	            Event->eventType    = EVT_CONTROL_SELECT;
                Event->eventID      = BUTTON_ADD_ERASE_NO;
                Event->evtPBP       = NULL;
            }            	            
        }       
    }                    


	switch(Event->eventType)
	{
		case EVT_CONTROL_SELECT:
			if (Event->eventID == BUTTON_ADD_ERASE_YES)
			{
				gTopNum = 0;
				gSelNum = -1;
				FormGetControlValue(CHECKBOX_ADD_ERASE, &control_value);
                DataCloseRecord(pb_dbid,app_status.rec_id);
				DataDeleteRecord(pb_dbid,app_status.rec_id, control_value);
				ListSetSelectedItem(LIST_NAME, -1);
				ListSetSelectedItem(LIST_PHONENUM, -1);
				FormGetObjectPointer(POPUP_TRIGGER_CATE, &object_type, (void **)&addr);
				((Control*)addr)->control_attr.control_visible = TRUE;
				((Control*)addr)->control_attr.control_enable = TRUE;
				PhonebookCateNameToPopupTrigger(pb_dbid);
				if (ControlPopupFindItemNum(POPUP_TRIGGER_CATE, current_cate, &item_num) == TRUE) 
					ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, (SHORT)item_num);
				else
				{
					item_num = 0;
					ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, 0);
				}
				PhonebookPopupCateActions(item_num);
                PhonebookChangeFontSize(FORM_TEL_LIST, font_size);
				FormPopupForm(FORM_TEL_LIST);
				return TRUE;
			}
			else if (Event->eventID == BUTTON_ADD_ERASE_NO)
			{
                PhonebookChangeFontSize(FORM_VIEW_EDIT, font_size);
				FormPopupForm(FORM_VIEW_EDIT);
				return TRUE;
			}
			break;
		case EVT_FORM_OPEN:
			FormDrawForm(FORM_ADD_ERASE);
			return TRUE;
		default: return FALSE;
	}
	return FALSE;
}

/********************************************************
 * Function:	PhonebookSaveChanges
 * Purpose: 	This function is the event handler for the SAVE CHANGES
				page of the Phonebook application
 * Scope:		application/internal
 * Input:		Event		received event
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookSaveChanges(EvtType *Event)
{
	BYTE        object_type;
	USHORT      item_num;
	void        *addr;
	BYTE        *starting_string = NULL;
	
	if (Event->eventType == EVT_KEY && Event->eventID == SOFT_KEY)
	{
        if ((Event->para2 & 0x00000200))
	    {
	        if (Event->para1 == 'Y' || Event->para1 == 'y')
	        {
	            Event->eventType    = EVT_CONTROL_SELECT;
                Event->eventID      = BUTTON_SAVE_CHANGES_YES;
                Event->evtPBP     = NULL;
            }
            else if (Event->para1 == 'N' || Event->para1 == 'n')
            {
	            Event->eventType    = EVT_CONTROL_SELECT;
                Event->eventID        = BUTTON_SAVE_CHANGES_NO;
                Event->evtPBP     = NULL;
            }            	            
            else if (Event->para1 == 'X' || Event->para1 == 'x')
            {
	            Event->eventType    = EVT_BITMAP_SELECT;
                Event->eventID      = BITMAP_SAVE_CHANGES;
                Event->evtPBP       = NULL;
            }            	            
        }
    }                    

	switch(Event->eventType)
	{
		case EVT_CONTROL_SELECT:
			if (Event->eventID == BUTTON_SAVE_CHANGES_YES)
			{
				if(PhonebookReturnSaveToTelList()==FALSE)
					FormPopupForm(FORM_ALERT);
			}
			else
				PhonebookReturnToTelList();
			break;
		case EVT_BITMAP_SELECT:
			FormPopupForm(FORM_VIEW_EDIT);
			break;
		case EVT_FORM_OPEN:
			FormDrawForm(FORM_SAVE_CHANGES);
			break;
		default: 
			return FALSE;
	}
	return TRUE;
}

/********************************************************
 * Function:	PhonebookLowMemoryHandle
 * Purpose: 	This function is the event handler for the FORM_PB_LOW_MEMORY
				page of the Phonebook application
 * Scope:		application/internal
 * Input:		Event		received event
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookLowMemoryHandle(EvtType* Event)
{

	if (Event->eventType == EVT_KEY && Event->eventID == SOFT_KEY)
	{
        if ((Event->para2 & 0x00000200))
	    {
	        if (Event->para1 == 'X' || Event->para1 == 'x')
	        {
	            Event->eventType    = EVT_BITMAP_SELECT;
                Event->eventID      = 0;
                Event->evtPBP       = NULL;
            }
        }
    }                    

    
	switch (Event->eventType)
	{
		case EVT_BITMAP_SELECT:	
			switch (low_memory_form_id)
			{
				case FORM_VIEW_EDIT:
                    FormPopupForm(FORM_VIEW_EDIT);            				
					break;
				case FORM_TEL_LIST:
					FormPopupForm(FORM_TEL_LIST);								
					break;				
				case FORM_EDIT_CATE:				
					FormPopupForm(FORM_EDIT_CATE);				
					break;
				default:
					break;				
			}			
			break;
		case EVT_INLAY_SELECT:
			if (Event->para1 == INLAY_OK || Event->para2 == INLAY_EXIT)
			{
                switch (low_memory_form_id)
                {
                    case FORM_VIEW_EDIT:
                    	FormPopupForm(FORM_VIEW_EDIT);            				
                        break;
                    case FORM_TEL_LIST:
                        FormPopupForm(FORM_TEL_LIST);            
                        break;           
                    case FORM_EDIT_CATE:             
						FormPopupForm(FORM_EDIT_CATE);				                    
                        break;
                    default:
                        break;
                }
			}
			break;					
		case EVT_FORM_OPEN:
#ifdef DEBUG
            printf("\n FormPopupForm - FORM_PB_LOW_MEMORY");
#endif					
			FormDrawForm(FORM_PB_LOW_MEMORY);
			break;
		default:
			break;			
	}				
	return TRUE;
}


/********************************************************
 * Function:	PhonebookDiscardChangesHandle
 * Purpose: 	This function is the event handler for the FORM_PB_DISCARD_CHANGES
				page of the Phonebook application
 * Scope:		application/internal
 * Input:		Event		received event
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookDiscardChangesHandle(EvtType *Event)
{
    USHORT        item_num;
    ObjectID      tempID;

    if (Event->eventType == EVT_KEY && Event->eventID == SOFT_KEY)
	{
        if ((Event->para2 & 0x00000200))
	    {
	        if (Event->para1 == 'Y' || Event->para1 == 'n')
	        {
	            Event->eventType    = EVT_CONTROL_SELECT;
                Event->eventID      = BUTTON_PB_DISCARD_CHANGES_YES;
                Event->evtPBP       = NULL;
            }
	        else if (Event->para1 == 'N' || Event->para1 == 'n')
	        {
	            Event->eventType    = EVT_CONTROL_SELECT;
                Event->eventID      = BUTTON_PB_DISCARD_CHANGES_NO;
                Event->evtPBP       = NULL;
            }            
	        else if (Event->para1 == 'X' || Event->para1 == 'x')
	        {
	            Event->eventType    = EVT_BITMAP_SELECT;
                Event->eventID      = BITMAP_PB_DISCARD_CHANGES;
                Event->evtPBP       = NULL;
            }                        
        }
    }                    


    switch (Event->eventType)
    {
        case EVT_BITMAP_SELECT:
            FormPopupForm(gf_in_form_id);
            break;
        case EVT_FORM_OPEN:
            FormDrawForm(FORM_PB_DISCARD_CHANGES);
            break;    
        case EVT_INLAY_SELECT:
            if (Event->para1 == INLAY_OK || Event->para1 == INLAY_EXIT)
                FormPopupForm(gf_in_form_id);
            return TRUE;
        case EVT_CONTROL_SELECT:
            if (Event->eventID == BUTTON_PB_DISCARD_CHANGES_YES)
            {
                switch (gf_in_form_id)
                {
                    case FORM_VIEW_EDIT:
                        gf_entry = FALSE;
            			if (app_status.company)
                        {			        
            			    SetStatus(EDIT,TRUE, FALSE, FALSE,app_status.rec_id,app_status.new_record);
            			}
            			else 
            			{	
            			    SetStatus(EDIT,FALSE, TRUE, FALSE,app_status.rec_id,app_status.new_record);
            			}
            			PhonebookFieldBuffersToField();
            			TableSetTopRowNum(TABLE_VIEW_EDIT, 0);
            			for (tempID = FIELD_ROW0; tempID <= FIELD_ROW11; tempID ++)
            			    FieldSetTopLineNum(tempID, 0);
            			PhonebookViewEditSetupScreen();
                        PhonebookPrepareChangeInfo();
            			PhonebookSetViewEditTable(FORM_VIEW_EDIT, TABLE_VIEW_EDIT);
            			PhonebookViewEditTableSetScrollbar(TABLE_VIEW_EDIT, SCROLLBAR_VIEW_EDIT);
            			if (KeyboardCheckKeyboardStatus() == FALSE)
                        {
                            PhonebookChangeFontSize(FORM_VIEW_EDIT, font_size);
            				FormPopupForm(FORM_VIEW_EDIT);
                        }
            			else 
            			{
            			    PhonebookRedrawWithKeyboard();
                            FormSetActiveForm(FORM_VIEW_EDIT);
                            FormSetEventHandler(FORM_VIEW_EDIT,(void**)&FormDispatchEvent, (void*)PhonebookViewEdit);                        
                        }         			    
                        
                        FormSetFormActiveObject(FORM_VIEW_EDIT, FIELD_ROW0);
                        FieldSetInsertPointOn(FIELD_ROW0);
                        FieldSetInsertPointPositionByCharPos(FIELD_ROW0, 0);			  
            			KeyboardSetKeyboardVisible();
                        break;
                    case FORM_TEL_LIST:
                        gf_entry = FALSE;
                        
    					PhonebookInitFieldBuffers();
    					SetStatus(EDIT,FALSE,FALSE,TRUE,0,TRUE);
    					FormInitAllFormObjects(FORM_VIEW_EDIT);
    					PhonebookCateNameToPopupTrigger(pb_dbid);
    					ControlPopupDeleteItem(POPUP_TRIGGER_CATE,0);
    					if (ControlPopupFindItemNum(POPUP_TRIGGER_CATE, current_cate, &item_num) == TRUE) 
    						ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, (SHORT)item_num);
    					else
    						ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, 0);
    					
    					PhonebookViewEditSetupScreen();
    					
    					if (app_status.key_in != TRUE)
    						StringSetText(STRING_NAME, (BYTE *)("ABC"));
    					else
    					{
    						FormSetFormActiveObject(FORM_VIEW_EDIT, TEXTBOX_LAST_NAME);
    						TextboxSetInsertPointPositionByCharPos(TEXTBOX_LAST_NAME, 0);
    						TextboxSetInsertPointOn(TEXTBOX_LAST_NAME);
    					}
    					if (save_cate != NULL)
    						qfree(save_cate);
    					save_cate = (BYTE*)qmalloc(30*sizeof(BYTE));
    					strcpy (save_cate, (BYTE*)("All"));
                        PhonebookChangeFontSize(FORM_VIEW_EDIT, font_size);
                        FormPopupForm(FORM_VIEW_EDIT);
                        break;           
                    default:
                        break;
                }
            }
            else
            {
                switch (gf_in_form_id)
                {
                    case FORM_VIEW_EDIT:                        
                    case FORM_TEL_LIST:
                        gf_entry = FALSE;
                        PhonebookGlobalFindReentranceRestore();
                        break;
                    default:
                        return FALSE;
                }                               
            }    
            return TRUE;
        default: 
                return FALSE;
    }
    return FALSE;                                     
}

/********************************************************
 * Function:	PhonebookAlertEventHandler
 * Purpose: 	This function is the event handler for the FORM_ALERT
				dialog of the Phonebook application
 * Scope:		application/internal
 * Input:		Event		received event
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
BOOLEAN PhonebookAlertEventHandler(EvtType *Event)
{
	BOOLEAN control_value;
	USHORT item_num;
	BYTE object_type;
	void *addr;

	if (Event->eventType == EVT_KEY && Event->eventID == SOFT_KEY)
	{
        if ((Event->para2 & 0x00000200))
	    {
	        if (Event->para1 == 'O' || Event->para1 == 'o' || Event->para1 == 'X' || Event->para1 == 'x')
	        {
	            Event->eventType    = EVT_CONTROL_SELECT;
                Event->eventID      = BUTTON_ALERT;
                Event->evtPBP       = NULL;
            }
        }       
    }                    

	switch(Event->eventType)
	{
		case EVT_BITMAP_SELECT:
			switch(Event->eventID)
			{
				case BITMAP_ALERT:
					FormPopupForm(FORM_VIEW_EDIT);
					break;
				default:
					return FALSE;
			}
			break;
		case EVT_CONTROL_SELECT:
			switch(Event->eventID)
			{
				case BUTTON_ALERT:
					FormPopupForm(FORM_VIEW_EDIT);
					break;
				default:
					return FALSE;
			}
			break;
		case EVT_FORM_OPEN:
			FormDrawForm(FORM_ALERT);
			break;
		default: 
			return FALSE;
	}
	return TRUE;
}
