/*
================================ COPYRIGHT ================================
The contents of this file are subject to the VTech Informations Ltd. License
of VT-OS Ver. 1.1 operating system (the "License"); you may not use this 
file except in compliance with the License.  
 
Software distributed under the License is distributed on an "AS IS" basis, 
WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
for the specific language governing rights and limitations under the License.
 
The Original Code is VT-OS Ver. 1.1 Operating System, released 
on October 1st, 1999

The Initial Developer of the Original Code is VTech Informations Ltd.  All 
codes are Copyright (C) VTech Informations Ltd. 1999.  All Rights Reserved.
===========================================================================
*/

/*
===========================================================================
File        :   appsave.c
Author(s)   :   Henry Fok
Company     :   VTech Informations Ltd.
Project     :   Helio 
Date:	    :   October 1st, 1999
Purpose:	:   application c file
Revision    :   1.1
Note        :   None
===========================================================================
*/              



#include "include\app.h"
#define DBG_MESSAGE


//#include <emudbg.h>


//#define 	DEBUG
//#define DEBUG_CATE

/********************************************************
 * Function:	PhonebookAppSave
 * Purpose: 	This function is called to save the data in 
				the application when it is called to stopped
 * Scope:		application/internal
 * Input:		None
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
void PhonebookAppSave()
{
	ObjectID 		active_form_id;
	BYTE 			application_status = RESTART;
	BOOLEAN 		exist = FALSE;
	BYTE 			*object_text;
	WORD 			count = 0;
	BYTE 			boolean_value;
    Table 			*table_ptr;
    BYTE    		object_type;  
    
    FormGetActiveFormID(&active_form_id);
	if (active_form_id == FORM_TEL_LIST || 
		active_form_id == FORM_FIND_INPUT ||
		active_form_id == FORM_FIND_RESULT ||
		active_form_id == FORM_FIND_BACKGROUND||
		active_form_id == FORM_NOT_FOUND ||
		(active_form_id == FORM_VIEW_EDIT && app_status.status == VIEW) ||
		(active_form_id == FORM_ADD_ERASE && app_status.status == VIEW))
	{
		application_status = ADDRESS_LIST;		
	}		
	else if ((active_form_id == FORM_ADD_ERASE && app_status.status == EDIT) ||
			 active_form_id == FORM_SAVE_CHANGES ||
			 (active_form_id == FORM_VIEW_EDIT && app_status.status == EDIT))
	{	
		application_status = EDITING;
	}		
	else if (active_form_id == FORM_EDIT_CATE ||
			 active_form_id == FORM_INPUT_CATE ||
			 active_form_id == FORM_NO_CATE ||
			 active_form_id == FORM_CATE_NAME_EXISTS ||
			 active_form_id == FORM_ERASE_CATE ||
			 active_form_id == FORM_REMOVE_CATE ||
			 active_form_id == FORM_CATE_FULL)
	{
		if (app_status.status == TEL_LIST)
			application_status = ADDRESS_LIST;
		else application_status = EDITING;		
	}

	PhonebookDatabaseChecking();

	DataWriteField(pb_dbid, PB_STATUS, 1, 1, &edit_dirty);
    DataWriteField(pb_dbid, PB_STATUS, 2, (strlen(find_string) + 1), find_string);
    DataWriteField(pb_dbid, PB_STATUS, 3, 1, &font_size);
	boolean_value = (letter_bar) ? 1 : 0;

    DataWriteField(pb_dbid, PB_STATUS, 4, 1, &boolean_value);
    DataWriteField(pb_dbid, PB_STATUS, 5, 4, (BYTE*)&gTopNum);
    DataWriteField(pb_dbid, PB_STATUS, 6, 4, (BYTE*)&gSelNum);

	switch (application_status)
	{
		case ADDRESS_LIST:
			DataWriteField(pb_dbid, PB_STATUS, 0, 1, &application_status);
			if (current_cate != NULL)
				DataWriteField(pb_dbid, PB_ADDR_LIST, 0, (strlen(current_cate) + 1), current_cate);
			DataWriteField(pb_dbid, PB_ADDR_LIST, 1, 1, &char_start);
			break;
		case EDITING:
			DataWriteField(pb_dbid, PB_STATUS, 0, 1, &application_status);
			if (current_cate != NULL)
				DataWriteField(pb_dbid, PB_ADDR_LIST, 0, (strlen(current_cate) + 1), current_cate);
			DataWriteField(pb_dbid, PB_ADDR_LIST, 1, 1, &char_start);
			/* STRING_NAME */
			StringGetText(STRING_NAME, &object_text);
			DataWriteField(pb_dbid, PB_EDIT_INFO, 0, (strlen(object_text) + 1), object_text);
			/* STRING_LAST_NAME */
			StringGetText(STRING_LAST_NAME, &object_text);
			DataWriteField(pb_dbid, PB_EDIT_INFO, 1, (strlen(object_text) + 1), object_text);
			/* STRING_FIRST_NAME */
			StringGetText(STRING_FIRST_NAME, &object_text);
			DataWriteField(pb_dbid, PB_EDIT_INFO, 2, (strlen(object_text) + 1), object_text);
			/* TEXTBOX_FIRST_NAME */
			TextboxGetTextPointer(TEXTBOX_FIRST_NAME, &object_text);
			DataWriteField(pb_dbid, PB_EDIT_INFO, 3, (strlen(object_text) + 1), object_text);
			/* TEXTBOX_LAST_NAME */
			TextboxGetTextPointer(TEXTBOX_LAST_NAME, &object_text);
			DataWriteField(pb_dbid, PB_EDIT_INFO, 4, (strlen(object_text) + 1), object_text);
			/* field buffers */
			PhonebookFieldToFieldBuffer();
			for (count = 0; count < 26; count++)
			{
				if (field_buffers == NULL)
					DataWriteField(pb_dbid, PB_EDIT_INFO, (USHORT)(5 + count), 1, (BYTE*)(""));
				else
					DataWriteField(pb_dbid, PB_EDIT_INFO, (USHORT)(5 + count), (strlen(field_buffers[count]) + 1), field_buffers[count]);
			}
			/* app_status */
			boolean_value = (BYTE)(app_status.company);
			DataWriteField(pb_dbid, PB_EDIT_INFO, 32, 1, (BYTE*)&boolean_value);			
			boolean_value = (BYTE)(app_status.home);
			DataWriteField(pb_dbid, PB_EDIT_INFO, 33, 1, (BYTE*)&boolean_value);			
			boolean_value = (BYTE)(app_status.key_in);
			DataWriteField(pb_dbid, PB_EDIT_INFO, 34, 1, (BYTE*)&boolean_value);
			DataWriteField(pb_dbid, PB_EDIT_INFO, 35, 4, (BYTE*)&app_status.rec_id);
			boolean_value = (BYTE)(app_status.new_record);
			DataWriteField(pb_dbid, PB_EDIT_INFO, 36, 1, (BYTE*)&boolean_value);
			if (temp_cate == NULL)
				DataWriteField(pb_dbid, PB_EDIT_INFO, 37, 1, (BYTE*)(""));
			else DataWriteField(pb_dbid, PB_EDIT_INFO, 37, (strlen(temp_cate) + 1), temp_cate);
			break;
		default: break;
	}
    if (FormGetObjectPointer(TABLE_VIEW_EDIT, &object_type, (void**)&table_ptr) == TRUE)
        table_ptr->table_num_row = 12;   
	DataCloseDB(pb_dbid);
}

/********************************************************
 * Function:	PhonebookAppRestore
 * Purpose: 	This function is called to restore the data in 
				the application when it is called to stopped
 * Scope:		application/internal
 * Input:		restart		whether the application is restart or not
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
void PhonebookAppRestore(BOOLEAN restart)
{
	BYTE 		application_status;
	BYTE 		*buffer;
	UWORD 		byte_read;
	WORD 		count;
	USHORT 		item_num;
	UBYTE       cate_num;

    draw_scrollbar = FALSE;
	/* global variables initialisation */
    find_string[0] = 0;
	edit_dirty = 0;
    pressed_object = 0;
    current_cate = NULL;
    char_start = 'A';
    temp_cate = NULL;
    save_cate = NULL;
    save_first_letter = 'A';
    SetStatus(TEL_LIST,FALSE,FALSE,FALSE,0,FALSE);
    list_tel_list.list_id = LIST_NAME;
    list_find.list_id = LIST_FIND_RESULT_NAME;
    list_tel_list.dbid = list_find.dbid = 0;
    list_tel_list.max_num_items_display = list_find.max_num_items_display = 0;
    list_tel_list.num_items_display = list_find.num_items_display = 0;
    list_tel_list.total_num_items = list_find.total_num_items = 0;
    list_tel_list.top_item_num = list_find.top_item_num = 0;        
    list_tel_list.record_id_block = list_find.record_id_block = NULL;        

    PhonebookDatabaseChecking();

	list_tel_list.dbid = list_find.dbid = pb_dbid;
	if (restart == TRUE)
		application_status = RESTART;
	else
	{
		DataGetField(pb_dbid, PB_STATUS, 0, &buffer, &byte_read);
		application_status = *buffer;
		qfree(buffer);
	}

	/* Allocate global variable */
    DataGetField(pb_dbid, PB_STATUS, 2, &buffer, &byte_read);
    strcpy(find_string, buffer);
    qfree(buffer);
    DataGetField(pb_dbid, PB_STATUS, 3, &buffer, &byte_read);
    font_size = *buffer;
    qfree(buffer);

	DataGetField(pb_dbid, PB_STATUS, 4, &buffer, &byte_read);
    letter_bar = (*buffer==1);
    qfree(buffer);
    DataGetField(pb_dbid, PB_STATUS, 5, &buffer, &byte_read);
	gTopNum = *(WORD*)buffer;
    qfree(buffer);
    DataGetField(pb_dbid, PB_STATUS, 6, &buffer, &byte_read);
	gSelNum = *(WORD*)buffer;
    qfree(buffer);

	field_buffers = (BYTE**)qmalloc(26*sizeof(BYTE*));
	for (count = 0; count <26; count++)
		field_buffers[count] = NULL;
	current_cate = (BYTE*)qmalloc(30*sizeof(BYTE));
    temp_cate = (BYTE*)qmalloc(30*sizeof(BYTE));
	
	DataGetField(pb_dbid, PB_STATUS, 1, &buffer, &byte_read);
	edit_dirty = *buffer;
	qfree(buffer);

    FormInitAllFormObjects(FORM_TEL_LIST);
    FormInitAllFormObjects(FORM_VIEW_EDIT);

    if (MemoryLow)
        entry_low_memory = TRUE;
    else 
		entry_low_memory = FALSE;
    
	if (application_status == EDITING)
		entry_old_edit = TRUE;
	else 
		entry_old_edit = FALSE;		    	
	
	if (entry_low_memory && entry_old_edit)
		application_status = RESTART;

	switch(application_status)
	{
		case RESTART:
			strcpy(current_cate,(BYTE*)("All"));
			strcpy(temp_cate,(BYTE*)("All"));
			char_start = 'A';
			PhonebookRecordToList(pb_dbid, (BYTE*)("All"), char_start, NULL);
			PhonebookCateNameToPopupTrigger(pb_dbid);
			ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, 0);
			FormPopupForm(FORM_TEL_LIST);
			if (entry_low_memory && entry_old_edit)
			{
				low_memory_form_id = FORM_TEL_LIST;
				FormPopupForm(FORM_PB_LOW_MEMORY);
			}								                     
			break;
		case ADDRESS_LIST:
			DataGetField(pb_dbid, PB_ADDR_LIST, 0, &buffer, &byte_read);
			strcpy(current_cate, buffer);

			strcpy(temp_cate, buffer);
			qfree(buffer);
			DataGetField(pb_dbid, PB_ADDR_LIST, 1, &buffer, &byte_read);			
			char_start = *buffer;
			qfree(buffer);

			if (PhonebookCateNameToNum(pb_dbid, current_cate, &cate_num) == FALSE)
				strcpy(current_cate, (BYTE*)("All"));

			PhonebookRecordToList(pb_dbid, current_cate, char_start, NULL);

			PhonebookSetTelListTopItemNum(char_start, 0, FALSE);

			PhonebookCateNameToPopupTrigger(pb_dbid);

			if (ControlPopupFindItemNum(POPUP_TRIGGER_CATE, current_cate, &item_num) == TRUE) 
				ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, (SHORT)item_num);
			else
				ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, 0);
				
			PhonebookChangeFontSize(FORM_TEL_LIST, font_size);

			if(!letter_bar)
				SetLetterBar();   
			
			FormPopupForm(FORM_TEL_LIST);
			break;
		case EDITING:
			DataGetField(pb_dbid, PB_ADDR_LIST, 0, &buffer, &byte_read);
			strcpy(current_cate, buffer);
			qfree(buffer);
			DataGetField(pb_dbid, PB_ADDR_LIST, 1, &buffer, &byte_read);			
			char_start = *buffer;
			qfree(buffer);
			/* STRING_NAME */
			DataGetField(pb_dbid, PB_EDIT_INFO, 0, &buffer, &byte_read);			
			StringSetText(STRING_NAME, buffer);
			qfree(buffer);
			/* STRING_LAST_NAME */
			DataGetField(pb_dbid, PB_EDIT_INFO, 1, &buffer, &byte_read);			
			StringSetText(STRING_LAST_NAME, buffer);
			qfree(buffer);
			/* STRING_FIRST_NAME */
			DataGetField(pb_dbid, PB_EDIT_INFO, 2, &buffer, &byte_read);			
			StringSetText(STRING_FIRST_NAME, buffer);
			qfree(buffer);
			/* TEXTBOX_FIRST_NAME */
			DataGetField(pb_dbid, PB_EDIT_INFO, 3, &buffer, &byte_read);			
			TextboxSetText(TEXTBOX_FIRST_NAME, buffer);
			qfree(buffer);
			/* TEXTBOX_LAST_NAME */
			DataGetField(pb_dbid, PB_EDIT_INFO, 4, &buffer, &byte_read);			
			TextboxSetText(TEXTBOX_LAST_NAME, buffer);
			qfree(buffer);
			/* field_buffers */
			for (count = 0; count < 26; count++)
			{
				DataGetField(pb_dbid, PB_EDIT_INFO, (count  + 5), &buffer, &byte_read);			
				field_buffers[count] = (BYTE*)qmalloc((strlen(buffer) + 1)*sizeof(BYTE));
				strcpy(field_buffers[count], buffer);
				qfree(buffer);
			}
			/* app_status */
			app_status.status = EDIT;						
			DataGetField(pb_dbid, PB_EDIT_INFO, 32, &buffer, &byte_read);
			app_status.company = (BOOLEAN)(*buffer);
			qfree(buffer);
			DataGetField(pb_dbid, PB_EDIT_INFO, 33, &buffer, &byte_read);
			app_status.home = (BOOLEAN)(*buffer);
			qfree(buffer);
			DataGetField(pb_dbid, PB_EDIT_INFO, 34, &buffer, &byte_read);
			app_status.key_in = (BOOLEAN)(*buffer);
			qfree(buffer);
			DataGetField(pb_dbid, PB_EDIT_INFO, 35, &buffer, &byte_read);
			app_status.rec_id = *(RecordID*)buffer;
			qfree(buffer);
			DataGetField(pb_dbid, PB_EDIT_INFO, 36, &buffer, &byte_read);
			app_status.new_record = (BOOLEAN)(*buffer);
			qfree(buffer);
			DataGetField(pb_dbid, PB_EDIT_INFO, 37, &buffer, &byte_read);
			strcpy(temp_cate, buffer);
			qfree(buffer);

			/* Setup FORM_VIEW_EDIT */
			PhonebookCateNameToPopupTrigger(pb_dbid);
			ControlPopupDeleteItem(POPUP_TRIGGER_CATE, 0);
			if (ControlPopupFindItemNum(POPUP_TRIGGER_CATE, temp_cate, &item_num) == TRUE) 
				ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, (SHORT)item_num);
			else
				ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, 0);
			PhonebookFieldBuffersToField();
			if (save_cate != NULL)
				qfree(save_cate);
			save_cate = (BYTE*)qmalloc(30*sizeof(BYTE));
			strcpy (save_cate, temp_cate);
			PhonebookSetViewEditTable(FORM_VIEW_EDIT, TABLE_VIEW_EDIT);
			PhonebookViewEditTableSetScrollbar(TABLE_VIEW_EDIT, SCROLLBAR_VIEW_EDIT);
			if (app_status.key_in)
			{	
            	FormSetFormActiveObject(FORM_VIEW_EDIT, TEXTBOX_LAST_NAME);
            	TextboxSetInsertPointOn(TEXTBOX_LAST_NAME);            	
			}            	
			else 
			{
            	FormSetFormActiveObject(FORM_VIEW_EDIT, FIELD_ROW0);
            	FieldSetInsertPointOn(FIELD_ROW0);
			}            	
			FieldSetInsertPointPositionByCharPos(FIELD_ROW0, 0);
			PhonebookChangeFontSize(FORM_VIEW_EDIT, font_size);
			PhonebookViewEditSetupScreen();
			FormPopupForm(FORM_VIEW_EDIT);
			break;
		default: 
			break;
	}
    draw_scrollbar = TRUE;
}

/********************************************************
 * Function:	PhonebookDatabaseChecking
 * Purpose: 	This function is called to check whether the required database 
				is already exist or not. If not, it will creat it
 * Scope:		application/internal
 * Input:		None
 * Output:		None
 * Return:		None
 * Comment: 	None
 *********************************************************/
void PhonebookDatabaseChecking()
{
	BYTE application_status;
	BYTE temp;
	WORD wtemp;

	DBG_MESSAGE("+PhonebookDatabaseChecking()\r\n");
    if (DataFindDB((BYTE*)("Phonebook Database"), &pb_dbid) != TRUE)
	{
		/* New Database */
		DataNewDB((BYTE*)("Phonebook Database"),1,(BYTE*)("Phonebook Application"),&pb_dbid);
        DataOpenDB(pb_dbid,SORT_TEXT_MODE | 2, OPEN_RW);

		/* Open Database */
		DataCategorySetName(pb_dbid,0,(BYTE*)("Unfiled"));
		DataCategorySetName(pb_dbid,1,(BYTE*)("Business"));
		DataCategorySetName(pb_dbid,2,(BYTE*)("Personal"));
	}
	else if (DataIsDBOpen(pb_dbid, NULL, NULL) == FALSE)
        DataOpenDB(pb_dbid,SORT_TEXT_MODE | 2, OPEN_RW);

	if (DataRecordInfo(pb_dbid, PB_STATUS, NULL, NULL, NULL, NULL, NULL) != TRUE)
	{
        DataNewRecordWithID(pb_dbid, PB_STATUS, 0, 7);
		application_status = RESTART;
		DataWriteField(pb_dbid, PB_STATUS, 0, 1, &application_status);
		temp = 0;
		DataWriteField(pb_dbid, PB_STATUS, 1, 1, &temp);
        DataWriteField(pb_dbid, PB_STATUS, 2, 1, (BYTE*)(""));
        temp = SMALL_FONT;
        DataWriteField(pb_dbid, PB_STATUS, 3, 1, &temp);
        wtemp = 0;
		DataWriteField(pb_dbid, PB_STATUS, 5, 4, (BYTE*)&wtemp);
		//added tab bar toggle
        temp = 1;	//show toggle bar
        DataWriteField(pb_dbid, PB_STATUS, 4, 1, &temp);
        wtemp = -1;
		DataWriteField(pb_dbid, PB_STATUS, 6, 4, (BYTE*)&wtemp);

	}
	if (DataRecordInfo(pb_dbid, PB_EDIT_INFO, NULL, NULL, NULL, NULL, NULL) != TRUE)
		DataNewRecordWithID(pb_dbid, PB_EDIT_INFO, 0, 38);
	if (DataRecordInfo(pb_dbid, PB_ADDR_LIST, NULL, NULL, NULL, NULL, NULL) != TRUE)
		DataNewRecordWithID(pb_dbid, PB_ADDR_LIST, 0, 2);
	DBG_MESSAGE("-PhonebookDatabaseChecking()\r\n");
}


/********************************************************
 * Function:	PhonebookGlobalFindReentranceRestore
 * Purpose: 	This function is called to restore the data in 
				the application when it is called to stopped
 * Scope:		application/internal
 * Input:		restart		whether the application is restart or not
 * Output:		None
 * Return:		TRUE if handled
				FALSE if not handled
 * Comment: 	None
 *********************************************************/
void PhonebookGlobalFindReentranceRestore()
{
	BYTE 		application_status;
	BYTE 		*buffer;
	UWORD 		byte_read;
	WORD 		count;
	USHORT 		item_num;

    draw_scrollbar = FALSE;
	/* global variables initialisation */
    find_string[0] = 0;
	edit_dirty = 0;
    pressed_object = 0;
    char_start = 'A';
    save_first_letter = 'A';
    table_font_size = SMALL_FONT;
    SetStatus(TEL_LIST,FALSE,FALSE,FALSE,0,FALSE);
    list_tel_list.list_id = LIST_NAME;
    list_find.list_id = LIST_FIND_RESULT_NAME;
    list_tel_list.dbid = list_find.dbid = 0;
    list_tel_list.max_num_items_display = list_find.max_num_items_display = 0;
    list_tel_list.num_items_display = list_find.num_items_display = 0;
    list_tel_list.total_num_items = list_find.total_num_items = 0;
    list_tel_list.top_item_num = list_find.top_item_num = 0;        
    list_tel_list.record_id_block = list_find.record_id_block = NULL;        

    PhonebookDatabaseChecking();
	list_tel_list.dbid = list_find.dbid = pb_dbid;
    DataGetField(pb_dbid, PB_STATUS, 0, &buffer, &byte_read);
    application_status = *buffer;
    qfree(buffer);
          
	for (count = 0; count <26; count++)
	{
	    if (field_buffers[count])
	        qfree(field_buffers[count]);        
    }		
	if (field_buffers)
	    qfree(field_buffers);            
    field_buffers = (BYTE**)qmalloc(26*sizeof(BYTE*));
	for (count = 0; count <26; count++)
		field_buffers[count] = NULL;
    
	DataGetField(pb_dbid, PB_STATUS, 1, &buffer, &byte_read);
	edit_dirty = *buffer;
	qfree(buffer);

    FormInitAllFormObjects(FORM_TEL_LIST);
    FormInitAllFormObjects(FORM_VIEW_EDIT);

    if (MemoryLow)
        entry_low_memory = TRUE;
    else 
		entry_low_memory = FALSE;
    
    if (application_status == EDITING)
		entry_old_edit = TRUE;
	else 
		entry_old_edit = FALSE;		    	
	
	if (entry_low_memory && entry_old_edit)
		application_status = RESTART;
		

    DataGetField(pb_dbid, PB_ADDR_LIST, 0, &buffer, &byte_read);
	strcpy(current_cate, buffer);
	qfree(buffer);
	
	DataGetField(pb_dbid, PB_ADDR_LIST, 1, &buffer, &byte_read);			
	char_start = *buffer;
	qfree(buffer);
	
	/* STRING_NAME */
	DataGetField(pb_dbid, PB_EDIT_INFO, 0, &buffer, &byte_read);			
	StringSetText(STRING_NAME, buffer);
    qfree(buffer);
	
	/* STRING_LAST_NAME */
	DataGetField(pb_dbid, PB_EDIT_INFO, 1, &buffer, &byte_read);			
	StringSetText(STRING_LAST_NAME, buffer);
	qfree(buffer);
	
	/* STRING_FIRST_NAME */
	DataGetField(pb_dbid, PB_EDIT_INFO, 2, &buffer, &byte_read);			
	StringSetText(STRING_FIRST_NAME, buffer);
	qfree(buffer);
	
	/* TEXTBOX_FIRST_NAME */
	DataGetField(pb_dbid, PB_EDIT_INFO, 3, &buffer, &byte_read);			
	TextboxSetText(TEXTBOX_FIRST_NAME, buffer);
	qfree(buffer);
	
	/* TEXTBOX_LAST_NAME */
	DataGetField(pb_dbid, PB_EDIT_INFO, 4, &buffer, &byte_read);			
	TextboxSetText(TEXTBOX_LAST_NAME, buffer);
	qfree(buffer);
	
	/* field_buffers */
	for (count = 0; count < 26; count++)
	{
    	DataGetField(pb_dbid, PB_EDIT_INFO, (count  + 5), &buffer, &byte_read);			
		field_buffers[count] = (BYTE*)qmalloc((strlen(buffer) + 1)*sizeof(BYTE));
		strcpy(field_buffers[count], buffer);
		qfree(buffer);
	}
	
	/* app_status */
	app_status.status = EDIT;						
	DataGetField(pb_dbid, PB_EDIT_INFO, 32, &buffer, &byte_read);
	app_status.company = (BOOLEAN)(*buffer);
	qfree(buffer);
	
	DataGetField(pb_dbid, PB_EDIT_INFO, 33, &buffer, &byte_read);
	app_status.home = (BOOLEAN)(*buffer);
	qfree(buffer);
	
	DataGetField(pb_dbid, PB_EDIT_INFO, 34, &buffer, &byte_read);
	app_status.key_in = (BOOLEAN)(*buffer);
	qfree(buffer);
	
	DataGetField(pb_dbid, PB_EDIT_INFO, 35, &buffer, &byte_read);
	app_status.rec_id = *(RecordID*)buffer;
	qfree(buffer);
	
	DataGetField(pb_dbid, PB_EDIT_INFO, 36, &buffer, &byte_read);
	app_status.new_record = (BOOLEAN)(*buffer);
	qfree(buffer);
	
	DataGetField(pb_dbid, PB_EDIT_INFO, 37, &buffer, &byte_read);
	strcpy(temp_cate, buffer);
	qfree(buffer);

	/* Setup FORM_VIEW_EDIT */
	PhonebookViewEditSetupScreen();
	PhonebookCateNameToPopupTrigger(pb_dbid);
	ControlPopupDeleteItem(POPUP_TRIGGER_CATE, 0);
	if (ControlPopupFindItemNum(POPUP_TRIGGER_CATE, temp_cate, &item_num) == TRUE) 
	    ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, (SHORT)item_num);
	else
		ControlPopupSetSelectedItem(POPUP_TRIGGER_CATE, 0);
	PhonebookFieldBuffersToField();
	if (save_cate != NULL)
		qfree(save_cate);
	save_cate = (BYTE*)qmalloc(30*sizeof(BYTE));
	strcpy (save_cate, temp_cate);
    PhonebookSetViewEditTable(FORM_VIEW_EDIT, TABLE_VIEW_EDIT);
    PhonebookViewEditTableSetScrollbar(TABLE_VIEW_EDIT, SCROLLBAR_VIEW_EDIT);
    if (app_status.key_in)
    {	
        FormSetFormActiveObject(FORM_VIEW_EDIT, TEXTBOX_LAST_NAME);
        TextboxSetInsertPointOn(TEXTBOX_LAST_NAME);            	
	}            	
    else 
    {
       	FormSetFormActiveObject(FORM_VIEW_EDIT, FIELD_ROW0);
      	FieldSetInsertPointOn(FIELD_ROW0);
	}           	
    FieldSetInsertPointPositionByCharPos(FIELD_ROW0, 0);
    PhonebookChangeFontSize(FORM_VIEW_EDIT, font_size);
	FormPopupForm(FORM_VIEW_EDIT);
    draw_scrollbar = TRUE;
}
