/*
================================ COPYRIGHT ================================
The contents of this file are subject to the VTech Informations Ltd. License
of VT-OS Ver. 1.1 operating system (the "License"); you may not use this 
file except in compliance with the License.  
 
Software distributed under the License is distributed on an "AS IS" basis, 
WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
for the specific language governing rights and limitations under the License.
 
The Original Code is VT-OS Ver. 1.1 Operating System, released 
on October 1st, 1999

The Initial Developer of the Original Code is VTech Informations Ltd.  All 
codes are Copyright (C) VTech Informations Ltd. 1999.  All Rights Reserved.
===========================================================================
*/

/*
===========================================================================
File        :   menufunc.c
Author(s)   :   Henry Fok
Company     :   VTech Informations Ltd.
Project     :   Helio 
Date:	    :   October 1st, 1999
Purpose:	:   application c file
Revision    :   1.1
Note        :   None
===========================================================================
*/              


#include "stdafx.h"
#include "include\app.h"
#include "include\appfunc.h"

extern ObjectID prev_form_id;

/********************************************************
 * Function:	MenuItemSelectedAction
 * Purpose: 	This fucntion is to do an action when 
				an item in a menu is selected
 * Scope:		application/internal
 * Input:		menu_item		The item number of the selectd menu item
 * Output:		None
 * Return:		None
 * Comment: 	None
 *********************************************************/
void MenuItemSelectedAction(USHORT item_num)
{
	ObjectID active_form_id;
	ObjectID active_object_id;
	BOOLEAN highlighted = FALSE, insert_pt = FALSE;
	BYTE object_type;
	void *addr;
	Field *field_ptr;
	USHORT count;
	UBYTE	date[4];

	FormGetActiveFormID(&active_form_id);
	FormGetActiveObject(active_form_id, &active_object_id);
	if (FormGetObjectPointer(active_object_id, &object_type, (void**)&addr) == FALSE)
		return;
	if (object_type != FIELD && item_num != MENU_ITEM_ZOOM)
		return;
	else if (object_type == FIELD)
	{
		field_ptr = (Field*)addr;
		highlighted = field_ptr->field_attr.field_highlight;
		insert_pt = field_ptr->field_attr.field_insert_pt_visible;
	}

	switch(item_num)
	{
		case MENU_ITEM_COPY:
			KeyboardSendEvent(KEY_COPY, FALSE, FALSE, FALSE);
			break;
		case MENU_ITEM_CUT:
			KeyboardSendEvent(KEY_CUT, FALSE, FALSE, FALSE);
			break;
		case MENU_ITEM_DUP:
			if (MemoryLow)
			{
				FormPopupForm(FORM_SCH_LOW_MEMORY);
				return;
			}				
			if (virtual_table.vt_active_row < 0)
				FormPopupForm(FORM_SCH_ALARM_SELECT);
			else if (new_appointment == FALSE)
			{
				duplicate = TRUE;
				SchedulerGetDayViewDate(date);
				SchedulerDayViewSaveAppmtData(&virtual_table, date);
				prev_form_id = FORM_SCH_DAY_VIEW;
                FormInitAllFormObjects(FORM_SCH_DATE);
				FormPopupForm(FORM_SCH_DATE);				
			}
			break;
		case MENU_ITEM_PASTE:
			if (MemoryLow)
			{
				FormPopupForm(FORM_SCH_LOW_MEMORY);
				return;
			}				
			KeyboardSendEvent(KEY_PASTE, FALSE, FALSE, FALSE);
			break;
		case MENU_ITEM_UNDO:
			if (UIGetUndoStatus() != UNDO_EMPTY)
				KeyboardSendEvent(KEY_UNDO, FALSE, FALSE, FALSE);
			break;
// --------------------------- modified at 280300 ---------------------------
		case MENU_ITEM_PURGE:
			SchedulerGetDayViewDate(date);
			SchedulerDayViewSaveAppmtData(&virtual_table, date);
			FormPopupForm(FORM_SCH_PURGE);
			break;
// ---------------------------------------------------------------------------
		case MENU_ITEM_ZOOM:
			if (virtual_table.vt_font_size == SMALL_FONT)
				VTSetTableFontSize(&virtual_table, MEDIUM_FONT);
			else VTSetTableFontSize(&virtual_table, SMALL_FONT);
			SchedulerDayViewSetScreen(&virtual_table);
			for (count = 0; count < virtual_table.vt_num_rows; count++)
			{
				virtual_table.vt_items[count]->ptr->bounds.height = 9;
				virtual_table.vt_items[count]->ptr->screen_bounds.height = 9;
				virtual_table.vt_row_height[count] = 9; 
			}
			SchedulerTimeSettingsDeleteAllEmptyAppmts(&virtual_table);
			SchedulerTimeSettingsAddAppmts(&virtual_table);
			VTSetVirtualTableLayout(&virtual_table);
			VTVirtualTableSetScrollbar(&virtual_table);
			VTTransferAllToRT(&virtual_table, TABLE_SCH_DAY_VIEW);			
            TableDrawTable(TABLE_SCH_DAY_VIEW);
            ScrollbarDrawScrollbar(SCROLLBAR_SCH_DAY_VIEW);
			SchedulerDayViewDrawAppointmentColumn(&virtual_table, TABLE_SCH_DAY_VIEW);
			if (virtual_table.vt_font_size == SMALL_FONT)
			{
				MenuDeleteItem(MENU_SCH_DAY_VIEW, MENU_ITEM_ZOOM);
                MenuInsertItem(MENU_SCH_DAY_VIEW, MENU_ITEM_ZOOM, (BYTE*)("Large Font"));
			}
			else
			{
				MenuDeleteItem(MENU_SCH_DAY_VIEW, MENU_ITEM_ZOOM);
                MenuInsertItem(MENU_SCH_DAY_VIEW, MENU_ITEM_ZOOM, (BYTE*)("Small Font"));
			}
			break;
		default: break;
	}
}
