/*
================================ COPYRIGHT ================================
The contents of this file are subject to the VTech Informations Ltd. License
of VT-OS Ver. 1.1 operating system (the "License"); you may not use this 
file except in compliance with the License.  
 
Software distributed under the License is distributed on an "AS IS" basis, 
WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
for the specific language governing rights and limitations under the License.
 
The Original Code is VT-OS Ver. 1.1 Operating System, released 
on October 1st, 1999

The Initial Developer of the Original Code is VTech Informations Ltd.  All 
codes are Copyright (C) VTech Informations Ltd. 1999.  All Rights Reserved.
===========================================================================
*/

/*
===========================================================================
File        :   app.h
Author(s)   :   Thomas Cheng
Company     :   VTech Informations Ltd.
Project     :   Helio 
Date:	    :   October 1st, 1999
Purpose:	:   application header file
Revision    :   1.1
Note        :   None
===========================================================================
*/              


#ifndef _APP_H_
#define _APP_H_

#include "include\uifunc.h"
#include "include\uidef.h"
#include "include\appfunc.h"

extern DatabaseID dbid;
extern RecordID rec_id;
extern Err retval;
extern BOOLEAN		restore_status;
extern BOOLEAN sketch_alphabet;
extern BOOLEAN sketch_select;
extern BOOLEAN sketch_drag;
extern BOOLEAN sketch_exist;
extern BOOLEAN sketch_loadbmp;
extern BitmapTemplate full_bmp1, *full_bmp4, part_bmp3;
// = {4, 19, 153, 122, 0, 0, 0, NULL},
extern Bitmap *full_scr;
extern ObjectBounds bounds;
extern SHORT sketch_x, sketch_y, text_xcoord, text_ycoord;
extern SHORT tmp_x, tmp_y;
extern BYTE application_status;


typedef struct _MemoSketch
{
	AppID		app_id;
	RecordID	rec_id;
	USHORT		sketch_status_num;
	USHORT		sketch_field_num;
	BYTE		return_mode;
}MemoSketch;


/*****************************************************************
******************** FORM MAIN MENU **********************
*****************************************************************/
#define     FORM_SKETCH_LIST     0
#define     LIST_TITLE     1
#define     SCROLLBAR_SKETCH_LIST     2
#define     BUTTON_NEW_RECORD     3
#define     FORM_SKETCH_INFO     4
#define     STRING_SKETCH_INFO     5
#define     TEXTBOX_SKETCH_INFO     6
#define     FORM_SKETCH_DRAW     7
#define     BUTTON_DELETE_RECORD     8
#define     CHECKBOX_SKETCH_PEN     9
#define     CHECKBOX_SKETCH_ERASER     10
#define     CHECKBOX_SKETCH_FILL     11
#define     CHECKBOX_SKETCH_SELECT     12
#define     CHECKBOX_SKETCH_RECTANGLE     13
#define     CHECKBOX_SKETCH_CIRCLE     14
#define     CHECKBOX_SKETCH_TEXT     15
#define     CHECKBOX_SKETCH_LINE     16
#define	    BITMAP_SKETCH_DRAW	   17
#define     FORM_INPUT_TEXT     18
#define     BITMAP_INPUT_TEXT_X     19
#define		TEXTBOX_INPUT_TEXT		20
#define     FORM_CONFIRM_ERASE     21
#define     STRING_CONFIRM_ERASE_0     22
#define     STRING_CONFIRM_ERASE_1     23
#define     CHECKBOX_ERASE_SAVE_ARCHIVE     24
#define     BUTTON_ERASE_YES     25
#define     BUTTON_ERASE_NO     26
#define     FORM_SAVE_CHANGES     27
#define     BITMAP_SAVE_CHANGES_X     28
#define     STRING_SAVE_CHANGES     29
#define     BUTTON_SAVE_CHANGES_YES     30
#define     BUTTON_SAVE_CHANGES_NO     31

#define SKETCH_STATUS		0x80001001
#define SKETCH_EDIT_INFO		0x80001002

#define RESTART_SKETCH	0	
#define RESTART_SKETCH_INFO	1
#define RESTART_SKETCH_DRAW	2

/*==================== Menu Item ===========================*/
#define MENU_ITEM_COPY						0
#define MENU_ITEM_CUT						1
#define MENU_ITEM_PASTE						2
#define MENU_ITEM_UNDO						3
#define MENU_ITEM_ZOOM						4
#define SKETCH_MENU							32


void SketchDatabaseTemp();
void SketchDatabaseInit();
void EventLoop();
BOOLEAN SketchAppLaunch(WORD cmd, void *cmd_ptr);
void SketchAppSave();
void SketchAppRestore(BOOLEAN restart);
void SketchInit();
#endif
