#ifndef __ANNDB_H_
#define __ANNDB_H_

#include "include\uifunc.h"
#include "include\ui.h"
#include "include\mmu.h"
#include "include\Memo.h"
#include "include\MemoFunc.h"

/*==================== App Status ===========================*/
typedef struct _AppStatus
{
	RecordID	rec_id;
	BYTE		sketch_status;
	USHORT		memo_year;
	USHORT		memo_month;
	USHORT		memo_day;
	BYTE		new_sort_mode;
	BYTE		edit_mode;
	BOOLEAN		field_change;
}AppStatus;

/*==================== Memo Records =========================*/
typedef	struct _RecordIDBlock
{
	BYTE		num_records;
	RecordID	record_id[20];
	DatabaseID	dbid[20];
	struct		_RecordIDBlock *next;
}RecordIDBlock;

typedef	struct _TableDisplay
{	
	ObjectID	table_id;
	USHORT		num_rows_displayed;
	USHORT		total_num_rows;
	USHORT		top_row_num;
	RecordIDBlock *record_id_block;
}TableDisplay;

/*****************************************************************
********************** Global Variables **************************
*****************************************************************/

extern ObjectID	pressed_object1;
extern ObjectID	pressed_object2;
extern BOOLEAN	pen_down;
extern BYTE		alarm_date;
extern BYTE		sch_date;
extern BYTE		week_click;
extern BYTE		restart_form;
extern BOOLEAN	restore_status;

/*****************************************************************
********************** To Do List Application ********************
*****************************************************************/
BOOLEAN TableDisplayDeleteAllRecordID(TableDisplay *table_display);
BOOLEAN MemoTableDisplayDraw(TableDisplay *table_display);
BOOLEAN MemoFieldUpdateRecord();
BOOLEAN MemoCateNameToNum(BYTE *cate_name, UBYTE *cate_num);
BOOLEAN	MemoRecordToTable(DatabaseID dbid, BYTE sorted_by, BYTE *cate_name);
BOOLEAN MemoGetRecNumWithCateName(UWORD total_num_rec, BYTE *cate_name, UWORD rec_num[], UWORD *num_rec);
BOOLEAN MemoPopupCateActions(SHORT selected_item);
void MemoAppRestore(BOOLEAN restart);
void MemoAppSave();
void MemoChangeUpdateRecord();
void TableDisplayInsertRecordID(TableDisplay *table_display, RecordID record_id, DatabaseID dbid);
void MemoDatabaseInit();
void MemoDatabaseChecking();
void MemoDateUpdateRecord(SHORT new_year, SHORT new_month, SHORT new_day);
BYTE MemoCompareTwoStrings(BYTE *string1, BYTE *string2);

#endif