/*
================================ COPYRIGHT ================================
The contents of this file are subject to the VTech Informations Ltd. License
of VT-OS Ver. 1.1 operating system (the "License"); you may not use this 
file except in compliance with the License.  
 
Software distributed under the License is distributed on an "AS IS" basis, 
WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
for the specific language governing rights and limitations under the License.
 
The Original Code is VT-OS Ver. 1.1 Operating System, released 
on October 1st, 1999

The Initial Developer of the Original Code is VTech Informations Ltd.  All 
codes are Copyright (C) VTech Informations Ltd. 1999.  All Rights Reserved.
===========================================================================
*/

/*
===========================================================================
File        :   dbinit.c
Author(s)   :   Henry Fok
Company     :   VTech Informations Ltd.
Project     :   Helio 
Date:	    :   October 1st, 1999
Purpose:	:   DB init
Revision    :   1.1
Note        :   None
===========================================================================
*/              

 
#include "stdafx.h"
#include "include\system.h"

//#define  INIT_DB
//#define  DEBUG

typedef struct _APPOINTMENT_DB
{
	BYTE hour;
	BYTE minute;
	BYTE alarm;
	BYTE alarm_time;
	WORD appointment;
    UWORD appmt_num;
	DatabaseID dbid;
	RecordID recid;
}AppointmentDB;

#define F_DATE			0
#define F_DATA			1
#define F_STRING		2
#define F_ALARM			3

#define NO_ALARM        0

#define TIME_INDEX_RECID	0x80001001

#ifdef EL32
#undef EL32
#endif
#define EL32(x) 	((x <<24) | ((x &0xff00) <<8) | ((x &0xff0000) >>8) | (x>>24))

/********************************************************
 * Function:	AppPhonebookDatabaseInit
 * Purpose: 	Init Phonebook Database
 * Scope:	application
 * Input:	None
 * Output:	None
 * Return:	None
 * Comment: 	None
 *********************************************************/
void AppPhonebookDatabaseInit()
{
	DatabaseID 	pb_dbid;
	RecordID	rec_id;	
	UBYTE		email_cate;
	BYTE 		count, count1;
	BYTE		note[2000];

	if (DataFindDB((BYTE*)("Phonebook Database"), &pb_dbid) != TRUE)
	{
		/* New Database */
		DataNewDB((BYTE*)("Phonebook Database"),1,(BYTE*)("Phonebook Application"),&pb_dbid);
		DataOpenDB(pb_dbid, 0, OPEN_RW);

		/* Open Database */
		DataCategorySetName(pb_dbid,0,(BYTE*)("Unfiled"));
		DataCategorySetName(pb_dbid,1,(BYTE*)("Business"));
		DataCategorySetName(pb_dbid,2,(BYTE*)("Personal"));

		/* Record 1*/
        DataNewRecord(pb_dbid,0,27,&rec_id);
		DataWriteField(pb_dbid,rec_id, 0, 12, (BYTE*)("Accessories"));
		DataWriteField(pb_dbid,rec_id, 1, 1, (BYTE*)(""));
        DataWriteField(pb_dbid,rec_id, 2, 12, (BYTE*)("Accessories"));
		DataWriteField(pb_dbid,rec_id, 3, 22, (BYTE*)("VTech Information LLC"));
		DataWriteField(pb_dbid,rec_id, 4, 1, (BYTE*)(""));
		DataWriteField(pb_dbid,rec_id, 5, 17, (BYTE*)("1-877-VTECH-INFO")); /*TEL*/
		DataWriteField(pb_dbid,rec_id, 6, 15, (BYTE*)("1-877-883-2446")); /*Direct Line*/	
		DataWriteField(pb_dbid,rec_id, 7, 1, (BYTE*)("")); /*FAX*/
		DataWriteField(pb_dbid,rec_id, 8, 20, (BYTE*)("sales@vtechinfo.com"));
		DataWriteField(pb_dbid,rec_id, 9, 18, (BYTE*)("www.vtechinfo.com"));		
		DataWriteField(pb_dbid,rec_id, 10, 36, (BYTE*)("9640 SW Sunshine Court, Suite G-800"));
		DataWriteField(pb_dbid,rec_id, 11, 10, (BYTE*)("Beaverton")); /*City*/
		DataWriteField(pb_dbid,rec_id, 12, 3, (BYTE*)("OR")); /*State*/	
		DataWriteField(pb_dbid,rec_id, 13, 6, (BYTE*)("97005")); /*Country*/
		DataWriteField(pb_dbid,rec_id, 14, 4, (BYTE*)("USA")); /*Country*/		
		strcpy(note, (BYTE*)("Information about accessories, peripheries, useful software & hardware are all available at www.vtechinfo.com"));	
		DataWriteField(pb_dbid,rec_id, 25, strlen(note) + 1, note); /*Country*/		
		email_cate = 0;
		DataWriteField(pb_dbid,rec_id, 26, 1, (BYTE*)&email_cate);
        DataSetRecordAttribute(pb_dbid, rec_id, ATTR_SET, ATTR_UNCHG, 2);
		DataCloseRecord(pb_dbid,rec_id);

		/* Record 2*/
        DataNewRecord(pb_dbid,0,27,&rec_id);
        DataWriteField(pb_dbid,rec_id, 0, 18, (BYTE*)("Technical Support"));
        DataWriteField(pb_dbid,rec_id, 1, 1, (BYTE*)(""));
        DataWriteField(pb_dbid,rec_id, 2, 18, (BYTE*)("Technical Support"));
		DataWriteField(pb_dbid,rec_id, 3, 22, (BYTE*)("VTech Information LLC"));
		DataWriteField(pb_dbid,rec_id, 4, 1, (BYTE*)(""));
		DataWriteField(pb_dbid,rec_id, 5, 17, (BYTE*)("1-877-VTECH-HELP")); /*TEL*/
		DataWriteField(pb_dbid,rec_id, 6, 15, (BYTE*)("1-877-883-2443")); /*Direct Line*/	
		DataWriteField(pb_dbid,rec_id, 7, 1, (BYTE*)("")); /*FAX*/
		DataWriteField(pb_dbid,rec_id, 8, 26, (BYTE*)("techsupport@vtechinfo.com"));
		DataWriteField(pb_dbid,rec_id, 9, 18, (BYTE*)("www.vtechinfo.com"));		
		DataWriteField(pb_dbid,rec_id, 10, 36, (BYTE*)("9640 SW Sunshine Court, Suite G-800"));
		DataWriteField(pb_dbid,rec_id, 11, 10, (BYTE*)("Beaverton")); /*City*/
		DataWriteField(pb_dbid,rec_id, 12, 3, (BYTE*)("OR")); /*State*/	
		DataWriteField(pb_dbid,rec_id, 13, 6, (BYTE*)("97005")); /*Country*/
		DataWriteField(pb_dbid,rec_id, 14, 4, (BYTE*)("USA")); /*Country*/		
        strcpy(note, (BYTE*)("For trouble shooting, please visit the web site at www.vtechinfo.com. Solutions to common technical problems can be found in our FAQ section (Frequently Asked Questions). For more technical information, please contact our technical support department via email or call us at 1-877-883-2443.")); 
		DataWriteField(pb_dbid,rec_id, 25, strlen(note) + 1, note); /*Country*/		
		email_cate = 0;
		DataWriteField(pb_dbid,rec_id, 26, 1, (BYTE*)&email_cate);
        DataSetRecordAttribute(pb_dbid, rec_id, ATTR_SET, ATTR_UNCHG, 2);
		DataCloseRecord(pb_dbid,rec_id);

		/* Record 3*/
        DataNewRecord(pb_dbid,0,27,&rec_id);
        DataWriteField(pb_dbid,rec_id, 0, 17, (BYTE*)("Customer Service"));
        DataWriteField(pb_dbid,rec_id, 1, 1, (BYTE*)(""));
        DataWriteField(pb_dbid,rec_id, 2, 17, (BYTE*)("Customer Service"));
		DataWriteField(pb_dbid,rec_id, 3, 22, (BYTE*)("VTech Information LLC"));
		DataWriteField(pb_dbid,rec_id, 4, 1, (BYTE*)(""));
		DataWriteField(pb_dbid,rec_id, 5, 17, (BYTE*)("1-877-VTECH-INFO")); /*TEL*/
		DataWriteField(pb_dbid,rec_id, 6, 15, (BYTE*)("1-877-883-2446")); /*Direct Line*/	
		DataWriteField(pb_dbid,rec_id, 7, 1, (BYTE*)("")); /*FAX*/
		DataWriteField(pb_dbid,rec_id, 8, 26, (BYTE*)("custservice@vtechinfo.com"));
		DataWriteField(pb_dbid,rec_id, 9, 18, (BYTE*)("www.vtechinfo.com"));		
		DataWriteField(pb_dbid,rec_id, 10, 36, (BYTE*)("9640 SW Sunshine Court, Suite G-800"));
		DataWriteField(pb_dbid,rec_id, 11, 10, (BYTE*)("Beaverton")); /*City*/
		DataWriteField(pb_dbid,rec_id, 12, 3, (BYTE*)("OR")); /*State*/	
		DataWriteField(pb_dbid,rec_id, 13, 6, (BYTE*)("97005")); /*Country*/
		DataWriteField(pb_dbid,rec_id, 14, 4, (BYTE*)("USA")); /*Country*/		
        strcpy(note, (BYTE*)("Our Customer Service Department works on:\r\rMonday to Friday -- 6:00am to 6:00pm (Pacific Standard Time)\rSaturday and Sunday -- 8:00am to 5:00pm (Pacific Standard Time)")); 
		DataWriteField(pb_dbid,rec_id, 25, strlen(note) + 1, note); /*Country*/		
		email_cate = 0;
		DataWriteField(pb_dbid,rec_id, 26, 1, (BYTE*)&email_cate);
        DataSetRecordAttribute(pb_dbid, rec_id, ATTR_SET, ATTR_UNCHG, 2);
		DataCloseRecord(pb_dbid,rec_id);


		for (count = 0; count < 3; count++)
		{
            DataOpenRecord(pb_dbid, count, &rec_id, NULL);
            for (count1 = 15; count1 <= 24; count1 ++) 
				DataWriteField(pb_dbid, rec_id, count1, 1, (BYTE*)(""));
			DataCloseRecord(pb_dbid, rec_id);
		}
        DataCloseDB(pb_dbid);
    }

}

/********************************************************
 * Function:	AppEmailDatabaseInit
 * Purpose: 	Init Email Database
 * Scope:	application
 * Input:	None
 * Output:	None
 * Return:	None
 * Comment: 	None
 *********************************************************/
void AppEmailDatabaseInit()
{
    DatabaseID  email_dbid, emess_dbid, message_id_dbid;
	RecordID	rec_id;
	BYTE		date[20], to[100], cc[100], bcc[100], from[100], sub[100], body[4000];
	WORD 		time_index;

    /* Check message_id_dbid*/
    if (DataFindDB((BYTE*)("Message ID Database"), &message_id_dbid) != TRUE)
	{
		/* New Database */
        DataNewDB((BYTE*)("Message ID Database"),1,(BYTE*)("Email Application"),&message_id_dbid);
	}


	/* Check email_dbid */
	if (DataFindDB((BYTE*)("Email Database"), &email_dbid) != TRUE)
	{
		/* New Database */
		DataNewDB((BYTE*)("Email Database"),1,(BYTE*)("Email Application"),&email_dbid);
        DataOpenDB(email_dbid, 0, OPEN_RW);

		/* Open Database */
		DataCategorySetName(email_dbid,0,(BYTE*)("Unfiled"));
		DataCategorySetName(email_dbid,1,(BYTE*)("Business"));
		DataCategorySetName(email_dbid,2,(BYTE*)("Personal"));
        DataCloseDB(email_dbid);
	}

	/* Check emess_dbid */
	if (DataFindDB((BYTE*)("Email Message Database"), &emess_dbid) != TRUE)
	{
		/* New Database */
        DataNewDB((BYTE*)("Email Message Database"),1,(BYTE*)("Email Application"),&emess_dbid);
        DataOpenDB(emess_dbid, 0, OPEN_RW);

		/* Open Database */
		DataCategorySetName(emess_dbid,0,(BYTE*)(""));
		DataCategorySetName(emess_dbid,1,(BYTE*)("Inbox"));
		DataCategorySetName(emess_dbid,2,(BYTE*)("Outbox"));
		DataCategorySetName(emess_dbid,3,(BYTE*)("Sent"));
		DataCategorySetName(emess_dbid,4,(BYTE*)("Draft"));

		/* Record 1 */
		DataNewRecord(emess_dbid, 1, 9, &rec_id);
        strcpy(date, (BYTE*)("20000301000000"));
		DataWriteField(emess_dbid,rec_id,0, strlen(date) + 1, date);
		DataWriteField(emess_dbid,rec_id,1,1, (BYTE*)(""));
        strcpy(from, (BYTE*)("Customer Service<custservice@vtechinfo.com>"));
		DataWriteField(emess_dbid,rec_id,2,(strlen(from) + 1), from);
        strcpy(to, (BYTE*)("Helio User<heliouser@heliouser.com>"));
		DataWriteField(emess_dbid,rec_id,3,(strlen(to) + 1), to);
		strcpy(cc, (BYTE*)(""));
		DataWriteField(emess_dbid,rec_id,4,(strlen(cc) + 1), cc);
		strcpy(bcc, (BYTE*)(""));
		DataWriteField(emess_dbid,rec_id,5,(strlen(bcc) + 1),bcc);
		strcpy(sub, (BYTE*)("Email Set-up & Synchronization"));
		DataWriteField(emess_dbid,rec_id,6,(strlen(sub) + 1), sub);
        strcpy(body,(BYTE*)("Dear Helio User,\r\rThank you for buying a Helio!\r\rAfter configuring the e-mail setting, the Helio can download your e-mail from your internet service provider via an external modem. Simply tap the System Setup icon on the Main Menu and then tap the Email Settings icon. Fill out all information and tap OK to save your settings. You can enter a maximum of four settings to create shortcuts to different internet service providers.\r\rYou can manage your e-mails anywhere you go. When you synchronize the Helio with your desktop computer,the Helio system puts a copy of your inbox e-mail onto your Helio.You can read, forward, reply or delete the messages on the Helio.If you delete an e-mail message, the same message on your desktop will be deleted the next time you synchronize the Helio.\r\rPlease refer to manual for detailed description."));
		DataWriteField(emess_dbid,rec_id,7,(strlen(body) + 1), body);
		DataCloseRecord(emess_dbid,rec_id);


		DataNewRecordWithID(emess_dbid, TIME_INDEX_RECID, 0, 4);

		/* inbox time index */
        time_index = 1;
		time_index = EL32(time_index);
		DataWriteField(emess_dbid, TIME_INDEX_RECID, 0, 4, (BYTE*) &time_index);

		/* outbox time index */
        time_index = 0;
		time_index = EL32(time_index);
		DataWriteField(emess_dbid, TIME_INDEX_RECID, 1, 4, (BYTE*) &time_index);

		/* sent time index */
        time_index = 0;
		time_index = EL32(time_index);
		DataWriteField(emess_dbid, TIME_INDEX_RECID, 2, 4, (BYTE*) &time_index);

		/* draft time index */
        time_index = 0;
		time_index = EL32(time_index);
		DataWriteField(emess_dbid, TIME_INDEX_RECID, 3, 4, (BYTE*) &time_index);

        DataCloseDB(emess_dbid);
	}
}

/*****************************************************************
 * Function:	AppExpenseDatabaseInit
 * Purpose: 	Init Expense Database
 * Scope:		application
 * Input:		None
 * Output:		None
 * Return:		TRUE if success
 *				FALSE if no memory
 * Comment: 	This function should be called in the StartApplication() function.
*****************************************************************/
void AppExpenseDatabaseInit()
{
	DatabaseID		Expense_dbid;
    Err             Error;
	BYTE			curr_to_cat;
	WORD			i;


	/* New Database */
	if (DataFindDB((BYTE*)"ExpenseDatabase", &Expense_dbid) != TRUE)
    {
        Error = DataNewDB((BYTE*)"ExpenseDatabase", 0, (BYTE*)("Expense Application"), &Expense_dbid);
        DataOpenDB(Expense_dbid, 0, OPEN_RW);


		if (DataNewRecordWithID(Expense_dbid, 0x80001000, 0, 50) != TRUE)
                        return;
		curr_to_cat = 25;
		for(i=0; i<50; i++)
		if (DataWriteField(Expense_dbid, 0x80001000, (USHORT)i, sizeof(BYTE), &curr_to_cat) != TRUE)
                        return;


        /* Open Database */
        DataCategorySetName(Expense_dbid,0,(BYTE*)(""));
        DataCategorySetName(Expense_dbid,1,(BYTE*)("Business"));
        DataCategorySetName(Expense_dbid,2,(BYTE*)("Personal"));
        DataCloseDB(Expense_dbid);
    }
}

/********************************************************
 * Function:	SchedulerDBAppmtToBuffer
 * Purpose: 	This function is called to convert appointment 
				data to buffers				
 * Scope:		application
 * Input:		appmt_rec			Array of appointment records
				string				Collective string
				num_appmt
 * Output:		appmt_rec_buf
				string_buf
				num_bytes_appmt
				num_bytes_string
 * Return:		None
 * Comment: 	This function should be called in the StartApplication() function.
 *********************************************************/
void SchedulerDBAppmtToBuffer(AppointmentDB *appmt_rec, BYTE **string, WORD num_appmt, 
			      BYTE **appmt_rec_buf, BYTE **string_buf, WORD *num_bytes_appmt,
			      WORD *num_bytes_string)
{
	USHORT num;
	BYTE *temp, *temp1;

	*num_bytes_appmt = 0;
	*num_bytes_string = 0;

	for (num = 0; num < num_appmt; num++)
		*num_bytes_string += strlen(string[num]);
	*num_bytes_string += num_appmt;
	*num_bytes_appmt = sizeof(AppointmentDB) * num_appmt;

	*appmt_rec_buf = (BYTE*)qmalloc(*num_bytes_appmt *sizeof(BYTE));
	*string_buf = (BYTE*)qmalloc(*num_bytes_string *sizeof(BYTE));

	temp = *appmt_rec_buf;
	temp1 = *string_buf;

	for (num = 0; num < num_appmt; num++)
	{
		*((AppointmentDB*)temp) = appmt_rec[num];
		temp += sizeof(AppointmentDB);
		strcpy(temp1, string[num]);
		temp1 += strlen(string[num]) + 1;
	}
}

/********************************************************
 * Function:	AppSchedulerDatabaseInit
 * Purpose: 	Init Scheduler Database
 * Scope:	application/internal
 * Input:	None
 * Output:	None
 * Return:	None
 * Comment: 	None
 *********************************************************/
void AppSchedulerDatabaseInit()
{
	DatabaseID	sch_appmt_dbid, sch_voice_dbid;
	AppointmentDB 	appmt_rec[10];
	BYTE 		*appmt_string[10];
	BYTE 		appmt_date[4];
	BYTE 		*appmt_rec_buf;
	BYTE 		*appmt_string_buf;
    WORD        i, num_bytes_appmt, num_bytes_string;
	RecordID 	rec_id;
	BYTE 		alarm;

	if (DataFindDB((BYTE*)("Scheduler Appointment Database"), &sch_appmt_dbid) != TRUE)
	{	
		DataNewDB((BYTE*)("Scheduler Appointment Database"),1,(BYTE*)("Scheduler Application"),&sch_appmt_dbid);
		DataOpenDB(sch_appmt_dbid,0,OPEN_RW);

		DataCloseDB(sch_appmt_dbid);
	}
	if (DataFindDB((BYTE*)("Scheduler Voice Database"), &sch_voice_dbid) != TRUE)
		DataNewDB((BYTE*)("Scheduler Voice Database"),1,(BYTE*)("Scheduler Application"),&sch_voice_dbid);
}

/********************************************************
 * Function:	AppToDoDatabaseInit
 * Purpose: 	Init ToDo Database
 * Scope:	application/internal
 * Input:	None
 * Output:	None
 * Return:	None
 * Comment: 	None
 *********************************************************/
void AppToDoDatabaseInit()
{
	DatabaseID	tdl_dbid, sound_dbid;
    BYTE        temp, content[4000];
    RecordID    rec_id;


    if (DataFindDB((BYTE*)("To Do List Database"), &tdl_dbid) != TRUE)
    {		
	DataNewDB((BYTE*)("To Do List Database"),0,(BYTE*)("To Do List Application"),&tdl_dbid);
	DataOpenDB(tdl_dbid, 1, OPEN_RW);	


	/* Record 1 */
	DataNewRecord(tdl_dbid,0,7,&rec_id);
    temp = 0;
	DataWriteField(tdl_dbid,rec_id, 0, 1,  (BYTE*)&temp);
	temp = 0;
	DataWriteField(tdl_dbid,rec_id, 1, 1,  (BYTE*)&temp);
	temp = 1;
	DataWriteField(tdl_dbid,rec_id, 2, 1,  (BYTE*)&temp);
    strcpy(content, (BYTE*)("Important - Register your Helio!\r\rFill out the registration card and return it by mail or fax.\rThen you will get:\r\ra) Free technical support\rb) Free software\rc) Free information\rd) A 1 year warranty"));
	DataWriteField(tdl_dbid,rec_id, 3, strlen(content) + 1,  (BYTE*)&content);
    strcpy(content, (BYTE*)("2000/03/01"));
	DataWriteField(tdl_dbid,rec_id, 4, strlen(content) + 1,  (BYTE*)&content);
	strcpy(content, (BYTE*)(""));
	DataWriteField(tdl_dbid,rec_id, 5, strlen(content) + 1,  (BYTE*)&content);
	DataWriteField(tdl_dbid,rec_id, 6, sizeof(RecordID),  (BYTE*)&rec_id);
	DataCloseRecord(tdl_dbid, rec_id);

	DataCloseDB(tdl_dbid);
    }
    if (DataFindDB((BYTE*)("To Do Sound Database"), &sound_dbid) != TRUE)
        DataNewDB((BYTE*)("To Do Sound Database"),0,(BYTE*)("To Do List Application"),&sound_dbid);
}

/********************************************************
 * Function:	AppAnniversariesDatabaseInit
 * Purpose: 	Init Anniversaries Database
 * Scope:	application/internal
 * Input:	None
 * Output:	None
 * Return:	None
 * Comment: 	None
 *********************************************************/
void AppAnniversariesDatabaseInit()
{
	DatabaseID	ann_dbid;

    if (DataFindDB((BYTE*)("Anniversaries Database"), &ann_dbid) != TRUE)
			DataNewDB((BYTE*)("Anniversaries Database"),1,(BYTE*)("Anniversaries Application"),&ann_dbid);
}

/********************************************************
 * Function:	AppVoxMemoDatabaseInit
 * Purpose: 	Init VoxMemo Database
 * Scope:	application/internal
 * Input:	None
 * Output:	None
 * Return:	None
 * Comment: 	None
 *********************************************************/
void AppVoxMemoDatabaseInit()
{
	DatabaseID	VoxMemo_dbid;

	if (DataFindDB((BYTE*)"VoxMemoDatabase", &VoxMemo_dbid) != TRUE)
		DataNewDB((BYTE*)"VoxMemoDatabase", 0, (BYTE*)("VoxMemo Application"), &VoxMemo_dbid);
}

/********************************************************
 * Function:    AppMemoDatabaseInit
 * Purpose: 	Init VoxMemo Database
 * Scope:	application/internal
 * Input:	None
 * Output:	None
 * Return:	None
 * Comment: 	None
 *********************************************************/
void AppMemoDatabaseInit()
{
	DatabaseID	memo_dbid;	
    BYTE        content[4000];
	BYTE		sketch;
    RecordID    rec_id;
    WORD        length;

	if (DataFindDB((BYTE*)"Memo Database", &memo_dbid) != TRUE)	
	{
		DataNewDB((BYTE*)("Memo Database"),1,(BYTE*)("Memo Application"),&memo_dbid);
		DataOpenDB(memo_dbid, 1, OPEN_RW);	
		DataCategorySetName(memo_dbid, 0, (BYTE*)("Unfiled"));
		DataCategorySetName(memo_dbid, 1, (BYTE*)("Business"));
        DataCategorySetName(memo_dbid, 2, (BYTE*)("Personal"));      

		/* Record 1 */
        DataNewRecord(memo_dbid,0,4,&rec_id);
		sketch = 0;
        DataWriteField(memo_dbid,rec_id, 0, 8,  (BYTE*)&sketch);
        strcpy(content, (BYTE*)("1. Regularly visit our web site at www.vtechinfo.com to get the latest information about VTech products and to download free software to the Helio.\r\r2. Entering Characters into Helio\r\rThere are four methods to enter text into Helio:\r\ra) Stylus\r\rUse your stylus to write letters, numbers and symbols on the writing pad. Built-in CIC's JOT"));
        length = strlen(content);
        content[length] = 174;
        content[length + 1] = 0;
        sprintf(content + length + 1, "%s", (BYTE*)(" handwriting recognition software will immediately translate and display the characters on screen.\r\rb) On-screen Keyboard\r\rTap the keyboard icon on the writing pad for the alphabetic keyboard. You can switch to numeric keyboard by tapping the \"123\" button on the alphabetic keyboard. For symbolic keyboard, simply tap the \"sym\" button on the numeric keyboard.\r\rc) Keyboard Modem\r\rType letters, numbers and symbols into the Helio via an optional keyboard modem. Please visit the web site at www.vtechinfo.com to see its availability.\r\rd) Your PC's Keyboard\r\rType your data into the applications on the Helio desktop, then put the Helio into the cradle and activate synchronization to transmit the data to your Helio."));
        DataWriteField(memo_dbid,rec_id, 1, (strlen(content) + 1),  content);
        strcpy(content, (BYTE*)("2000/03/01"));
		DataWriteField(memo_dbid,rec_id, 2, (strlen(content) + 1),  content);
        DataWriteField(memo_dbid,rec_id, 3, 1, (BYTE*)(""));
		DataCloseRecord(memo_dbid,rec_id);

		DataCloseDB(memo_dbid);
	}

}

/********************************************************
 * Function:    AppSketchDatabaseInit
 * Purpose:     Init Sketch Database
 * Scope:	application/internal
 * Input:	None
 * Output:	None
 * Return:	None
 * Comment: 	None
 *********************************************************/
void AppSketchDatabaseInit()
{
    DatabaseID  dbid; 

    if (DataFindDB((BYTE *)"Sketch Database", &dbid) != TRUE)
        DataNewDB((BYTE *)"Sketch Database", 0, (BYTE *)"Sketch", &dbid);
}     

/********************************************************
 * Function:	AllApplicationDatabaseInit
 * Purpose: 	This function is called to init all database 
 * Scope:	application
 * Input:	None
 * Output:	None
 * Return:	None
 * Comment: 	None
 *********************************************************/
void AllApplicationDatabaseInit()
{
#ifdef DEBUG
    printf("\n =========== Enter DBINIT ===========");
#endif

    AppPhonebookDatabaseInit();
    
    AppEmailDatabaseInit();
    
    AppExpenseDatabaseInit();
  
    AppSchedulerDatabaseInit();
    
    AppToDoDatabaseInit();
    
	SySetupDatabaseInit();
	
    AppAnniversariesDatabaseInit();
    
    AppVoxMemoDatabaseInit();
    
    AppMemoDatabaseInit();
    
    AppSketchDatabaseInit();

#ifdef DEBUG
    printf("\n =========== Exit DBINIT ===========");
#endif
}



