/*
================================ COPYRIGHT ================================
The contents of this file are subject to the VTech Informations Ltd. License
of VT-OS Ver. 1.1 operating system (the "License"); you may not use this 
file except in compliance with the License.  
 
Software distributed under the License is distributed on an "AS IS" basis, 
WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
for the specific language governing rights and limitations under the License.
 
The Original Code is VT-OS Ver. 1.1 Operating System, released 
on October 1st, 1999

The Initial Developer of the Original Code is VTech Informations Ltd.  All 
codes are Copyright (C) VTech Informations Ltd. 1999.  All Rights Reserved.
===========================================================================
*/

/*
===========================================================================
File        :   dev_pen.c
Author(s)   :   Andrew Hui
Company     :   VTech Informations Ltd.
Project     :   Helio 
Date:	    :   October 1st, 1999
Purpose:	:   Pen low level device driver
Revision    :   1.1
Note        :   23/09/98   Prepared by Andrew Hui (AH)     
               23/09/98   V1.0 release (AH)                               
               09/12/98   V1.1 release (AH) <Optimize to O3>              
               15/12/98   V1.2 release (AH) <Optimize to O3>              
               05/01/99   V1.3 release (AH) <Optimize to O3>              
               18/05/99   V1.4 release (AH) <Optimize to O3>              
               05/08/99   V1.5 Change reset signal                        
===========================================================================
*/              


#include "platform.h"
#ifdef PR31700

#include "include\datatype.h"
#include "include\pr31700s.h"
#include "include\pr31700c.h"
#include "include\dev_sib.h"
#include "include\dev_pen.h"
#include "include\dev_bety.h"
#include "include\intc.h"

volatile WORD BtyRstState;

void  BettyReset()
{
    volatile register WORD i;

    CPU->REG_IR_CTRL_1 |= (1 << 2); i=0xF; while (i--);
    CPU->REG_IR_CTRL_1 &= ~(1 << 2);i=0xFF;while (i--);
    CPU->REG_IR_CTRL_1 |= (1 << 2); i=0xF; while (i--);
}                                    


void BettyInitSM()
{
    switch(BtyRstState)
    {

        case 0:     /* set io pin to output */
                    BtyRstState++;
                    SibEngaged ++;
                    BtyAdcAccess(BettyInitSM);
                    break;

        case 1:     /* set io pin to output */
                    BtyRstState++;
                    SibAccess((BETTY_IO_PORT_DIRECTN |0x0 |1<<15 |BTY_WRT), 0);
                    SibAccess((BETTY_RIS_INT_ENABLE|BTY_WRT), 0);
                    SibAccess((BETTY_FAL_INT_ENABLE|BTY_WRT ), 0);
                    SibAccess((BETTY_INT_CLEAR|BTY_WRT), 0);
                    SibAccess((BETTY_INT_CLEAR |0x0ffff|BTY_WRT), 0);

                    SibAccess((BETTY_TEL_CTRL_A |BTY_WRT), 0);
                    SibAccess((BETTY_TEL_CTRL_B|BTY_TEL_MUTE  |BTY_WRT), 0);
                    SibAccess((BETTY_AUD_CTRL_A|BTY_WRT), 0);
                    SibAccess((BETTY_AUD_CTRL_B | BTY_AUD_MUTE |BTY_WRT), 0);
                    SibAccess(( BETTY_TS_CTRL   |BTY_TSMY_POW     |BTY_TSPY_GND
                               |BTY_TSC_MODE(2) |BTY_TSC_BIAS_ENA |BTY_WRT),
                                0);
                    SibAccess(( BETTY_ADC_CTRL
                                |TTP_ADC_PX
                                |BTY_ADC_SYNC_ENA |BTY_VREFBYP_CON
                                |BTY_WRT), 0);
                    SibAccess((BETTY_MODE|BTY_WRT), BettyInitSM);
                    break;
        case 2:
                    SibEngaged --;
                    BtyRstState=0;
                    break;
    }

    if (BtyRstState==0)
    {
        AdcQueue[AdcQPtr.front].status=ADC_Q_COMPLETE;
        BtyAdcAccessHandler();
    }

}


void  BettyInit()
{

    BtyRstState=0;

    DIS_GBL_INT ;
    BettyInitSM();
    ENA_GBL_INT ;

    while(BtyRstState!=0)
    {
     __asm(" nop");
     __asm(" nop");
     __asm(" nop");
     __asm(" nop");
    }
}



#endif

