/*
================================ COPYRIGHT ================================
The contents of this file are subject to the VTech Informations Ltd. License
of VT-OS Ver. 1.1 operating system (the "License"); you may not use this 
file except in compliance with the License.  
 
Software distributed under the License is distributed on an "AS IS" basis, 
WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
for the specific language governing rights and limitations under the License.
 
The Original Code is VT-OS Ver. 1.1 Operating System, released 
on October 1st, 1999

The Initial Developer of the Original Code is VTech Informations Ltd.  All 
codes are Copyright (C) VTech Informations Ltd. 1999.  All Rights Reserved.
===========================================================================
*/

/*
===========================================================================
File        :   ints.s
Author(s)   :   Thomas Cheng
Company     :   VTech Informations Ltd.
Project     :   Helio 
Date:	    :   October 1st, 1999
Purpose:	:   Interrupt solving
Revision    :   1.1
Note        :   None
===========================================================================
*/              


	.data
# System Stack Pointer
	.globl	SysSP
SysSP:
	.word	0

# Application Stack Pointer
	.globl	AppSP
AppSP:
	.word	0

# Temporary Stack Pointer
	.globl	TmpSP
TmpSP:
	.word	0

# Temporary System Stack Pointer
	.globl	TmpSysSP
TmpSysSP:
	.word	0

# Temporary Application Stack Pointer
	.globl	TmpAppSP
TmpAppSP:
	.word	0

	.globl	INT1
INT1:
	.word	0
	.globl	INT2
INT2:
	.word	0
	.globl	INT3
INT3:
	.word	0
	.globl	INT4
INT4:
	.word	0
	.globl	INT5
INT5:
	.word	0

	.globl	ClkTick1
ClkTick1:
	.word	0
	.globl	ClkTick2
ClkTick2:
	.word	0

	.globl	IntHighVect
IntHighVect:
	.word	OtherIntHighHandle	#Null
	.word	OtherIntHighHandle	#IOPOSINT(0) or IONEGINT(0)
	.word	OtherIntHighHandle	#CHIDMACNTINT
	.word	OtherIntHighHandle	#TELDMACNTINT
	.word	OtherIntHighHandle	#SNDDMACNTINT
	.word	OtherIntHighHandle	#Reserved
	.word	OtherIntHighHandle	#IONEGINT(6) or IONEGINT(5)
	.word	OtherIntHighHandle	#Reserved
	.word	OtherIntHighHandle	#IOPOSINT(6) or IOPOSINT(5)
	.word	OtherIntHighHandle	#Reserved
	.word	OtherIntHighHandle	#UARTBRXINT
	.word	$GL19			#UARTARXINT
	.word	OtherIntHighHandle	#Reserved
	.word	$GL17			#PERINT
	.word	$GL18			#ALARMINT
	.word	$GL20			#POSPWROKINT or NEGPWROKINT
	

#include "include\datatype.h"
#include "include\pr3910.h"
#include "include\pr31700s.h"

//#define DEBUG
#define C_EPC		6
#define C_STATUS	7
#define C_RA		8
#define C_S0		9
#define C_S1		10
#define C_SYSSIZE	11
#define C_S2		11
#define C_AT		12
#define C_V0		13
#define C_V1		14
#define C_A0		15
#define C_A1		16
#define C_A2		17
#define C_A3		18
#define C_T0		19
#define C_T1		20
#define C_T2		21
#define C_T3		22
#define C_T4		23
#define C_T5		24
#define C_T6		25
#define C_T7		26
#define C_T8		27
#define C_T9		28
#define C_LO		29
#define C_HI		30
#define C_IHSIZE	31
#define C_IE1		31
#define C_IE2		32
#define C_IE3		33
#define C_IE4		34
#define C_IE5		35
#define C_ILSIZE  	36

#define C_MARGIN	6

	.text

# UTLB Exception Handling Routine
	.globl	UtlbExcHandle
	.ent 	UtlbExcHandle
UtlbExcHandle:
	.set 	noat
	.set	reorder

#ifdef DEBUG
	li		k0,CPU_REGS_BASE_ADDR
	lw		k1,MFIO_DATA_OUT(k0)
	ori		k1,k1,1
	sw		k1,MFIO_DATA_OUT(k0)
#endif

	# Save Registers
	subu	sp,C_IHSIZE*4
	mfc0	k0,C0_EPC
	sw		k0,C_EPC*4(sp)
	mfc0	k0,C0_STATUS
	sw		k0,C_STATUS*4(sp)
	sw		ra,C_RA*4(sp)
	sw		s0,C_S0*4(sp)
	sw		s1,C_S1*4(sp)
	sw		s2,C_S2*4(sp)
	sw		AT,C_AT*4(sp)
	sw		v0,C_V0*4(sp)
	sw		v1,C_V1*4(sp)
	sw		a0,C_A0*4(sp)
	sw		a1,C_A1*4(sp)
	sw		a2,C_A2*4(sp)
	sw		a3,C_A3*4(sp)
	sw		t0,C_T0*4(sp)
	sw		t1,C_T1*4(sp)
	sw		t2,C_T2*4(sp)
	sw		t3,C_T3*4(sp)
	sw		t4,C_T4*4(sp)
	sw		t5,C_T5*4(sp)
	sw		t6,C_T6*4(sp)
	sw		t7,C_T7*4(sp)
	sw		t8,C_T8*4(sp)
	sw		t9,C_T9*4(sp)
	mflo	k0
	sw		k0,C_LO*4(sp)
	mfhi	k0
	sw		k0,C_HI*4(sp)

	subu	sp,sp,C_MARGIN*4

	# Extract Exception Code
    mfc0	k0,C0_CAUSE
	andi	k1,k0,CAUSE_EXCMASK

	# Check Utlb Load Exception
	li		k0,EXC_TLBL
	beq		k1,k0,$UL1

	# Check Utlb Store Exception
	li		k0,EXC_TLBS
	beq		k1,k0,$UL2

	# It should be impossible to stay here
	j		$UL200

# Utlb Load Exception
$UL1:
	# Others
	jal		UtlbLoadExcHandle
	j		$UL200

# Utlb Store Exception
$UL2:
	# Others
	jal		UtlbStoreExcHandle
	j		$UL200

# Others
$UL200:

	addu	sp,sp,C_MARGIN*4

	# Restore Registers
	lw		AT,C_AT*4(sp)
	lw		v0,C_V0*4(sp)
	lw		v1,C_V1*4(sp)
	lw		a0,C_A0*4(sp)
	lw		a1,C_A1*4(sp)
	lw		a2,C_A2*4(sp)
	lw		a3,C_A3*4(sp)
	lw		t0,C_T0*4(sp)
	lw		t1,C_T1*4(sp)
	lw		t2,C_T2*4(sp)
	lw		t3,C_T3*4(sp)
	lw		t4,C_T4*4(sp)
	lw		t5,C_T5*4(sp)
	lw		t6,C_T6*4(sp)
	lw		t7,C_T7*4(sp)
	lw		t8,C_T8*4(sp)
	lw		t9,C_T9*4(sp)
	lw		k0,C_LO*4(sp)
	mtlo	k0
	lw		k0,C_HI*4(sp)
	mthi	k0
	lw		s0,C_S0*4(sp)
	lw		s1,C_S1*4(sp)
	lw		s2,C_S2*4(sp)
	lw		ra,C_RA*4(sp)
	lw		k0,C_STATUS*4(sp)
	mtc0	k0,C0_STATUS

#ifdef DEBUG
	li		k0,CPU_REGS_BASE_ADDR
	lw		k1,MFIO_DATA_OUT(k0)
	andi	k1,k1,0xFFFE
	sw		k1,MFIO_DATA_OUT(k0)
#endif

	lw		k0,C_EPC*4(sp)
	addu	sp,C_IHSIZE*4

	# Return To Interrupted Program
	.set 	noreorder
	j		k0
	rfe
	.set	reorder
	.set	at
	.end 	UtlbExcHandle


# General Exception Handling Routine
	.globl	GenExcHandle
	.ent 	GenExcHandle
GenExcHandle:
	.set 	noat
	.set	reorder
/*
	li		k0,CPU_REGS_BASE_ADDR
	lw		k1,INT_STATUS_1(k0)
	la		k0,INT1
	sw		k1,0(k0)

	li		k0,CPU_REGS_BASE_ADDR
	lw		k1,INT_STATUS_2(k0)
	la		k0,INT2
	sw		k1,0(k0)

	li		k0,CPU_REGS_BASE_ADDR
	lw		k1,INT_STATUS_3(k0)
	la		k0,INT3
	sw		k1,0(k0)

	li		k0,CPU_REGS_BASE_ADDR
	lw		k1,INT_STATUS_4(k0)
	la		k0,INT4
	sw		k1,0(k0)

	li		k0,CPU_REGS_BASE_ADDR
	lw		k1,INT_STATUS_5(k0)
	la		k0,INT5
	sw		k1,0(k0)
*/
#if 0
	li		k0,CPU_REGS_BASE_ADDR
	lw		k1,PERIODIC_TIMER(k0)
	srl		k1, k1, 16
	la		k0,ClkTick1
	sw		k1,0(k0)
#endif
#ifdef DEBUG
	li		k0,CPU_REGS_BASE_ADDR
	lw		k1,MFIO_DATA_OUT(k0)
	ori		k1,k1,1
	sw		k1,MFIO_DATA_OUT(k0)
#endif

	# Extract Exception Code
    mfc0	k0,C0_CAUSE
	andi	k1,k0,CAUSE_EXCMASK

	# Check External Interrupt
	beq		k1,zero,$GL1

	# Check Syscall Exception
	li		k0,EXC_SYS
	beq		k1,k0,$GL2

	jal		OtherGenExcHandle
	# Others up to $GL13 maximum
	j		$GL200

# External Interrupt
$GL1:
	# Load Interrupt Status 6 Register
	li		k0,CPU_REGS_BASE_ADDR
	lw		k1,INT_STATUS_6(k0)

	# Check IRQ High
	li		k0,IRQHIGH
	and		k0,k0,k1
	bne		k0,zero,$GL15

#if 1
	b		$GL16
#endif

	# Check IRQ Low
	li		k0,IRQLOW
	and		k0,k0,k1
	bne		k0,zero,$GL16

#if 0
	# Save Registers
	subu	sp,C_IHSIZE*4
	mfc0	k0,C0_EPC
	sw		k0,C_EPC*4(sp)
	mfc0	k0,C0_STATUS
	sw		k0,C_STATUS*4(sp)
	sw		ra,C_RA*4(sp)
	sw		s0,C_S0*4(sp)
	sw		s1,C_S1*4(sp)
	sw		s2,C_S2*4(sp)
	sw		AT,C_AT*4(sp)
	sw		v0,C_V0*4(sp)
	sw		v1,C_V1*4(sp)
	sw		a0,C_A0*4(sp)
	sw		a1,C_A1*4(sp)
	sw		a2,C_A2*4(sp)
	sw		a3,C_A3*4(sp)
	sw		t0,C_T0*4(sp)
	sw		t1,C_T1*4(sp)
	sw		t2,C_T2*4(sp)
	sw		t3,C_T3*4(sp)
	sw		t4,C_T4*4(sp)
	sw		t5,C_T5*4(sp)
	sw		t6,C_T6*4(sp)
	sw		t7,C_T7*4(sp)
	sw		t8,C_T8*4(sp)
	sw		t9,C_T9*4(sp)
	mflo	k0
	sw		k0,C_LO*4(sp)
	mfhi	k0
	sw		k0,C_HI*4(sp)

	jal		ChkPt

	# Restore Registers
	lw		AT,C_AT*4(sp)
	lw		v0,C_V0*4(sp)
	lw		v1,C_V1*4(sp)
	lw		a0,C_A0*4(sp)
	lw		a1,C_A1*4(sp)
	lw		a2,C_A2*4(sp)
	lw		a3,C_A3*4(sp)
	lw		t0,C_T0*4(sp)
	lw		t1,C_T1*4(sp)
	lw		t2,C_T2*4(sp)
	lw		t3,C_T3*4(sp)
	lw		t4,C_T4*4(sp)
	lw		t5,C_T5*4(sp)
	lw		t6,C_T6*4(sp)
	lw		t7,C_T7*4(sp)
	lw		t8,C_T8*4(sp)
	lw		t9,C_T9*4(sp)
	lw		s0,C_LO*4(sp)
	mtlo	s0
	lw		s0,C_HI*4(sp)
	mthi	s0
	lw		s0,C_S0*4(sp)
	lw		s1,C_S1*4(sp)
	lw		s2,C_S2*4(sp)
	lw		ra,C_RA*4(sp)
	lw		k0,C_STATUS*4(sp)
	mtc0	k0,C0_STATUS
	lw		k0,C_EPC*4(sp)
	addu	sp,C_IHSIZE*4
#endif

	# It should be impossible to stay here
	j		$GL200

# IRQ High
$GL15:
	# Save Registers
	subu	sp,C_IHSIZE*4
	mfc0	k0,C0_EPC
	sw		k0,C_EPC*4(sp)
	mfc0	k0,C0_STATUS
	sw		k0,C_STATUS*4(sp)
	sw		ra,C_RA*4(sp)
	sw		s0,C_S0*4(sp)
	sw		s1,C_S1*4(sp)
	sw		s2,C_S2*4(sp)
	sw		AT,C_AT*4(sp)
	sw		v0,C_V0*4(sp)
	sw		v1,C_V1*4(sp)
	sw		a0,C_A0*4(sp)
	sw		a1,C_A1*4(sp)
	sw		a2,C_A2*4(sp)
	sw		a3,C_A3*4(sp)
	sw		t0,C_T0*4(sp)
	sw		t1,C_T1*4(sp)
	sw		t2,C_T2*4(sp)
	sw		t3,C_T3*4(sp)
	sw		t4,C_T4*4(sp)
	sw		t5,C_T5*4(sp)
	sw		t6,C_T6*4(sp)
	sw		t7,C_T7*4(sp)
	sw		t8,C_T8*4(sp)
	sw		t9,C_T9*4(sp)
	mflo	s0
	sw		s0,C_LO*4(sp)
	mfhi	s0
	sw		s0,C_HI*4(sp)

	# Load High Priority Interrupt Vector
	li		s0,CPU_REGS_BASE_ADDR
	lw		s1,INT_STATUS_6(s0)
	andi	s1,s1,INTVECTMASK


	la		s2,IntHighVect
	addu	s1,s1,s2
	lw		s2,0(s1)
	jr		s2


	# Check Periodic Timer Interrupt
	li		s2,VECT_PERINT
	beq		s1,s2,$GL17

	# Check Alarm Interrupt
	li		s2,VECT_ALARMINT
	beq		s1,s2,$GL18

	# Others
	jal		OtherIntHighHandle

$GL197:
	# Restore Registers
	lw		AT,C_AT*4(sp)
	lw		v0,C_V0*4(sp)
	lw		v1,C_V1*4(sp)
	lw		a0,C_A0*4(sp)
	lw		a1,C_A1*4(sp)
	lw		a2,C_A2*4(sp)
	lw		a3,C_A3*4(sp)
	lw		t0,C_T0*4(sp)
	lw		t1,C_T1*4(sp)
	lw		t2,C_T2*4(sp)
	lw		t3,C_T3*4(sp)
	lw		t4,C_T4*4(sp)
	lw		t5,C_T5*4(sp)
	lw		t6,C_T6*4(sp)
	lw		t7,C_T7*4(sp)
	lw		t8,C_T8*4(sp)
	lw		t9,C_T9*4(sp)
	lw		s0,C_LO*4(sp)
	mtlo	s0
	lw		s0,C_HI*4(sp)
	mthi	s0
	lw		s0,C_S0*4(sp)
	lw		s1,C_S1*4(sp)
	lw		s2,C_S2*4(sp)
	lw		ra,C_RA*4(sp)
	lw		k0,C_STATUS*4(sp)
	mtc0	k0,C0_STATUS

#ifdef DEBUG
	li		k0,CPU_REGS_BASE_ADDR
	lw		k1,MFIO_DATA_OUT(k0)
	andi	k1,k1,0xFFFE
	sw		k1,MFIO_DATA_OUT(k0)
#endif

	lw		k0,C_EPC*4(sp)
	addu	sp,C_IHSIZE*4

	j		$GL200

# Periodic Timer Interrupt
$GL17:
	li		s2,PERINT
	sw		s2,INT_STATUS_5(s0)
	jal		TmrISR
	j		$GL197

# Alarm Interrupt
$GL18:
	li		s2,ALARMINT
	sw		s2,INT_STATUS_5(s0)
	jal		AlmISR
	j		$GL197

# Uart A Rx Interrupt
$GL19:
	li		s2,UARTARXINT
	sw		s2,INT_STATUS_5(s0)
	jal		UartIsrRx
	j		$GL197

# Pwr Ok Interrupt
$GL20:
	# Check Interrupt Status 5 Register
	lw		s1,INT_STATUS_5(s0)
	lw		s2,INT_ENABLE_5(s0)
	and		s1,s1,s2

	# Check NegPwrOk Interrupt
	li		s2,NEGPWROKINT
	and		s2,s2,s1
	bne		s2,zero,$GL21

	# Check PosPwrOk Interrupt
	li		s2,POSPWROKINT
	and		s2,s2,s1
	bne		s2,zero,$GL22

# NegPwrOk Interrupt
$GL21:
    sw      s2,INT_STATUS_5(s0)
    jal     NegPwrOkIntISR
	j		$GL197

# PosPwrOk Interrupt
$GL22:
    sw      s2,INT_STATUS_5(s0)
    jal     PosPwrOkIntISR
	j		$GL197

# IRQ Low
$GL16:
	# Save Registers
	subu	sp,C_ILSIZE*4
	mfc0	k0,C0_EPC
	sw		k0,C_EPC*4(sp)
	mfc0	k0,C0_STATUS
	sw		k0,C_STATUS*4(sp)
	sw		ra,C_RA*4(sp)
	sw		s0,C_S0*4(sp)
	sw		s1,C_S1*4(sp)
	sw		s2,C_S2*4(sp)
	sw		AT,C_AT*4(sp)
	sw		v0,C_V0*4(sp)
	sw		v1,C_V1*4(sp)
	sw		a0,C_A0*4(sp)
	sw		a1,C_A1*4(sp)
	sw		a2,C_A2*4(sp)
	sw		a3,C_A3*4(sp)
	sw		t0,C_T0*4(sp)
	sw		t1,C_T1*4(sp)
	sw		t2,C_T2*4(sp)
	sw		t3,C_T3*4(sp)
	sw		t4,C_T4*4(sp)
	sw		t5,C_T5*4(sp)
	sw		t6,C_T6*4(sp)
	sw		t7,C_T7*4(sp)
	sw		t8,C_T8*4(sp)
	sw		t9,C_T9*4(sp)
	mflo	s0
	sw		s0,C_LO*4(sp)
	mfhi	s0
	sw		s0,C_HI*4(sp)

	# Save Interrupt Enable Registers For Nesting
	li		s0,CPU_REGS_BASE_ADDR
	lw		s1,INT_ENABLE_1(s0)
	sw		s1,C_IE1*4(sp)
	lw		s1,INT_ENABLE_2(s0)
	sw		s1,C_IE2*4(sp)
	lw		s1,INT_ENABLE_3(s0)
	sw		s1,C_IE3*4(sp)
	lw		s1,INT_ENABLE_4(s0)
	sw		s1,C_IE4*4(sp)
	lw		s1,INT_ENABLE_5(s0)
	sw		s1,C_IE5*4(sp)

	subu	sp,sp,C_MARGIN*4

	# Check Interrupt Status 1 Register
	li		s0,CPU_REGS_BASE_ADDR
	lw		s1,INT_STATUS_1(s0)
	lw		s2,INT_ENABLE_1(s0)
	and		s1,s1,s2
	bne		s1,zero,$GL30

	# Check Interrupt Status 2 Register
	lw		s1,INT_STATUS_2(s0)
	lw		s2,INT_ENABLE_2(s0)
	and		s1,s1,s2
	bne		s1,zero,$GL65

	# Check Interrupt Status 3 Register
	lw		s1,INT_STATUS_3(s0)
	lw		s2,INT_ENABLE_3(s0)
	and		s1,s1,s2
	bne		s1,zero,$GL100

	# Check Interrupt Status 4 Register
	lw		s1,INT_STATUS_4(s0)
	lw		s2,INT_ENABLE_4(s0)
	and		s1,s1,s2
	bne		s1,zero,$GL135

	# Check Interrupt Status 5 Register
	lw		s1,INT_STATUS_5(s0)
	lw		s2,INT_ENABLE_5(s0)
	and		s1,s1,s2
	bne		s1,zero,$GL170

	# Others

$GL199:
	# Restore Interrupt Enable Registers For Nesting

	jal		DisableGlobal

	addu	sp,sp,C_MARGIN*4
/*
	li		s0,CPU_REGS_BASE_ADDR
	lw		s1,C_IE1*4(sp)
	sw		s1,INT_ENABLE_1(s0)
	lw		s1,C_IE2*4(sp)
	sw		s1,INT_ENABLE_2(s0)
	lw		s1,C_IE3*4(sp)
	sw		s1,INT_ENABLE_3(s0)
	lw		s1,C_IE4*4(sp)
	sw		s1,INT_ENABLE_4(s0)
	lw		s1,C_IE5*4(sp)
	sw		s1,INT_ENABLE_5(s0)
*/
	# Restore Registers
	lw		AT,C_AT*4(sp)
	lw		v0,C_V0*4(sp)
	lw		v1,C_V1*4(sp)
	lw		a0,C_A0*4(sp)
	lw		a1,C_A1*4(sp)
	lw		a2,C_A2*4(sp)
	lw		a3,C_A3*4(sp)
	lw		t0,C_T0*4(sp)
	lw		t1,C_T1*4(sp)
	lw		t2,C_T2*4(sp)
	lw		t3,C_T3*4(sp)
	lw		t4,C_T4*4(sp)
	lw		t5,C_T5*4(sp)
	lw		t6,C_T6*4(sp)
	lw		t7,C_T7*4(sp)
	lw		t8,C_T8*4(sp)
	lw		t9,C_T9*4(sp)
	lw		s0,C_LO*4(sp)
	mtlo	s0
	lw		s0,C_HI*4(sp)
	mthi	s0
	lw		s0,C_S0*4(sp)
	lw		s1,C_S1*4(sp)
	lw		s2,C_S2*4(sp)
	lw		ra,C_RA*4(sp)
	lw		k0,C_STATUS*4(sp)
	mtc0	k0,C0_STATUS

#if 0
	li		k0,CPU_REGS_BASE_ADDR
	lw		k1,PERIODIC_TIMER(k0)
	srl		k1, k1, 16
	la		k0,ClkTick2
	sw		k1,0(k0)
#endif

#ifdef DEBUG
	li		k0,CPU_REGS_BASE_ADDR
	lw		k1,MFIO_DATA_OUT(k0)
	andi	k1,k1,0xFFFE
	sw		k1,MFIO_DATA_OUT(k0)
#endif

	lw		k0,C_EPC*4(sp)
	addu	sp,C_ILSIZE*4

	j		$GL200

# Interrupt Status 1 Register
$GL30:
	# Check	Sib SF0 Interrupt
	li		s2,SIBSF0INT
	and		s2,s2,s1
	bne		s2,zero,$GL31

	# Check	Sib SF1 Interrupt
	li		s2,SIBSF1INT
	and		s2,s2,s1
	bne		s2,zero,$GL32

	# Check	Sib Irq Positive Interrupt
	li		s2,SIBIRQPOSINT
	and		s2,s2,s1
	bne		s2,zero,$GL33

	# Check	Tel DMA Half Interrupt
	li		s2,TEL0_5INT
	and		s2,s2,s1
	bne		s2,zero,$GL34

	# Check	Tel DMA Full Interrupt
	li		s2,TEL1_0INT
	and		s2,s2,s1
	bne		s2,zero,$GL35

    # Check Snd DMA Full Interrupt
    li      s2,SND1_0INT
	and		s2,s2,s1
    bne     s2,zero,$GL36

	# Others
	jal		OtherIntLow1Handle
	j		$GL199

# Sib SF0 Interrupt
$GL31:
	sw		s2,INT_STATUS_1(s0)
//	li		a0,23
//	jal		IntMaskIntEnable
//	jal		EnableGlobal
	jal		SF0Isr
	j		$GL199

# Sib SF1 Interrupt
$GL32:
	sw		s2,INT_STATUS_1(s0)
//	li		a0,23
//	jal		IntMaskIntEnable
//	jal		EnableGlobal
	jal		SF1Isr
	j		$GL199

# Sib Irq Positive Interrupt
$GL33:
	sw		s2,INT_STATUS_1(s0)
//	li		a0,25
//	jal		IntMaskIntEnable
//	jal		EnableGlobal
	jal		SibIrqPosISR
	j		$GL199

# Tel DMA Half Interrupt
$GL34:
	sw		s2,INT_STATUS_1(s0)
	jal		Tel0_5ISR
	j		$GL199

# Tel DMA Full Interrupt
$GL35:
	sw		s2,INT_STATUS_1(s0)
	jal		Tel1_0ISR
	j		$GL199

# Snd DMA Full Interrupt
$GL36:
	sw		s2,INT_STATUS_1(s0)
    jal     SndIntHandler
	j		$GL199

# Interrupt Status 2 Register
$GL65:
	# Check	UartA Rx Interrupt
	li		s2,UARTARXINT
	and		s2,s2,s1
	bne		s2,zero,$GL66

	# Check	UartA Rx Overrun Interrupt
	li		s2,UARTARXOVERRUNINT
	and		s2,s2,s1
	bne		s2,zero,$GL67

	# Check	UartA DMA Full Interrupt
	li		s2,UARTADMAFULLINT
	and		s2,s2,s1
	bne		s2,zero,$GL68

	# Others
	jal		OtherIntLow2Handle
	j		$GL199

# UartA Rx Interrupt
$GL66:
	sw		s2,INT_STATUS_2(s0)
//	li		a0,27
//	jal		IntMaskIntEnable
//	jal		EnableGlobal
	jal		UartIsrRx
	j		$GL199

# UartA Rx Overrun Interrupt
$GL67:
	sw		s2,INT_STATUS_2(s0)
//	li		a0,28
//	jal		IntMaskIntEnable
//	jal		EnableGlobal
//	jal
	j		$GL199

# UartA DMA Full Interrupt
$GL68:
	sw		s2,INT_STATUS_2(s0)
//	li		a0,35
//	jal		IntMaskIntEnable
//	jal		EnableGlobal
	jal		UartADmaFullIsr
	j		$GL199

# Interrupt Status 3 Register
$GL100:
	# Check MFIO 0 Interrupt
    li		s2,MFIOPOSINT(0)
	and		s2,s2,s1
    bne		s2,zero,$GL101

################################################
    # Check MFIO 25 Interrupt
    li      s2,MFIOPOSINT(25)
	and		s2,s2,s1
    bne     s2,zero,$GL102

    # Check MFIO 30 Interrupt
    li      s2,MFIOPOSINT(30)
	and		s2,s2,s1
    bne     s2,zero,$GL103
################################################

    li      s2,MFIOPOSINT(8)
	and		s2,s2,s1
    bne     s2,zero,$GL104

	# Others
	jal		OtherIntLow3Handle
	j		$GL199

# MFIO 0 Interrupt
$GL101:
	sw		s2,INT_STATUS_3(s0)
    jal     CheckKey8
	j		$GL199

################################################
# MFIO 25 Interrupt
$GL102:
	sw		s2,INT_STATUS_3(s0)
    jal     DisHotSynCheck
	j		$GL199

# MFIO 30 Interrupt
$GL103:
	sw		s2,INT_STATUS_3(s0)
    jal     DisSioDevDet
	j		$GL199
################################################

# MFIO Pos 8 Interrupt
$GL104:
	sw		s2,INT_STATUS_3(s0)
    jal     PosBatDoorIntISR
	j		$GL199


# Interrupt Status 4 Register
$GL135:

################################################
    # Check MFIO 25 Interrupt
    li      s2,MFIONEGINT(25)
	and     s2,s2,s1
	bne     s2,zero,$GL136

	# Check MFIO 28 Interrupt
	li      s2,MFIONEGINT(28)
	and     s2,s2,s1
    bne     s2,zero,$GL137

    # Check MFIO 30 Interrupt
    li      s2,MFIONEGINT(30)
	and     s2,s2,s1
    bne     s2,zero,$GL138
    
    li		s2,MFIONEGINT(8)
    and		s2,s2,s1
    bne		s2,zero,$GL139

################################################

	# Others
	jal		OtherIntLow4Handle
	j		$GL199

################################################

# MFIO 25 Interrupt
$GL136:
	sw      s2,INT_STATUS_4(s0)
    jal     HotSynDebounCheck
	j		$GL199

# MFIO 28 Interrupt
$GL137:
	sw      s2,INT_STATUS_4(s0)
	jal     SIORdy
	j		$GL199


# MFIO 30 Interrupt
$GL138:
	sw      s2,INT_STATUS_4(s0)
    jal     SIODebounCheck
	j		$GL199

# MFIO Neg 8 Interrupt
$GL139:
	sw      s2,INT_STATUS_4(s0)
    jal     NegBatDoorIntISR
	j		$GL199


# Interrupt Status 5 Register
$GL170:
	# Check	Periodic Timer Interrupt
	li		s2,PERINT
	and		s2,s2,s1
	bne		s2,zero,$GL171

	# Check	Alarm Interrupt
	li		s2,ALARMINT
	and		s2,s2,s1
	bne		s2,zero,$GL172

	# Check Negative On Button Interrupt
	li		s2,NEGONBUTNINT
	and		s2,s2,s1
	bne		s2,zero,$GL173

	# Check GPIO Interrupt
	li		s2,IOPOSINT(6)
	and		s2,s2,s1
	bne		s2,zero,$GL174

	# Check GPIO Interrupt
	li		s2,IOPOSINT(5)
	and		s2,s2,s1
	bne		s2,zero,$GL175

	# Check GPIO Interrupt
	li		s2,IOPOSINT(4)
	and		s2,s2,s1
	bne		s2,zero,$GL176

	# Check GPIO Interrupt
	li		s2,IOPOSINT(3)
	and		s2,s2,s1
	bne		s2,zero,$GL177

	# Check GPIO Interrupt
	li		s2,IOPOSINT(2)
	and		s2,s2,s1
	bne		s2,zero,$GL178

	# Check GPIO Interrupt
	li		s2,IOPOSINT(1)
	and		s2,s2,s1
	bne		s2,zero,$GL179

	# Check GPIO Interrupt
	li		s2,IOPOSINT(0)
	and		s2,s2,s1
	bne		s2,zero,$GL180

	# Check POSON Interrupt
	li		s2,POSONBUTNINT
	and		s2,s2,s1
	bne		s2,zero,$GL181

	# Check NegPwrOk Interrupt
	li		s2,NEGPWROKINT
	and		s2,s2,s1
	bne		s2,zero,$GL182

	# Check PosPwrOk Interrupt
	li		s2,POSPWROKINT
	and		s2,s2,s1
	bne		s2,zero,$GL183

	# Check NegPwr Interrupt
	li		s2,NEGPWRINT
	and		s2,s2,s1
	bne		s2,zero,$GL184

	# Check PosPwrOk Interrupt
	li		s2,POSPWRINT
	and		s2,s2,s1
	bne		s2,zero,$GL185

	# Others
	jal		OtherIntLow5Handle
	j		$GL199

# Periodic Timer Interrupt
$GL171:
	sw		s2,INT_STATUS_5(s0)
//	li		a0,113
//	jal		IntMaskIntEnable
//	jal		EnableGlobal
	jal		TmrISR
//	li		a0,113
//	jal		IntRunHookedISR
	j		$GL199

# Alarm Interrupt
$GL172:
	sw		s2,INT_STATUS_5(s0)
//	li		a0,112
//	jal		IntMaskIntEnable
//	jal		EnableGlobal
	jal		AlmISR
	j		$GL199

# Negative Edge On Button Interrupt
$GL173:
	sw		s2,INT_STATUS_5(s0)
//	li		a0,120
//	jal		IntMaskIntEnable
//	jal		EnableGlobal
	jal		NegOnButnISR
	j		$GL199

# GPIO Interrupt
$GL174:
	sw      s2,INT_STATUS_5(s0)
    jal     KeyStop
	j		$GL199

# GPIO Interrupt
$GL175:
    sw      s2,INT_STATUS_5(s0)
    jal     PlaySoundKey
	j		$GL199

# GPIO Interrupt
$GL176:
    sw      s2,INT_STATUS_5(s0)
    jal     KeyDown
	j		$GL199

# GPIO Interrupt
$GL177:
    sw      s2,INT_STATUS_5(s0)
    jal     KeyUp
	j		$GL199

# GPIO Interrupt
$GL178:
    sw      s2,INT_STATUS_5(s0)
    jal     IOCtrl
	j		$GL199

# GPIO Interrupt
$GL179:
    sw      s2,INT_STATUS_5(s0)
    jal     IOCtrl
	j		$GL199

# GPIO Interrupt
$GL180:
    sw      s2,INT_STATUS_5(s0)
    jal     IOCtrl
	j		$GL199

# POSON Interrupt
$GL181:
    sw      s2,INT_STATUS_5(s0)
    jal     PowerCtrl
	j		$GL199

# NegPwrOk Interrupt
$GL182:
    sw      s2,INT_STATUS_5(s0)
    jal     NegPwrOkIntISR
	j		$GL199

# PosPwrOk Interrupt
$GL183:
    sw      s2,INT_STATUS_5(s0)
    jal     PosPwrOkIntISR
	j		$GL199

# NegPwr Interrupt
$GL184:
    sw      s2,INT_STATUS_5(s0)
    jal     NegPwrIntISR
	j		$GL199

# PosPwr Interrupt
$GL185:
    sw      s2,INT_STATUS_5(s0)
    jal     PosPwrIntISR
	j		$GL199

# Syscall Exception
$GL2:
# Application Stack Pointer
	# Swap Between Stack and System Stack Pointer
	la		k1,AppSP
	sw		sp,0(k1)
	la		k1,SysSP
	lw		sp,0(k1)
# System Stack Pointer

	# Save Registers
	subu	sp,C_SYSSIZE*4
	mfc0	k0,C0_EPC
	addiu	k0,k0,4
	sw		k0,C_EPC*4(sp)
	mfc0	k0,C0_STATUS
	sw		k0,C_STATUS*4(sp)
	sw		ra,C_RA*4(sp)
	sw		s0,C_S0*4(sp)
	sw		s1,C_S1*4(sp)

# System Stack Pointer
	# Swap Between Stack and System Stack Pointer
	la		k1,SysSP
	sw		sp,0(k1)
	la		k1,AppSP
	lw		sp,0(k1)
# Application Stack Pointer

# Thomas 240899
	li		s0,0x80000000
	and		s0,s0,v0
	beq		s0,$0,$SCFS

	# Jump To Corresponding	Hooked Syscall Exception Handler
	sub		v0,v0,s0
	sll		v0,v0,3
	la		s0,SysCallHookedFptr
	addu		v0,v0,s0
	lw		s0,0(v0)
	j		$SCFE

$SCFS:
	# Jump To Corresponding	Syscall Exception Handler
	sll		v0,v0,2
	la		s0,SysCallFptr
	addu	v0,v0,s0
	lw		s0,0(v0)
$SCFE:	

#if 0
	# Save Registers
	subu	sp,C_IHSIZE*4
	mfc0	k0,C0_EPC
	sw		k0,C_EPC*4(sp)
	mfc0	k0,C0_STATUS
	sw		k0,C_STATUS*4(sp)
	sw		ra,C_RA*4(sp)
	sw		s0,C_S0*4(sp)
	sw		s1,C_S1*4(sp)
	sw		s2,C_S2*4(sp)
	sw		AT,C_AT*4(sp)
	sw		v0,C_V0*4(sp)
	sw		v1,C_V1*4(sp)
	sw		a0,C_A0*4(sp)
	sw		a1,C_A1*4(sp)
	sw		a2,C_A2*4(sp)
	sw		a3,C_A3*4(sp)
	sw		t0,C_T0*4(sp)
	sw		t1,C_T1*4(sp)
	sw		t2,C_T2*4(sp)
	sw		t3,C_T3*4(sp)
	sw		t4,C_T4*4(sp)
	sw		t5,C_T5*4(sp)
	sw		t6,C_T6*4(sp)
	sw		t7,C_T7*4(sp)
	sw		t8,C_T8*4(sp)
	sw		t9,C_T9*4(sp)
	mflo	k0
	sw		k0,C_LO*4(sp)
	mfhi	k0
	sw		k0,C_HI*4(sp)

	addu	a0,s0,0
	addu	a1,ra,0
	li		a2,0
	jal		ChkPt

	# Restore Registers
	lw		AT,C_AT*4(sp)
	lw		v0,C_V0*4(sp)
	lw		v1,C_V1*4(sp)
	lw		a0,C_A0*4(sp)
	lw		a1,C_A1*4(sp)
	lw		a2,C_A2*4(sp)
	lw		a3,C_A3*4(sp)
	lw		t0,C_T0*4(sp)
	lw		t1,C_T1*4(sp)
	lw		t2,C_T2*4(sp)
	lw		t3,C_T3*4(sp)
	lw		t4,C_T4*4(sp)
	lw		t5,C_T5*4(sp)
	lw		t6,C_T6*4(sp)
	lw		t7,C_T7*4(sp)
	lw		t8,C_T8*4(sp)
	lw		t9,C_T9*4(sp)
	lw		s0,C_LO*4(sp)
	mtlo	s0
	lw		s0,C_HI*4(sp)
	mthi	s0
	lw		s0,C_S0*4(sp)
	lw		s1,C_S1*4(sp)
	lw		s2,C_S2*4(sp)
	lw		ra,C_RA*4(sp)
	lw		k0,C_STATUS*4(sp)
	mtc0	k0,C0_STATUS
	lw		k0,C_EPC*4(sp)
	addu	sp,C_IHSIZE*4
#endif

	jal		EnableGlobal

	jalr	s0

	jal		DisableGlobal

#if 0
	# Save Registers
	subu	sp,C_IHSIZE*4
	mfc0	k0,C0_EPC
	sw		k0,C_EPC*4(sp)
	mfc0	k0,C0_STATUS
	sw		k0,C_STATUS*4(sp)
	sw		ra,C_RA*4(sp)
	sw		s0,C_S0*4(sp)
	sw		s1,C_S1*4(sp)
	sw		s2,C_S2*4(sp)
	sw		AT,C_AT*4(sp)
	sw		v0,C_V0*4(sp)
	sw		v1,C_V1*4(sp)
	sw		a0,C_A0*4(sp)
	sw		a1,C_A1*4(sp)
	sw		a2,C_A2*4(sp)
	sw		a3,C_A3*4(sp)
	sw		t0,C_T0*4(sp)
	sw		t1,C_T1*4(sp)
	sw		t2,C_T2*4(sp)
	sw		t3,C_T3*4(sp)
	sw		t4,C_T4*4(sp)
	sw		t5,C_T5*4(sp)
	sw		t6,C_T6*4(sp)
	sw		t7,C_T7*4(sp)
	sw		t8,C_T8*4(sp)
	sw		t9,C_T9*4(sp)
	mflo	k0
	sw		k0,C_LO*4(sp)
	mfhi	k0
	sw		k0,C_HI*4(sp)

	addu	a0,s0,0
	addu	a1,ra,0
	li		a2,1
	jal		ChkPt

	# Restore Registers
	lw		AT,C_AT*4(sp)
	lw		v0,C_V0*4(sp)
	lw		v1,C_V1*4(sp)
	lw		a0,C_A0*4(sp)
	lw		a1,C_A1*4(sp)
	lw		a2,C_A2*4(sp)
	lw		a3,C_A3*4(sp)
	lw		t0,C_T0*4(sp)
	lw		t1,C_T1*4(sp)
	lw		t2,C_T2*4(sp)
	lw		t3,C_T3*4(sp)
	lw		t4,C_T4*4(sp)
	lw		t5,C_T5*4(sp)
	lw		t6,C_T6*4(sp)
	lw		t7,C_T7*4(sp)
	lw		t8,C_T8*4(sp)
	lw		t9,C_T9*4(sp)
	lw		s0,C_LO*4(sp)
	mtlo	s0
	lw		s0,C_HI*4(sp)
	mthi	s0
	lw		s0,C_S0*4(sp)
	lw		s1,C_S1*4(sp)
	lw		s2,C_S2*4(sp)
	lw		ra,C_RA*4(sp)
	lw		k0,C_STATUS*4(sp)
	mtc0	k0,C0_STATUS
	lw		k0,C_EPC*4(sp)
	addu	sp,C_IHSIZE*4
#endif

# Application Stack Pointer
	# Swap Between Stack and System Stack Pointer
	la		k1,AppSP
	sw		sp,0(k1)
	la		k1,SysSP
	lw		sp,0(k1)
# System Stack Pointer
/*
	# Store Return Value
	la		s0,Return
	sw		v0,0(s0)
*/
	# Restore Registers
	lw		s0,C_S0*4(sp)
	lw		s1,C_S1*4(sp)
	lw		ra,C_RA*4(sp)
	lw		k0,C_STATUS*4(sp)
	mtc0	k0,C0_STATUS

#ifdef DEBUG
	li		k0,CPU_REGS_BASE_ADDR
	lw		k1,MFIO_DATA_OUT(k0)
	andi	k1,k1,0xFFFE
	sw		k1,MFIO_DATA_OUT(k0)
#endif

	lw		k0,C_EPC*4(sp)
	addu	sp,C_SYSSIZE*4

# System Stack Pointer
	# Swap Between Stack and System Stack Pointer
	la		k1,SysSP
	sw		sp,0(k1)
	la		k1,AppSP
	lw		sp,0(k1)
# Application Stack Pointer

	j		$GL200

# Others
$GL200:
	# Return To Interrupted Program
	.set 	noreorder
	j		k0
	rfe
	.set	reorder
	.set	at
	.end 	GenExcHandle

	.globl	EnableGlobal
	.ent	EnableGlobal
	.set	reorder
EnableGlobal:
	mfc0	s1,C0_STATUS
	ori		s1,s1,1
	mtc0	s1,C0_STATUS
	j		ra
	.end	EnableGlobal

	.globl	DisableGlobal
	.ent	DisableGlobal
	.set	reorder
DisableGlobal:
	mfc0	s0,C0_STATUS
	li		s1,0xFFFFFFFE
	and		s0,s0,s1
	mtc0	s0,C0_STATUS
	j		ra
	.end	DisableGlobal
/*
 	.globl	RunApp
	.ent	RunApp
	.set	reorder
RunApp:
	subu	sp, 10*4
	sw		$4, 7*4(sp)
	sw		ra, 6*4(sp)
	li		$4, 0x10000000
	jal		$4
	nop
	lw		$4, 7*4(sp)
	lw		ra, 6*4(sp)
	addu	sp, 10*4
	j		ra
	.end	RunApp
*/
 	.globl	RunISR
	.ent	RunISR
/*
RunISR:
	subu	sp, 10*4
	sw		$4, 8*4(sp)
	sw		$5, 7*4(sp)
	sw		ra, 6*4(sp)
	li		$5, 0x30000000
	add		$4, $4, $5
	jal		$4
	nop
	lw		$4, 8*4(sp)
	lw		$5, 7*4(sp)
	lw		ra, 6*4(sp)
	addu	sp, 10*4
	j		ra
	.end	RunISR
*/
RunISR:
	subu	sp, 10*4
	sw		$4, 9*4(sp)
	sw		$5, 8*4(sp)
	sw		$6,	7*4(sp)
	sw		ra, 6*4(sp)
	li		$6, 0x30000000
	add		$5, $5, $6
	jal		$5
	nop
	lw		$4, 9*4(sp)
	lw		$5, 8*4(sp)
	lw		$6, 7*4(sp)
	lw		ra, 6*4(sp)
	addu	sp, 10*4
	j		ra
	.end	RunISR


	.globl	GetRA
	.ent	GetRA
GetRA:
	subu	sp, 10*4
	sw		$4, 7*4(sp)
	sw		ra, 6*4(sp)
	addu	$4, $2, 0
	jal		PrintRA
	nop
	lw		$4, 7*4(sp)
	lw		ra, 6*4(sp)
	addu	sp, 10*4
	j		ra
	.end	GetRA

#Set Software Interrupt Bit 0
	.globl	IntSetSW0
	.ent	IntSetSW0
IntSetSW0:
	mfc0	$8, $13
	ori		$8, $8, 0x0100
	mtc0	$8, $13
	j		ra
	.end	IntSetSW0

#Set Software Interrupt Bit 1
	.globl	IntSetSW1
	.ent	IntSetSW1
IntSetSW1:
	mfc0	$8, $13
	ori		$8, $8, 0x0200
	mtc0	$8, $13
	j		ra
	.end	IntSetSW1

#Clear Software Interrupt Bit 0
	.globl	IntClrSW0
	.ent	IntClrSW0
IntClrSW0:
	mfc0	$8, $13
	li		$9, 0xFFFFFEFF
	and		$8, $8, $9
	mtc0	$8, $13
	j		ra
	.end	IntClrSW0

#Clear Software Interrupt Bit 1
	.globl	IntClrSW1
	.ent	IntClrSW1
IntClrSW1:
	mfc0	$8, $13
	li		$9, 0xFFFFFDFF
	and		$8, $8, $9
	mtc0	$8, $13
	j		ra
	.end	IntClrSW1

 	.globl	ReduceFreq
	.ent	ReduceFreq
ReduceFreq:
	subu	sp, 10*4
	sw		$4, 5*4(sp)
	sw		ra, 4*4(sp)
	mfc0	$8, $3
	li		$9, 0xFFFFF3FF
	add		$8, $8, $9
	addiu	$4, $4, 0x3
	sll		$4, $4, 10
	or		$8, $8, $4
	mtc0	$8, $3
	j		ra
	.end	ReduceFreq

	.globl	SaveTmpSP
	.ent	SaveTmpSP
SaveTmpSP:
	la		$8, TmpSP
	sw		sp, 0($8)
	la		$8, TmpSysSP
	la		$9,	SysSP
	lw		$10, 0($9)
	sw		$10, 0($8)
	la		$8, TmpAppSP
	la		$9,	AppSP
	lw		$10, 0($9)
	sw		$10, 0($8)
	.globl	RestoreTmpSP
RestoreTmpSP:
	la		$8, TmpSP
	sw		sp, 0($8)
	la		$8, TmpSysSP
	la		$9,	SysSP
	lw		$10, 0($9)
	sw		$10, 0($8)
	la		$8, TmpAppSP
	la		$9,	AppSP
	lw		$10, 0($9)
	sw		$10, 0($8)
	la		$8, SaveTmpSPBack
	j		$8
	.end	SaveTmpSP
