/*
================================ COPYRIGHT ================================
The contents of this file are subject to the VTech Informations Ltd. License
of VT-OS Ver. 1.1 operating system (the "License"); you may not use this 
file except in compliance with the License.  
 
Software distributed under the License is distributed on an "AS IS" basis, 
WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License 
for the specific language governing rights and limitations under the License.
 
The Original Code is VT-OS Ver. 1.1 Operating System, released 
on October 1st, 1999

The Initial Developer of the Original Code is VTech Informations Ltd.  All 
codes are Copyright (C) VTech Informations Ltd. 1999.  All Rights Reserved.
===========================================================================
*/

/*
===========================================================================
File        :   welcome.c
Author(s)   :   Henry Fok, Thomas Cheng
Company     :   VTech Informations Ltd.
Project     :   Helio 
Date:	    :   October 1st, 1999
Purpose:	:   welcome screen and low battery screen
Revision    :   1.1
Note        :   None
===========================================================================
*/              



#include "include\pr31700s.h"
#include "include\pr31700c.h"
#include "include\intc.h"
#include "include\uart.h"
#include "include\print.h"
#include "include\tmrapi.h"
#include "include\msg.h"
#include "include\eventmgr.h"
#include "include\mmu.h"
#include "include\alaunch.h"
#include "include\ttp.h"
#include "include\lcdapi.h"
#include "include\dev_pwr.h"

//#define DEBUG

extern EvtQueueType evtQueue;
extern MsgQueueType	msgQueue;

UWORD lowbattmr, weltmr;

const UWORD lowbat[500] = {
0x0fffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
0xffffffff, 0xff0f0000, 0x30000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00cf0000, 0xcaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaabf0000, 0xcaa00000, 0x0002aaaa,
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaabf0000,
0xca855555, 0x5557a8a8, 0xa8aaaaaa, 0x8aaaaaaa, 0xa80aaa8a, 0x8aaaaaaa, 0xa2aaaaaa, 0xaaaaaaaa,
0xaaaaaaaa, 0xaabf0000, 0xca855540, 0x5557a8a8, 0xa8aaaaaa, 0xaaaaaaaa, 0xa8a2aa8a, 0x8aaaaaaa,
0xa2aaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaabf0000, 0xcaa15547, 0x555ea8a8, 0xa8828882, 0x882a2aaa,
0xa8a20a02, 0x028a2222, 0xa2aa2888, 0xaaaaaaaa, 0xaaaaaaaa, 0xaabf0000, 0xcaa15547, 0x555eaa22,
0x22a88288, 0x88888a80, 0xa80aa28a, 0x8a220a22, 0xa2a88888, 0xaaaaaaaa, 0xaaaaaaaa, 0xaabf0000,
0xcaa85547, 0x557aaa22, 0x22808a88, 0x88888aaa, 0xa8a2028a, 0x8a022a22, 0xa2a88888, 0xaaaaaaaa,
0xaaaaaaaa, 0xaabf0000, 0xcaa85547, 0x557aaa8a, 0x8a888a88, 0x888a0aaa, 0xa8a2228a, 0x8a2a2a82,
0xa2a88a22, 0xaaaaaaaa, 0xaaaaaaaa, 0xaabf0000, 0xcaaa1547, 0x55eaaa8a, 0x8a808a88, 0x888a8aaa,
0xa80a02a2, 0xa2822aa2, 0xa00a2a22, 0xaaaaaaaa, 0xaaaaaaaa, 0xaabf0000, 0xcaaa1547, 0x55eaaaaa,
0xaaaaaaaa, 0xaaa82aaa, 0xaaaaaaaa, 0xaaaaaa0a, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaabf0000,
0xcaaa857f, 0x57aaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaaaa, 0xaabf0000, 0xcaaa8555, 0x57aaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaabf0000, 0xcaaaa143, 0x5eaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaabf0000, 0xcaaaa147, 0x5eaaaaaa,
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaabf0000, 
0xcaaaa87f, 0x7aaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaaaa, 0xaabf0000, 0xcaaaa855, 0x7aaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaabf0000, 0xcaaaaa15, 0xeaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaabf0000, 0xcaaaaa15, 0xeaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaabf0000, 
0xcaaaaa87, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaabf0000, 0xcaaaaa8f, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaabf0000, 0xcaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaabf0000, 0xcaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaabf0000, 
0xcaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaabf0000, 0xcbffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 
0xffffffff, 0xffffffff, 0xffffffff, 0xe2bf0000, 0xcb000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x22bf0000, 0xcb000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x22bf0000, 
0xcb000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x22bf0000, 0xcb000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x22bf0000, 0xcb000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x22bf0000, 0xcb000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x22bf0000,
0xcb000000, 0x00000000, 0x00000000, 0xc0000000, 0x3f000303, 0x00000000, 0xccc00000, 0x00000000, 
0x00000000, 0x22bf0000, 0xcb000000, 0x00000000, 0x00000000, 0xc0000000, 0x30c00303, 0x00000000,
0xccc00000, 0x00000000, 0x00000000, 0x22bf0000, 0xcb000000, 0x00000000, 0x00000000, 0xc00c3330,
0x30cf0fcf, 0xc30cccc0, 0xccc00000, 0x00000000, 0x00000000, 0x22bf0000, 0xcb000000, 0x00000000, 
0x00000000, 0xc0333330, 0x3f00c303, 0x0ccf0cc0, 0xccc00000, 0x00000000, 0x00000000, 0x22bf0000,
0xcb000000, 0x00000000, 0x00000000, 0xc0333330, 0x30cfc303, 0x0fcc0cc0, 0xccc00000, 0x00000000, 
0x00000000, 0x22bf0000, 0xcb000000, 0x00000000, 0x00000000, 0xc0330cc0, 0x30ccc303, 0x0c0c03c0, 
0x00000000, 0x00000000, 0x00000000, 0x22bf0000, 0xcb000000, 0x00000000, 0x00000000, 0xff0c0cc0, 
0x3f0fc0c0, 0xc3cc00c0, 0xccc00000, 0x00000000, 0x00000000, 0x22bf0000, 0xcb000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000f00, 0x00000000, 0x00000000, 0x00000000, 0x22bf0000, 
0xcb000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x22bf0000, 0xcb000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x22bf0000, 0xcb000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x22bf0000, 0xcb000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x22bf0000,
0xcb000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x22bf0000, 0xcbaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xa2bf0000, 0xc8000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x02bf0000, 0xcaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaabf0000,
0x3aaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaacf0000, 0x0fffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
0xffffffff, 0xffffffff, 0xffffffff, 0xff0f0000, };

const UWORD welcome[3200] = { /* 00043200 */
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00055555, 0x55555555, 0x55555555, 0x55000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000555, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x05555555,
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55550000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x55555550, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00555555, 0x55555555,
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55500000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x55555555, 0x55555000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000555, 0x55555555, 0x55555555,
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555550, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00055555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x55555555, 0x55555555, 0x55000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x55555555, 0x55555555, 0x55555555,
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55550000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000005, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x55555555, 0x55555555, 0x55555500, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000555, 0x55555555, 0x55555555, 0x55555555,
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00055555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x55555555, 0x55555555, 0x55000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00555555, 0x55555555, 0x55555555, 0x55555555,
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55500000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x55555555, 0x55555555, 0x55555000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000005, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555500, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000555, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00005555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x50000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00555555, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55000000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x05555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x55550000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000055, 
0x55555550, 0x00005555, 0x55555555, 0x55555550, 0x00005555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000055, 0x55555550, 0x00005555, 0x55555555, 0x55555550, 
0x00005555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x55555500, 0x00000000, 0x00000000, 0x00000000, 0x00000eee, 0xee000000, 0x0000eee0, 0x00000055, 
0x555eeee0, 0x00005555, 0x55555555, 0x555eeee0, 0x00005555, 0x55555555, 0x55555555, 0x55555555,
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555550, 0x00000000, 0x00000000, 0x00000000, 
0x00000eee, 0xee000000, 0x0000eee0, 0x00000005, 0x555eeee0, 0x00005555, 0x55555555, 0x555eeee0, 
0x00005555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x00000000, 0x00000000, 0x00000000, 0x000000ee, 0xee000000, 0x000eeee0, 0x00000005, 
0x555eee00, 0x00055555, 0x55555555, 0x555eeee0, 0x00005555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x50000000, 0x00000000, 0x00000000, 
0x000000ee, 0xeee00000, 0x005eeee0, 0x00000005, 0x555eee00, 0x00055555, 0x55555555, 0x555eeee0, 
0x00005555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x55555555, 0x55000000, 0x00000000, 0x00000000, 0x000000ee, 0xeee00000, 0x055eee00, 0x00000005, 
0x55eeee00, 0x00055555, 0x55000000, 0x0000eee0, 0x00005555, 0x55555000, 0x00000000, 0x55555550,
0x00000055, 0x55555555, 0x00000000, 0x00000000, 0x00005555, 0x55500000, 0x00000000, 0x00000000,
0x0000000e, 0xeee00000, 0x555eee00, 0x00000000, 0x55eeee00, 0x00555555, 0x00000000, 0x0000eee0, 
0x00005555, 0x55550000, 0x00000000, 0x55555000, 0x00000000, 0x55555555, 0x00000000, 0x00000000,
0x00000055, 0x55550000, 0x00000000, 0x00000000, 0x0000000e, 0xeeee0000, 0x05eeee00, 0x00e00000,
0x55eee000, 0x00555550, 0x00000000, 0x0000eee0, 0x00005555, 0xeee00000, 0x00000000, 0x555e0000, 
0x00000000, 0x0555555e, 0x00000000, 0x00000000, 0x00000005, 0x555ee000, 0x00000000, 0x00000000, 
0x0000000e, 0xeeee0000, 0x05eeee00, 0x00ee0000, 0x55eee000, 0x00555500, 0x00000000, 0x0000eee0,
0x0000555e, 0xee000000, 0x00000000, 0x5ee00000, 0x00000000, 0x0055555e, 0x00000000, 0x00000000, 
0x00000005, 0x5eee0000, 0x00000000, 0x00000000, 0x00000000, 0xeeee0000, 0x05eee000, 0x00ee0000, 
0x0eeee000, 0x00555500, 0x000eeeee, 0xeeeeeee0, 0x000055ee, 0xe0000000, 0xeee55555, 0xeee00000, 
0x0eeee000, 0x0005555e, 0x00000eee, 0xe00000ee, 0xee000005, 0xeeee0000, 0x0eeeeee0, 0x00000000,
0x00000000, 0xeeeee000, 0x00eee000, 0x00ee0000, 0x0eeee000, 0x05555000, 0x00eeeeee, 0xeeeeeee0, 
0x00005eee, 0xe00000ee, 0xeee5555e, 0xee000000, 0xeeeeee00, 0x0005555e, 0x00000eee, 0xe00000ee, 
0xeee00000, 0xeee00000, 0xeeeeeee0, 0x00000000, 0x00000000, 0xeeeee000, 0x00eee000, 0x0eeee000,
0x0eee0000, 0x05555000, 0x00555555, 0x555eeee0, 0x0000eeee, 0xe0000055, 0x5555555e, 0xee000005, 
0x5eeeeee0, 0x0005555e, 0x00000555, 0xe0000055, 0x5ee00000, 0xeee00000, 0x00000000, 0x00000000, 
0x00000000, 0x0eeee000, 0x00eee000, 0x0eeee000, 0x00ee0000, 0x0555e000, 0x00000000, 0x0000eee0,
0x0000eeee, 0xe0000055, 0x555555ee, 0xee000005, 0x55eeeee0, 0x0000555e, 0x00000555, 0xe0000055, 
0x55e00000, 0xeee00000, 0x00000000, 0x00000000, 0x00000000, 0x0eeeee00, 0x000e0000, 0x0eeee000,
0x00ee0000, 0x5555e000, 0x00000000, 0x0000eee0, 0x0000eeee, 0xe0000055, 0x555555ee, 0xee00000a, 
0xaaaeeee0, 0x0000555e, 0x00000555, 0xe0000055, 0x55e00000, 0xeee00000, 0x00000000, 0x00000000, 
0x00000000, 0x0eeeee00, 0x000e0000, 0x0eeeee00, 0x00e00000, 0x5555e000, 0x00000000, 0x0000eee0, 
0x0000eeee, 0xe0000055, 0x555aaaee, 0xee00000a, 0xaaaeeee0, 0x0000aa5e, 0x00000555, 0xe0000055, 
0x55e00000, 0xeee00000, 0x00000000, 0x00000000, 0x00000000, 0x05eeee00, 0x000e0000, 0x5eeeee00,
0x00e00000, 0x5555e000, 0x00000000, 0x0000eee0, 0x0000eeee, 0xe000005a, 0xaaaaaaee, 0xee00000a, 
0xaaaeeee0, 0x0000aaae, 0x00000555, 0xe0000055, 0x55e00000, 0xeee00000, 0x00000000, 0x00000000, 
0x00000000, 0x55eeeee0, 0x000e0000, 0x55eeee00, 0x00000000, 0x5555e000, 0x00eeeeee, 0xeeeeeee0, 
0x0000eeee, 0xe00000aa, 0xaaaaaaee, 0xee00000a, 0xaaaeeee0, 0x000aaaae, 0x00000555, 0xe0000055, 
0x55e00000, 0xeee00000, 0xeeeeeee0, 0x00000000, 0x00000005, 0x55eeeee0, 0x00000000, 0x55eeee00, 
0x00000005, 0x5555ee00, 0x00eeeeee, 0xeeeeeee0, 0x0000eeee, 0xe0000000, 0xaaaaaaee, 0xee000000, 
0xaaaeee00, 0x000aaaae, 0x00000aa5, 0xe0000055, 0x55e00000, 0xeee00000, 0x0eeeeee0, 0x00000000, 
0x00000005, 0x555eeee0, 0x00000000, 0x55eeeee0, 0x00000005, 0x5555ee00, 0x00055555, 0x555eeee0,
0x0000eeee, 0xe0000000, 0xaaaaaaee, 0xeee00000, 0x0aaee000, 0x000aaaae, 0x00000aaa, 0xe0000055, 
0x55e00000, 0xeee00000, 0x05555500, 0x00000000, 0x00000055, 0x555eeeee, 0x00000005, 0x55eeeee0, 
0x00000005, 0x55555ee0, 0x00000000, 0x0000eee0, 0x0000eeee, 0xee000000, 0x00000000, 0xeee00000, 
0x00000000, 0x00aaaaae, 0x00000aaa, 0xe0000055, 0x55e00000, 0xeeee0000, 0x00000000, 0x00000000, 
0x00000555, 0x555eeeee, 0x00000005, 0x555eeee0, 0x00000055, 0x55555ee0, 0x00000000, 0x0000eee0, 
0x0000aeee, 0xeee00000, 0x00000000, 0xeeee0000, 0x00000000, 0x00aaaaae, 0x00000aaa, 0xe0000055, 
0x55e00000, 0xeeee0000, 0x00000000, 0x00000000, 0x00000555, 0x5555eeee, 0x00000005, 0x555eeeee,
0x00000055, 0x555555ee, 0x00000000, 0x0000eee0, 0x0000aeee, 0xeeee0000, 0x00000000, 0xeeeee000, 
0x00000000, 0x0aaaaaae, 0x00000aaa, 0xe00000a5, 0x55e00000, 0xeeeeee00, 0x00000000, 0x00000000, 
0x00005555, 0x5555eeee, 0xe0000005, 0x555eeeee, 0x00000055, 0x555555ee, 0xee000000, 0x0000eee0, 
0x0000aaee, 0xeeeeee00, 0x00000000, 0xeeeeeee0, 0x000000aa, 0xaaaaaaae, 0x00000aaa, 0xe00000aa, 
0xa5e00000, 0xeeeeeeee, 0x00000000, 0x00000000, 0x00005555, 0x5555eeee, 0xeee55555, 0x5555eeee, 
0xee555555, 0x5555555e, 0xeeeeeeee, 0xeeeeeeee, 0xaaaaaaae, 0xeeeeeeee, 0xeeeaaaaa, 0xaeeeeeee, 
0xeeeeeaaa, 0xaaaaaaae, 0xeeeeaaaa, 0xeeeeeaaa, 0xaaeeeee5, 0x5eeeeeee, 0xeeeeee55, 0x50000000, 
0x00055555, 0x55555eee, 0xeee55555, 0x5555eeee, 0xee555555, 0x55555555, 0x5eeeeeee, 0xeeeeeeee, 
0xaaaaaaaa, 0xaeeeeeee, 0xeeeaaaaa, 0xaaaeeeee, 0xeeaaaaaa, 0xaaaaaaae, 0xeeeeaaaa, 0xeeeeeaaa, 
0xaaeeeee5, 0x555eeeee, 0xeeeeee55, 0x50000000, 0x00055555, 0x55555555, 0x55555555, 0x55555555,
0x55555555, 0x55555555, 0x55555555, 0x555aaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaa555, 0x55555555, 0x55555555, 0x55000000, 
0x00555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55aaaaaa,
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaa55, 0x55555555, 0x55555555, 0x55500000, 0x05555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x55555555, 0x55555555, 0x5aaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0x55555555, 0x55555555, 0x55500000, 
0x05555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaaaa, 0xa5555555, 0x55555555, 0x55500000, 0x05555555, 0x55555555, 0x55555555, 0x55555555,
0x55555555, 0x55555555, 0x555555aa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaa555555, 0x55555555, 0x55550000, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555aaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaa55555, 0x55555555, 0x55550000, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x55555555, 0x5555aaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaa5555, 0x55555555, 0x55555000, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x5555aaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaa555, 0x55555555, 0x55555000, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x55555555, 0x555aaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaa55, 0x55555555, 0x55555000, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55aaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaa5, 0x55555555, 0x55555500, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x55555555, 0x55555555, 0x5aaaaa33, 0x333aaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0x55555555, 0x55555500, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0xaaaaa333, 0x3aaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xa5555555, 0x55555500, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x5555555a, 0xaaaaa333, 0x3aaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaa555555, 0x55555500, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x555555aa, 0xaaaa3333, 0xaaccccca, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaa555555, 0x55555550, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x555555aa, 0xaaa33333, 0xacccccaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaa55555, 0x55555550, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555aaa, 0xaaa3333a, 0xaccccaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaa5555, 0x55555550, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x5555aaaa, 0xaa3333aa, 0xccccaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaa5555, 0x55555550, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x5555aaaa, 0xaa3333ac, 0xccccaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaa555, 0x55555550, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x55555555, 0x555aaaaa, 0xa3333aac, 0xcccaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaa55, 0x55555550, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55aaa333, 0x33333333, 0x3333aaaa,
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaee, 0xeeeeeeee, 0xeeeeeeaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaa55, 0x55555550, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x55555555, 0x55aaaaaa, 0x333aaccc, 0xccaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaa5, 0x55555550,
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x5aaaaaa3, 0x333ccccc, 0xcccccccc, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaae, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaa5, 0x55555550, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x55555555, 0x5aaaaa33, 0x33aacccc, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeea, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0x55555550,
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0xaaaaa333, 0x3aacccca, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0x55555550, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0xaaaaa333, 0x3aacccaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xa5555550, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x5555555a, 0xaaaa3333, 0xaaccccaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xa5555550, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x5555555a, 0xaaa33333, 0xaccccaaa, 0xaaaaaa33, 0x333aaaaa, 0xaaaaaaaa, 0xaaaaaaee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaa555550,
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x5555555a, 0xaaa3333a, 0xccccaaaa, 0xaaaa333a, 
0xaa33aaaa, 0xaaaaaaaa, 0xaaaaaeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeea, 0xaaaaaaaa, 0xaaaaaaaa, 0xaa555550, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x555555aa, 0xaa3333aa, 0xccccaaaa, 0xaaa333ac, 0xccc3aaaa, 0xaaaaaaaa, 0xaaaaeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xaaaaaaaa, 0xaaaaaaaa, 0xaa555550,
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x555555aa, 0xa33333ac, 0xcccaaaaa, 0xaa333cca, 
0xaaa3caaa, 0xaaaaaaaa, 0xaaaeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeaaaaaaa, 0xaaaaaaaa, 0xaaa55550, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555aaa, 0x33333acc, 0xccaaaaaa, 0xa333ccaa, 0xaaa3caaa, 0xaaaaaaaa, 0xaaeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeaaaaaa, 0xaaaaaaaa, 0xaaa55550, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555aaa, 0x3333accc, 0xccaaaaaa, 0x333ccaaa, 
0xaa33caaa, 0xaaaaaaaa, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeaaaaa, 0xaaaaaaaa, 0xaaaa5550, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555aa3, 0x3333cccc, 0xcaaaaaa3, 0x33ccaaaa, 0xaa33caaa, 0xaaaaaaaa, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeaaaa, 0xaaaaaaaa, 0xaaaa5550, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x5555aa33, 0x333ccccc, 0xaaaaaa33, 0x33ccaaaa, 
0xaa33caaa, 0xaaaaaaae, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeaaa, 0xaaaaaaaa, 0xaaaaa550, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x5555a3c3, 0x33cacccc, 0xaaaaa333, 0x3ccaaaaa, 0xa333caaa, 0xaaaaaaee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeaa, 0xaaaaaaaa, 0xaaaaa550, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55553c33, 0x33acccca, 0xaaaa3333, 0xccaaaaaa,
0xa33caaaa, 0xaaaaaeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeea, 0xaaaaaaaa, 0xaaaaa550, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x5553c333, 0x3cccccaa, 0xaaa33333, 0xcaaaaaaa, 0xa33caaaa, 0xaaaaeeee, 0xeeeeeeee, 0xeeeeeeee,
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeea, 0xaaaaaaaa, 0xaaaaaa50, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x5553c333, 0xcaccccaa, 0xaa33333c, 0xcaaaaaaa,
0x33ccaaaa, 0xaaaaeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xaaaaaaaa, 0xaaaaaa50, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x553c3333, 0xaccccaaa, 0xaa33333c, 0xaaaaaaa3, 0x3ccaaa3a, 0xaaaeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xaaaaaaaa, 0xaaaaaa50, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x53ca333a, 0xccccaaa3, 0xa33333cc, 0xaaaaaaa3,
0x3caaa3ac, 0xaaaeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeaaaaaaa, 0xaaaaaa50, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x5c53333a, 0xccccaa3a, 0xaa3333ca, 0xaaaaaa33, 0xccaa3aca, 0xaaeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeaaaaaaa, 0xaaaaaa50, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x555333ac, 0xcccaa3aa, 0xaa333cca, 0xaaaaa33c, 
0xcaa3acaa, 0xaaeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeaaaaaa, 0xaaaaaa50, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55333aac, 0xccaa33aa, 0xa3333caa, 0xaaaaa33c, 0xa33acaaa, 0xaeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeaaaaa, 0xaaaaaa50, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55333acc, 0xcca33aaa, 0xa333ccaa, 0xaaaa3333, 
0x3accaaaa, 0xaeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee,
0xeeeeeeee, 0xeeeeeeee, 0xeeeaaaaa, 0xaaaaaa50, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x5333aacc, 0xca33aaaa, 0xc333caaa, 0xaaa33ccc, 0xccaaaaaa, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0x00000000, 0x00000000, 0x00000000, 0x00000eee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeaaaaa, 0xaaaaaa50,
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x5333accc, 0xa33aaaac, 0xa333caaa, 0xaa33ccaa,
0xaaaaaaaa, 0xeeeeeeee, 0xeeeeeeee, 0xe0000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 
0x000eeeee, 0xeeeeeeee, 0xeeeeaaaa, 0xaaaaaa50, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x533aaccc, 0x33aaaaca, 0xa333caaa, 0xa33ccaaa, 0xaaaaaaaa, 0xeeeeeeee, 0xeeeee000, 0x00000000, 
0x00eeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xee000000, 0x00000000, 0xeeeeeeee, 0xeeeeaaaa, 0xaaaaaa50, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x533aacc3, 0x3aaaacaa, 0xa333caaa, 0x3accaaaa, 
0xaaaaaaae, 0xeeeeeeee, 0xee000000, 0x0000eeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xee000000, 0x000eeeee, 0xeeeeaaaa, 0xaaaaaa50, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x53aaac33, 0xaaaacaaa, 0xaa33ca33, 0xacaaaaaa, 0xaaaaaaae, 0xeeeeeee0, 0x00000000, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeee000, 0x00000eee, 0xeeeeeaaa, 0xaaaaaa50, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x533aa3aa, 0xaaccaaaa, 0xaaa333ac, 0xcaaaaaaa, 
0xaaaaaaae, 0xeeeee000, 0x0000000e, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeee0, 0x0000000e, 0xeeeeeaaa, 0xaaaaaa50, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55333cca, 0xaccaaaaa, 0xaaaaccca, 0xaaaaaaaa, 0xaaaaaaee, 0xeeee0000, 0x00000000, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeee000, 0x00000000, 0x0eeeeaaa, 0xaaaaaa50, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55aaaacc, 0xcaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaee, 0xee000000, 0x00000000, 0x0000eeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xee000000, 0x00000000, 0x00eeeaaa, 0xaaaaaa50, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x55aaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaee, 0xe0000000, 0x00000000, 0x00000000, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeee000, 0x00000000, 0x00000000, 0x000eeeaa, 0xaaaaaa50,
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55aaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaaee, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x0000eeaa, 0xaaaaaa50, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x55aaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaee, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x0000eeaa, 0xaaaaaa50, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55aaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaaee, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x0000eeaa, 0xaaaaaa50, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55aaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaee, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x0000eeaa, 0xaaaaaa50, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55aaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaee, 0xe0000000, 0x00000000, 0x00000000, 0x00eeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xee000000, 
0x00000000, 0x00000000, 0x000eeeaa, 0xaaaaaa50, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x555aaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaee, 0xee000000, 0x00000000, 0x000eeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xee000000, 0x00000000, 0x000eeeaa, 0xaaaaaa50, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x555aaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaee, 0xeee00000, 0x0000000e, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeee00, 0x00000000, 0x0eeeeeaa, 0xaaaaaa50, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x555aaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaee, 0xeeee0000, 0x000000ee, 0xeeeeeeee,
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeee0, 0x00000000, 0xeeeeeeaa, 0xaaaaaa50, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x555aaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaee, 0xeeeeee00, 0x0000000e, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee,
0xeeeeee00, 0x000000ee, 0xeeeeeeaa, 0xaaaaaa50, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x555aaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaee, 0xeeeeeeee, 0x00000000, 0x000eeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xee000000, 0x000eeeee, 0xeeeeeeaa, 0xaaaaaa50, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x5555aaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaee, 0xeeeeeeee, 0xeee00000, 0x00000000, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeee000, 
0x00000000, 0xeeeeeeee, 0xeeeeeeaa, 0xaaaaa550, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x5555aaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaee, 0xeeeeeeee, 0xeeeeeeee, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000eee, 0xeeeeeeee, 0xeeeeeeaa, 0xaaaaa550, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x5555aaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeee000, 0x00000000, 0x00000000, 0x00000000, 0x0000000e, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeaa, 0xaaaaa550, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x5555aaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeee000, 0x00000000, 0x00000000, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeaaa, 0xaaaa5550, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555aaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeaaa, 0xaaaa5550, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555aaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaae, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeaaa, 0xaaaa5550,
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555aaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaaae, 0xeee000ee, 0x000eeeee, 0xeeeee000, 0x000eeeee, 0xeeee000e, 0xeeeeeeee, 0xeee0000e, 
0xeeeeeeee, 0xeee000ee, 0xeeeeeaaa, 0xaaa55550, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x55555aaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaae, 0xeee000ee, 0x000eeeee, 0xeeeee000, 
0x000eeeee, 0xeeee000e, 0xeeeeeeee, 0xeee0000e, 0xeeeeeeee, 0xe0000000, 0xeeeeaaaa, 0xaaa55500, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x555555aa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaae, 0xeee000ee, 0x000eeeee, 0xeeeee000, 0xeeeeeeee, 0xeeee000e, 0xeeeeeeee, 0xeee0000e, 
0xeeeeeeee, 0x000eee00, 0x0eeeaaaa, 0xaaa55500, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x555555aa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xeee00000, 0x000eeeee, 0xeeeee000, 
0x00eeeeee, 0xeeee000e, 0xeeeeeeee, 0xeee0000e, 0xeeeeeeee, 0x000eee00, 0x0eeeaaaa, 0xaa555500, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x555555aa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaaaa, 0xeee000ee, 0x000eeeee, 0xeeeee000, 0xeeeeeeee, 0xeeee000e, 0xeeeeeeee, 0xeee0000e, 
0xeeeeeeee, 0x000eee00, 0x0eeaaaaa, 0xaa555000, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x5555555a, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaee000ee, 0x000eeeee, 0xeeeee000, 
0x000eeeee, 0xeeee0000, 0x00eeeeee, 0xeee0000e, 0xeeeeeeee, 0xe0000000, 0xeeeaaaaa, 0xaa555000, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x5555555a, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaee000ee, 0x000eeeee, 0xeeeee000, 0x000eeeee, 0xeeee0000, 0x00eeeeee, 0xeee0000e, 
0xeeeeeeee, 0xeee000ee, 0xeeaaaaaa, 0xa5555000, 0x55555555, 0x55555555, 0x55555555, 0x55555555,
0x55555555, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeaaaaaa, 0xa5550000, 
0x05555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaaaa, 0xaaeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeaaaaaa, 0x55550000, 0x05555555, 0x55555555, 0x55555555, 0x55555555,
0x55555555, 0x5aaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaeeeee, 0xeeeeeeee, 0xeeeeeeee,
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeaaaaaaa, 0x55500000, 
0x00555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x5aaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xaaaaaaa5, 0x55500000, 0x00555555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x55aaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xaaaaaaa5, 0x55000000, 
0x00055555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55aaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeea, 0xaaaaaa55, 0x55000000, 0x00055555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x555aaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeea, 0xaaaaa555, 0x50000000, 
0x00005555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x5555aaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeaa, 0xaaaaa555, 0x50000000, 0x00000555, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x5555aaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaae, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeaaa, 0xaaaa5555, 0x00000000, 
0x00000555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555aaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xaaaaaaaa, 0xaaaaaaaa, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee,
0xeeeeeeee, 0xeeeeaaaa, 0xaaaa5550, 0x00000000, 0x00000055, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x555555aa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xeeeeeeee, 0xeeeeeeee,
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeaaaaa, 0xaaa55550, 0x00000000,
0x00000055, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x555555aa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeaaaaaa, 0xaa555500, 0x00000000, 0x00000005, 0x55555555, 0x55555555, 0x55555555, 
0x55555555, 0x5555555a, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaeeeeee, 0xeeeeeeee,
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeaaaaaaa, 0xa5555000, 0x00000000, 
0x00000000, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeee, 0xaaaaaaaa, 0x55555000, 0x00000000, 0x00000000, 0x05555555, 0x55555555, 0x55555555,
0x55555555, 0x55555555, 0x5aaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaeee, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeea, 0xaaaaaaaa, 0x55550000, 0x00000000, 
0x00000000, 0x05555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55aaaaaa, 0xaaaaaaaa,
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeeeeaa, 0xaaaaaaa5, 0x55500000, 0x00000000, 0x00000000, 0x00555555, 0x55555555, 0x55555555,
0x55555555, 0x55555555, 0x55aaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaae, 0xeeeeeeee, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeaaaa, 0xaaaaaa55, 0x55500000, 0x00000000, 
0x00000000, 0x00555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x555aaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 
0xeeeaaaaa, 0xaaaaa555, 0x55000000, 0x00000000, 0x00000000, 0x00055555, 0x55555555, 0x55555555,
0x55555555, 0x55555555, 0x5555aaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaeeeee,
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeaaaaaaa, 0xaaaa5555, 0x50000000, 0x00000000, 
0x00000000, 0x00005555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x555555aa, 0xaaaaaaaa,
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeea, 
0xaaaaaaaa, 0xaaa55555, 0x00000000, 0x00000000, 0x00000000, 0x00000555, 0x55555555, 0x55555555,
0x55555555, 0x55555555, 0x5555555a, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaae, 
0xeeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeeeeaaa, 0xaaaaaaaa, 0xaa555550, 0x00000000, 0x00000000, 
0x00000000, 0x00000055, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaeeeeeee, 0xeeeeeeee, 0xeeeeeeee, 0xeeaaaaaa, 
0xaaaaaaaa, 0xa5555550, 0x00000000, 0x00000000, 0x00000000, 0x00000005, 0x55555555, 0x55555555, 
0x55555555, 0x55555555, 0x55555555, 0x5aaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaeee, 0xeeeeeeee, 0xeeeeeeaa, 0xaaaaaaaa, 0xaaaaaaaa, 0x55555500, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55aaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xeeeeeeee, 0xeeeeaaaa, 0xaaaaaaaa, 
0xaaaaaaa5, 0x55555000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x05555555, 0x55555555, 
0x55555555, 0x55555555, 0x55555555, 0x5555aaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaa555, 0x55550000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555aaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaa5555, 0x55500000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00055555, 0x55555555,
0x55555555, 0x55555555, 0x55555555, 0x555555aa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaa555555, 0x50000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00005555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa,
0xa5555555, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000555, 0x55555555, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55aaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaa5, 0x55555550, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000055, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x555aaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaa555, 
0x55555500, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000005, 0x55555555, 
0x55555555, 0x55555555, 0x55555555, 0x55555555, 0x55555aaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 
0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaa5555, 0x55555000, 0x00000000, 0x00000000, 0x00000000, 
0x00000000, 0x00000000, 0x00000000, 0x05555555, 0x55555555, 0x55555555, 0x55555555, 0x55555555, 
0x5555555a, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaaaaaaaa, 0xaa555555, 
0x55550000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 0x00000000,
};


void WelscrTmr()
{
	TmrIntDisable(weltmr);
	EvtAppendEvt(0, 0, 0, 0, NULL);
}

BOOLEAN Welscr()
{
	BitmapTemplate 		bitmap;
	BOOLEAN				system_battery_empty = FALSE;
	EvtType 			event;

    bitmap.xcoord = 0;
	bitmap.ycoord = 0;
	bitmap.width = 160;
	bitmap.height = 160;
	bitmap.quantisation = 4;

    (const *)bitmap.bitmap_data = welcome;
 	LcdDrawBitmap(&bitmap, COLOR_NO_INVERT);

	MsgQueueCreate(&msgQueue);
	EvtQueueCreate(&evtQueue);

	weltmr = TmrIntEnable(5000, WelscrTmr);

    do
    {
    	if (CheckBatteryEmpty() == 1)
		{
			system_battery_empty = TRUE;
    		break;	
		}

    	EvtGetEvent(&event);
    	
    	if ((event.eventType == POWER_EVENT && event.eventID == BAT_MAIN_EMPTY) ||
    		(event.eventType == POWER_EVENT && event.eventID == BAT_DOOR_OPEN))
    	{
    		system_battery_empty = TRUE;
    		break;    		
    	}   	
#ifdef DEBUG
		printf("\n Welcome - Event = %ld %ld %ld %ld", event.eventType, event.eventID, event.para1, event.para2);
#endif		    	
	}while(event.eventType == POWER_EVENT);    	

	MsgQueueCreate(&msgQueue);
	EvtQueueCreate(&evtQueue);

	TmrIntDisable(weltmr);		
	if (system_battery_empty)
	{
#ifdef DEBUG
		printf("\n Low Bat Screen return FALSE");		
#endif		
		return FALSE;
	}		
	else
	{
#ifdef DEBUG
		printf("\n Low Bat Screen return TRUE");		
#endif			
		return TRUE;		
	}		
}

void LowbatscrTmr()
{
	TmrIntDisable(lowbattmr);
#ifdef DEBUG
	printf("\n Low Bat TimeOut");
#endif		
	EvtAppendEvt(0, 0, 0, 0, NULL);
}

BOOLEAN Lowbatscr()
{
	BitmapTemplate 		bitmap;
	BOOLEAN				system_battery_empty = FALSE;
	EvtType 			event;

    bitmap.xcoord = 5;
	bitmap.ycoord = 47;
	bitmap.width = 150;
	bitmap.height = 50;
	bitmap.quantisation = 2;

    (const *)bitmap.bitmap_data = lowbat;
 	LcdDrawBitmap(&bitmap, COLOR_NO_INVERT);

	MsgQueueCreate(&msgQueue);
	EvtQueueCreate(&evtQueue);

	lowbattmr = TmrIntEnable(5000, LowbatscrTmr);

    do
    {
    	if (CheckBatteryEmpty() == 1)
		{
#ifdef DEBUG
			printf("\n system_battery_empty = TRUE");
#endif						
			system_battery_empty = TRUE;
    		break;	
		}

    	EvtGetEvent(&event);
    	
    	if ((event.eventType == POWER_EVENT && event.eventID == BAT_MAIN_EMPTY) ||
    		(event.eventType == POWER_EVENT && event.eventID == BAT_DOOR_OPEN))
    	{
    		system_battery_empty = TRUE;
    		break;    		
    	}   	
#ifdef DEBUG
		printf("\n LowBatScr - Event = %ld %ld %ld %ld", event.eventType, event.eventID, event.para1, event.para2);
#endif	
    	
	}while(event.eventType == POWER_EVENT);    		


	TmrIntDisable(lowbattmr);
	
#ifdef DEBUG
	printf("\n Quit LowBat Screen - Battery Empty = %ld", system_battery_empty);
#endif	


	
	if (system_battery_empty)
		return FALSE;
	else return TRUE;			
}
